-- MetaViews.sql

-- $Header $
--
-- This file adds views to the Object database same named views 
-- in the Meta database.

USE Meta
GO

SET NOCOUNT ON
GO


IF EXISTS (SELECT * FROM sysobjects WHERE name = 'DefineMetaViews' AND type = 'P')
  DROP PROCEDURE DefineMetaViews
GO

CREATE PROCEDURE DefineMetaViews
  @dbname sysname
AS
  EXEC("
  USE " + @dbname + "

  DECLARE viewc CURSOR FOR
    SELECT name FROM Meta..sysobjects WHERE type = 'V' AND category = 0
    ORDER BY name
  OPEN viewc
  DECLARE @view sysname
  FETCH NEXT FROM viewc INTO @view
  WHILE @@fetch_status <> -1
  BEGIN
    RAISERROR('Creating view %s', 0, 1, @view)
    IF EXISTS (SELECT * FROM sysobjects WHERE name = @view and type = 'V' and category=0)
      EXEC('DROP VIEW ' + @view)
    EXEC(' CREATE VIEW ' + @view + ' AS SELECT * FROM Meta..' + @view)
    FETCH NEXT FROM viewc INTO @view
  end
  DEALLOCATE viewc

  PRINT 'Creating view custom_update_proc'
  IF EXISTS (SELECT * FROM sysobjects WHERE name = 'custom_update_proc' and type = 'V')
    DROP VIEW custom_update_proc

  EXEC('CREATE VIEW custom_update_proc AS SELECT * FROM Meta..custom_update_proc')

  PRINT 'Creating view custom_view_ddl'
  IF EXISTS (SELECT * FROM sysobjects WHERE name = 'custom_view_ddl' and type = 'V')
    DROP VIEW custom_view_ddl

  EXEC('CREATE VIEW custom_view_ddl AS SELECT * FROM Meta..custom_view_ddl')

  PRINT 'Creating view derived_obj_link'
  IF EXISTS (SELECT * FROM sysobjects WHERE name = 'derived_obj_link' and type = 'V')
    DROP VIEW derived_obj_link

  EXEC('CREATE VIEW derived_obj_link AS SELECT * FROM Meta..derived_obj_link')

  ")
  PRINT 'Done'
GO

EXEC DefineMetaViews Object
