-- $Header:   //ARCHIVE/Archive/DB/SQL/Process_SA390_OPCException.sqv   1.0   Feb 04 2001 18:49:26   BRENT  $
--
-- Process_SA390_OPCException.sql

USE Object
GO

---------------------------------------------------------------------------------------------------
-- Process_SA390_OPCException
PRINT 'Creating procedure Process_SA390_OPCException'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'Process_SA390_OPCException' AND type = 'P')
  DROP PROCEDURE Process_SA390_OPCException
GO

-- $Archive:   //ARCHIVE/Archive/DB/SQL/Process_SA390_OPCException.sqv  $
-- $Revision:   1.0  $
-- $Date:   Feb 04 2001 18:49:26  $
-- $Author:   BRENT  $
-- Creates an exception on a resource managed by OPC.
--
CREATE PROCEDURE Process_SA390_OPCException
  @SourceCID          ClassID,
  @SourceID           ObjID,
  @FormatType         SMALLINT,
  @ActionType         SMALLINT,
  @DATE_TIME          VARCHAR(30) = NULL,
  @SEQ_NO             VARCHAR(50) = NULL,
  @OBJ_TYPE_ID        VARCHAR(4) = NULL,
  @OBJECT_NAME        VARCHAR(8) = NULL,
  @NATIVE_KEY         VARCHAR(10) = NULL,
  @SMFID              VARCHAR(4) = NULL,
  @RESOURCE_TYPE      VARCHAR(8) = NULL,
  @EVENT_TYPE         VARCHAR(255) = NULL,
  @EVENT_STATE        VARCHAR(16) = NULL,
  @APPID              VARCHAR(16) = NULL,
  @IA                 VARCHAR(16) = NULL,
  @WKSTNID            VARCHAR(4) = NULL,
  @EVENT_TEXT         VARCHAR(255) = NULL
AS
  DECLARE @r INT, @datetime DATETIME

  EXEC asisp_convertMVSDateTime @DATE_TIME, @datetime OUTPUT

  SELECT @APPID = RTRIM(@APPID), @OBJECT_NAME = RTRIM(@OBJECT_NAME)

  INSERT StagedOPCEvent(src_cid, src_id, TIME, SEQ_NO, MESSAGE, APPID, WKSTNID, JOBNAME, IA, MESSAGE_TEXT)
    SELECT @SourceCID, @SourceID, @datetime, @SEQ_NO, @EVENT_TYPE, @APPID, @WKSTNID, @OBJECT_NAME, @IA, @EVENT_TEXT
GO
