# $Header:   //ARCHIVE/Archive/DB/SQL/SNA/SNAbcps.ksv   1.0   Jan 02 2001 16:40:56   BRENT  $

# SNAbcps.ksh

# Script to do bulk table copies of SNA tables

Usage()
{
  print "USAGE:"
  print "  SNAbcps.ksh options... "
  print "  The options are:"
  print "    -E               Use trusted connection (instead of -U and -P)"
  print "    -U<user>         User name for the database login"
  print "    -P<password>     Password for the database login"
  print "    -S<server>       Database server"
}


while getopts EU:S:P: c; do
  case $c in
  E)  trusted_opt=-T;;
  U)  user_opt=-U"$OPTARG";;
  P)  password_opt=-P"$OPTARG";;
  S)  server_opt=-S"$OPTARG";;
  *)  Usage; exit;;
  esac
done

if [ -z "$user_opt" -o -z "$password_opt" ]; then
  if [ -z "$trusted_opt" ]; then
    Usage >&2
    exit 1
  fi
fi

for bcp in *.bcp; do
  table=$(echo $bcp | sed 's/.bcp//')
  bcp RODMLoad..$table in $bcp $user_opt $password_opt $server_opt $trusted_opt -t"|" -c -b1000
done
