-- $Header:   P:/Archive/DB/SQL/SNAPostDBGen.sqv   1.2   Dec 04 2000 12:45:18   BRENT  $
--
-- SNAPostDBGen.sql
--
-- SQL to be run after object classes in SNANetwork.sqi have been applied to a system
-- via dbgen. Defines the icons for the classes using the SNA Topology Manager names


----------------------------------------------------------------------------------------------------
-- SetSNAIcons
PRINT 'Creating procedure SetSNAIcons'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'SetSNAIcons' AND type = 'P')
  DROP PROCEDURE SetSNAIcons
GO

-- Sets the icons for the SNA resources to BLOB's whose names derive from the
-- SNA Topology Manager icon names
CREATE PROCEDURE SetSNAIcons
AS
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION SetSNAIcons
  ELSE
    SAVE TRANSACTION SetSNAIcons

  SET NOCOUNT ON

  IF NOT EXISTS (SELECT * FROM BLOB_ID)
    INSERT BLOB_ID(last_id) SELECT 0

  CREATE TABLE #subtype ( colname sysname, subtype VARCHAR(16) )
  INSERT #subtype SELECT '_LargeIconName', 'LARGE'
  INSERT #subtype SELECT '_LargeDeletedIconName', 'LARGE_DELETED'
  INSERT #subtype SELECT '_SmallIconName', 'SMALL'
  INSERT #subtype SELECT '_SmallDeletedIconName', 'SMALL_DELETED'

  DECLARE cc INSENSITIVE CURSOR FOR
    SELECT oc.cname + '_S', cr.IconName
    FROM obj_class AS oc
      JOIN SNAClassDefModel AS cdm ON cdm.cid = oc.cid
      JOIN SNADisplayResourceType AS drt ON drt.Class = cdm.Class AND drt.Role = cdm.Role
      JOIN SNAIconCrossRef AS cr ON cr.DisplayResourceType = drt.Value
    ORDER BY oc.cname
  OPEN cc
  DECLARE @table sysname, @IconName VARCHAR(8)
  FETCH NEXT FROM cc INTO @table, @IconName
  WHILE @@FETCH_STATUS <> -1
  BEGIN
    DECLARE tc CURSOR FOR SELECT colname, subtype FROM #subtype
    OPEN tc
    DECLARE @colname sysname, @SubType VARCHAR(16)
    FETCH NEXT FROM tc INTO @colname, @SubType
    WHILE @@FETCH_STATUS <> -1
    BEGIN
      IF NOT EXISTS (SELECT * FROM BLOB_V WHERE name = @IconName AND _Type = 'BMP' AND _SubType = @SubType)
      BEGIN
        DECLARE @blob_id ObjID
        EXEC @blob_id = asisp_createBLOB @IconName, @Type = 'BMP', @SubType = @SubType
        IF @blob_id < 0
        BEGIN
          DEALLOCATE tc
          DEALLOCATE cc
          ROLLBACK TRANSACTION SetSNAIcons
          RETURN -30000
        END
        UPDATE BLOB_A SET _Data = 0x0 WHERE id = @blob_id
        IF @@ERROR <> 0
        BEGIN
          DEALLOCATE tc
          DEALLOCATE cc
          ROLLBACK TRANSACTION SetSNAIcons
          RETURN -30000
        END
      END
      DECLARE @sql VARCHAR(255)
      SELECT @sql = "SET NOCOUNT OFF UPDATE " + @table + " SET " + @colname + " = CAST(b.id AS VARCHAR) FROM BLOB_V AS b WHERE b.name = '" + @IconName + "' AND _Type = 'BMP' AND _SubType = '" + @SubType + "' AND " + @colname + " <> CAST(b.id AS VARCHAR)"
      PRINT @sql
      EXEC(@sql)
      FETCH NEXT FROM tc INTO @colname, @SubType
    END
    DEALLOCATE tc
    FETCH NEXT FROM cc INTO @table, @IconName
  END
  DEALLOCATE cc

  IF @tcount = 0
    COMMIT TRANSACTION SetSNAIcons
GO


EXEC SetSNAIcons
GO

DROP PROCEDURE SetSNAIcons
GO
