-- $Header:   P:/Archive/DB/SQL/additional_link_tables.sqv   1.0   Dec 08 2000 11:14:04   BRENT  $
--
-- additional_link_tables.sql
--
-- Temporary file for defining link tables that should be defined by dbgen.
-- Must make necessary changes to SNANetwork.sqi to generated these.

use Object

-------------------------------------------------------------------------------------------------------

-- Table NNDN_NNDM_MAGC from src_cid=NNDN, dst_cid=NNDM, link_type=MAGC
if not exists (select * from sysobjects where name = 'NNDN_NNDM_MAGC' and type = 'U')
begin
  print 'Creating table NNDN_NNDM_MAGC'
  exec("
  create table NNDN_NNDM_MAGC
  (
    src_id       ObjID    CONSTRAINT NNDN_NNDM_MAGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
    dst_id       ObjID,
    ctime        datetime CONSTRAINT NNDN_NNDM_MAGC_ctime_DF DEFAULT getdate(),
    deleted      tinyint  CONSTRAINT NNDN_NNDM_MAGC_deleted_DF DEFAULT 0
  )
  ")
  exec("
  grant insert on NNDN_NNDM_MAGC to public
  grant delete on NNDN_NNDM_MAGC to public
  grant select on NNDN_NNDM_MAGC to public
  grant update on NNDN_NNDM_MAGC to public
  ")
end
go

print 'Creating triggers for NNDN_NNDM_MAGC'
go

PRINT 'Creating trigger tI_NNDN_NNDM_MAGC'
go

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated insert trigger for NNDN_NNDM_MAGC table
create trigger tI_NNDN_NNDM_MAGC on NNDN_NNDM_MAGC for INSERT as
  declare @rc int, @src_id ObjID, @dst_id ObjID
  select @rc=@@rowcount
  insert link(link_type, src_cid, src_id, dst_cid, dst_id)
    select 'MAGC', 'NNDN', src_id, 'NNDM', dst_id from inserted
go

PRINT 'Creating trigger tD_NNDN_NNDM_MAGC'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated delete trigger for NNDN_NNDM_MAGC table
CREATE TRIGGER tD_NNDN_NNDM_MAGC ON NNDN_NNDM_MAGC FOR DELETE AS
  -- Delete link records
  DELETE c
    FROM link AS c
    JOIN deleted AS d ON c.link_type = 'MAGC' AND c.src_cid = 'NNDN' AND c.src_id = d.src_id AND c.dst_cid = 'NNDM' AND c.dst_id = d.dst_id
GO

PRINT 'Creating trigger tU_NNDN_NNDM_MAGC'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated update trigger for NNDN_NNDM_MAGC table
CREATE TRIGGER tU_NNDN_NNDM_MAGC ON NNDN_NNDM_MAGC FOR UPDATE AS
  IF UPDATE(deleted)
  BEGIN
    -- Update the deleted flag in link table
    UPDATE c SET deleted = i.deleted
      FROM link AS c
      JOIN deleted AS d ON c.link_type = 'MAGC' AND c.src_cid = 'NNDN' AND c.src_id = d.src_id AND c.dst_cid = 'NNDM' AND c.dst_id = d.dst_id
      JOIN inserted AS i ON i.src_id = d.src_id AND i.dst_id = d.dst_id
      WHERE c.deleted <> i.deleted
  END
GO

-------------------------------------------------------------------------------------------------------

-- Table NNDC_NNDN_MAGC from src_cid=NNDC, dst_cid=NNDN, link_type=MAGC
if not exists (select * from sysobjects where name = 'NNDC_NNDN_MAGC' and type = 'U')
begin
  print 'Creating table NNDC_NNDN_MAGC'
  exec("
  create table NNDC_NNDN_MAGC
  (
    src_id       ObjID    CONSTRAINT NNDC_NNDN_MAGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
    dst_id       ObjID,
    ctime        datetime CONSTRAINT NNDC_NNDN_MAGC_ctime_DF DEFAULT getdate(),
    deleted      tinyint  CONSTRAINT NNDC_NNDN_MAGC_deleted_DF DEFAULT 0
  )
  ")
  exec("
  grant insert on NNDC_NNDN_MAGC to public
  grant delete on NNDC_NNDN_MAGC to public
  grant select on NNDC_NNDN_MAGC to public
  grant update on NNDC_NNDN_MAGC to public
  ")
end
go

print 'Creating triggers for NNDC_NNDN_MAGC'
go

PRINT 'Creating trigger tI_NNDC_NNDN_MAGC'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated insert trigger for NNDC_NNDN_MAGC table
create trigger tI_NNDC_NNDN_MAGC on NNDC_NNDN_MAGC for INSERT as
  declare @rc int, @src_id ObjID, @dst_id ObjID
  select @rc=@@rowcount
  insert link(link_type, src_cid, src_id, dst_cid, dst_id)
    select 'MAGC', 'NNDC', src_id, 'NNDN', dst_id from inserted
go

PRINT 'Creating trigger tD_NNDC_NNDN_MAGC'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated delete trigger for NNDC_NNDN_MAGC table
CREATE TRIGGER tD_NNDC_NNDN_MAGC ON NNDC_NNDN_MAGC FOR DELETE AS
  -- Delete link records
  DELETE c
    FROM link AS c
    JOIN deleted AS d ON c.link_type = 'MAGC' AND c.src_cid = 'NNDC' AND c.src_id = d.src_id AND c.dst_cid = 'NNDN' AND c.dst_id = d.dst_id
GO

PRINT 'Creating trigger tU_NNDC_NNDN_MAGC'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated update trigger for NNDC_NNDN_MAGC table
CREATE TRIGGER tU_NNDC_NNDN_MAGC ON NNDC_NNDN_MAGC FOR UPDATE AS
  IF UPDATE(deleted)
  BEGIN
    -- Update the deleted flag in link table
    UPDATE c SET deleted = i.deleted
      FROM link AS c
      JOIN deleted AS d ON c.link_type = 'MAGC' AND c.src_cid = 'NNDC' AND c.src_id = d.src_id AND c.dst_cid = 'NNDN' AND c.dst_id = d.dst_id
      JOIN inserted AS i ON i.src_id = d.src_id AND i.dst_id = d.dst_id
      WHERE c.deleted <> i.deleted
  END
GO

-------------------------------------------------------------------------------------------------------

-- Table NNDN_NNDM_MMBR from src_cid=NNDN, dst_cid=NNDM, link_type=MMBR
if not exists (select * from sysobjects where name = 'NNDN_NNDM_MMBR' and type = 'U')
begin
  print 'Creating table NNDN_NNDM_MMBR'
  exec("
  create table NNDN_NNDM_MMBR
  (
    src_id       ObjID    CONSTRAINT NNDN_NNDM_MMBR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
    dst_id       ObjID,
    ctime        datetime CONSTRAINT NNDN_NNDM_MMBR_ctime_DF DEFAULT getdate(),
    deleted      tinyint  CONSTRAINT NNDN_NNDM_MMBR_deleted_DF DEFAULT 0
  )
  ")
  exec("
  grant insert on NNDN_NNDM_MMBR to public
  grant delete on NNDN_NNDM_MMBR to public
  grant select on NNDN_NNDM_MMBR to public
  grant update on NNDN_NNDM_MMBR to public
  ")
end
go

print 'Creating triggers for NNDN_NNDM_MMBR'
go

PRINT 'Creating trigger tI_NNDN_NNDM_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated insert trigger for NNDN_NNDM_MMBR table
create trigger tI_NNDN_NNDM_MMBR on NNDN_NNDM_MMBR for INSERT as
  declare @rc int, @src_id ObjID, @dst_id ObjID
  select @rc=@@rowcount
  insert link(link_type, src_cid, src_id, dst_cid, dst_id)
    select 'MMBR', 'NNDN', src_id, 'NNDM', dst_id from inserted
go

PRINT 'Creating trigger tD_NNDN_NNDM_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated delete trigger for NNDN_NNDM_MMBR table
CREATE TRIGGER tD_NNDN_NNDM_MMBR ON NNDN_NNDM_MMBR FOR DELETE AS
  -- Delete link records
  DELETE c
    FROM link AS c
    JOIN deleted AS d ON c.link_type = 'MMBR' AND c.src_cid = 'NNDN' AND c.src_id = d.src_id AND c.dst_cid = 'NNDM' AND c.dst_id = d.dst_id
GO

PRINT 'Creating trigger tU_NNDN_NNDM_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated update trigger for NNDN_NNDM_MMBR table
CREATE TRIGGER tU_NNDN_NNDM_MMBR ON NNDN_NNDM_MMBR FOR UPDATE AS
  IF UPDATE(deleted)
  BEGIN
    -- Update the deleted flag in link table
    UPDATE c SET deleted = i.deleted
      FROM link AS c
      JOIN deleted AS d ON c.link_type = 'MMBR' AND c.src_cid = 'NNDN' AND c.src_id = d.src_id AND c.dst_cid = 'NNDM' AND c.dst_id = d.dst_id
      JOIN inserted AS i ON i.src_id = d.src_id AND i.dst_id = d.dst_id
      WHERE c.deleted <> i.deleted
  END
GO

-------------------------------------------------------------------------------------------------------

-- Table NNDC_NNDN_MMBR from src_cid=NNDC, dst_cid=NNDN, link_type=MMBR
if not exists (select * from sysobjects where name = 'NNDC_NNDN_MMBR' and type = 'U')
begin
  print 'Creating table NNDC_NNDN_MMBR'
  exec("
  create table NNDC_NNDN_MMBR
  (
    src_id       ObjID    CONSTRAINT NNDC_NNDN_MMBR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
    dst_id       ObjID,
    ctime        datetime CONSTRAINT NNDC_NNDN_MMBR_ctime_DF DEFAULT getdate(),
    deleted      tinyint  CONSTRAINT NNDC_NNDN_MMBR_deleted_DF DEFAULT 0
  )
  ")
  exec("
  grant insert on NNDC_NNDN_MMBR to public
  grant delete on NNDC_NNDN_MMBR to public
  grant select on NNDC_NNDN_MMBR to public
  grant update on NNDC_NNDN_MMBR to public
  ")
end
go

print 'Creating triggers for NNDC_NNDN_MMBR'
go

PRINT 'Creating trigger tI_NNDC_NNDN_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated insert trigger for NNDC_NNDN_MMBR table
create trigger tI_NNDC_NNDN_MMBR on NNDC_NNDN_MMBR for INSERT as
  declare @rc int, @src_id ObjID, @dst_id ObjID
  select @rc=@@rowcount
  insert link(link_type, src_cid, src_id, dst_cid, dst_id)
    select 'MMBR', 'NNDC', src_id, 'NNDN', dst_id from inserted
go

PRINT 'Creating trigger tD_NNDC_NNDN_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated delete trigger for NNDC_NNDN_MMBR table
CREATE TRIGGER tD_NNDC_NNDN_MMBR ON NNDC_NNDN_MMBR FOR DELETE AS
  -- Delete link records
  DELETE c
    FROM link AS c
    JOIN deleted AS d ON c.link_type = 'MMBR' AND c.src_cid = 'NNDC' AND c.src_id = d.src_id AND c.dst_cid = 'NNDN' AND c.dst_id = d.dst_id
GO

PRINT 'Creating trigger tU_NNDC_NNDN_MMBR'
GO

-- $Archive:   P:/Archive/DB/SQL/additional_link_tables.sqv  $
-- $Revision:   1.0  $
-- $Date:   Dec 08 2000 11:14:04  $
-- $Author:   BRENT  $
-- Automatically generated update trigger for NNDC_NNDN_MMBR table
CREATE TRIGGER tU_NNDC_NNDN_MMBR ON NNDC_NNDN_MMBR FOR UPDATE AS
  IF UPDATE(deleted)
  BEGIN
    -- Update the deleted flag in link table
    UPDATE c SET deleted = i.deleted
      FROM link AS c
      JOIN deleted AS d ON c.link_type = 'MMBR' AND c.src_cid = 'NNDC' AND c.src_id = d.src_id AND c.dst_cid = 'NNDN' AND c.dst_id = d.dst_id
      JOIN inserted AS i ON i.src_id = d.src_id AND i.dst_id = d.dst_id
      WHERE c.deleted <> i.deleted
  END
GO

-------------------------------------------------------------------------------------------------------

