-- $Header:   //ARCHIVE/Archive/DB/sql/asisp_notifyChildEvent.sqv   1.0   Feb 02 2001 19:54:32   BRENT  $
--
-- asisp_notifyChildEvent.sql

USE Object
GO

---------------------------------------------------------------------------------------------------
-- asisp_notifyChildEvent
PRINT 'Creating procedure asisp_notifyChildEvent'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_notifyChildEvent' AND type = 'P')
  DROP PROCEDURE asisp_notifyChildEvent
GO

-- $Archive:   //ARCHIVE/Archive/DB/sql/asisp_notifyChildEvent.sqv  $
-- $Revision:   1.0  $
-- $Date:   Feb 02 2001 19:54:32  $
-- $Author:   BRENT  $
-- Inserts a PendingEvent record for a ChildEvent
CREATE PROCEDURE asisp_notifyChildEvent
  @type           INT,
  @parent_cno     SMALLINT,
  @parent_id      ObjID,
  @chev_id        ObjID,
  @ChildCID       ClassID,
  @ChildID        ObjID,
  @EventCID       ClassID,
  @EventDetail    VARCHAR(255),
  @EventCount     INT,
  @Direction      SMALLINT,
  @AlertState     INT,
  @Priority       INT,
  @NumOwned       INT,
  @nCHVH          INT
AS
--  PRINT 'asisp_notifyChildEvent: ' + CONVERT(VARCHAR(40), GETDATE(), 113) + ': start'
  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@trancount
  IF @tcount = 0
    BEGIN TRANSACTION asisp_notifyChildEvent
  ELSE
    SAVE TRANSACTION asisp_notifyChildEvent
  
  -- Encode fields into string
  DECLARE @fields VARCHAR(255)
  SELECT @fields =
    CONVERT(VARCHAR(5), ISNULL(@parent_cno, 0))  + '|' +
    CONVERT(VARCHAR(9), ISNULL(@parent_id, 0))   + '|' +
    CONVERT(VARCHAR(9), ISNULL(@chev_id, 0))     + '|' +
    @ChildCID                                    + '|' +
    CONVERT(VARCHAR(9), ISNULL(@ChildID, 0))     + '|' +
    @EventCID                                    + '|' +
    CONVERT(VARCHAR(9), ISNULL(@EventCount, 0))  + '|' +
    CONVERT(VARCHAR(9), ISNULL(@Direction, 0))   + '|' +
    CONVERT(VARCHAR(9), ISNULL(@AlertState, 0))  + '|' +
    CONVERT(VARCHAR(9), ISNULL(@Priority, 0))    + '|' +
    CONVERT(VARCHAR(9), ISNULL(@NumOwned, 0))    + '|' +
    CONVERT(VARCHAR(9), ISNULL(@nCHVH, 0))
  
  INSERT INTO PendingEvent(type, fields, detail, cid, id)
    SELECT @type, @fields, @EventDetail, oc.cid, @parent_id
    FROM obj_class AS oc
    WHERE cno = @parent_cno
  IF @@rowcount <> 1
  BEGIN
    RAISERROR('asisp_notifyChildEvent: failed to add row to PendingEvent', 11, 1)
    ROLLBACK TRANSACTION asisp_notifyChildEvent
    RETURN -30000
  END

  IF @tcount = 0
    COMMIT TRANSACTION asisp_notifyChildEvent
--  PRINT 'asisp_notifyChildEvent: ' + CONVERT(VARCHAR(40), GETDATE(), 113) + ': finish'
go
