-- $Header:   //ARCHIVE/Archive/DB/sql/QueryLinkChain.sqv   1.0   Jan 31 2001 16:42:10   BRENT  $
--
-- QueryLinkChain.sqi
--
-- Defines the QueryLinkChain method
-- $Header:   //ARCHIVE/Archive/DB/sql/BusinessObject.sqv   1.87   Feb 04 2001 12:30:54   BRENT  $
USE Object
GO
SET NOCOUNT ON
GO
IF NOT EXISTS (SELECT * FROM tempdb..sysobjects WHERE type = 'U' AND name = '##MetaDatabaseVersion')
BEGIN
  EXEC("
  CREATE TABLE ##MetaDatabaseVersion ( verno INT )
  ")
END
GO
TRUNCATE TABLE ##MetaDatabaseVersion
INSERT INTO ##MetaDatabaseVersion SELECT verno FROM Meta..DatabaseVersion
GO


  

-- BEGIN_METHOD(NAME=QueryLinkChain, DESCRIPTION='Returns the subset of rows from the link_chain table that match a specified SQL where-clause', LABEL='Query Link Chain')
  IF NOT EXISTS (SELECT * FROM method WHERE mname = 'QueryLinkChain')
  BEGIN
    PRINT 'Defining method QueryLinkChain'
    INSERT INTO method(mid, mname, description, label)
      SELECT
        MAX(mid)+1,
        'QueryLinkChain',
        'Returns the subset of rows from the link_chain table that match a specified SQL where-clause',
        'Query Link Chain'
      FROM method
      WHERE mid < 0x40000000
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  ELSE
  BEGIN
    UPDATE method SET
      description = 'Returns the subset of rows from the link_chain table that match a specified SQL where-clause',
      label = 'Query Link Chain'
    WHERE
      mname = 'QueryLinkChain'
      AND
      (
        description <> 'Returns the subset of rows from the link_chain table that match a specified SQL where-clause'
        OR
        label <> 'Query Link Chain'
      )
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END

  BEGIN /* METHOD_PARAM(NAME=WhereClause, TYPE=ASIVARIANT, DESCRIPTION='WHERE clause specifying rows to return. Columns in the link chain table are:
  cid		Class id of object
  generation	generation of link (1=parent, 2=grandparent, etc.)
  src_cid	Parent object class
  dst_cid	Child object class', LABEL='WHERE Clause') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'QueryLinkChain' and pname = 'WhereClause')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'WhereClause', 'ASIVARIANT', 'WHERE clause specifying rows to return. Columns in the link chain table are:
  cid		Class id of object
  generation	generation of link (1=parent, 2=grandparent, etc.)
  src_cid	Parent object class
  dst_cid	Child object class', 'WHERE Clause'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'QueryLinkChain'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'ASIVARIANT', mp.description = 'WHERE clause specifying rows to return. Columns in the link chain table are:
  cid		Class id of object
  generation	generation of link (1=parent, 2=grandparent, etc.)
  src_cid	Parent object class
  dst_cid	Child object class', mp.label = 'WHERE Clause'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'WhereClause' AND m.mname = 'QueryLinkChain'
        AND (mp.ptype <> 'ASIVARIANT' OR mp.description <> 'WHERE clause specifying rows to return. Columns in the link chain table are:
  cid		Class id of object
  generation	generation of link (1=parent, 2=grandparent, etc.)
  src_cid	Parent object class
  dst_cid	Child object class' OR mp.label <> 'WHERE Clause')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=WhereClause)
    -- METHOD_PARAM_FLAG(FLAG=input)
    UPDATE mp SET flag_input = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'QueryLinkChain' AND mp.pname = 'WhereClause' AND flag_input = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  BEGIN /* METHOD_PARAM(NAME=MatchingRows, TYPE=ASIRESULTSET, DESCRIPTION='Table of link_chain rows matching the specified WHERE clause', LABEL='Matching Rows') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'QueryLinkChain' and pname = 'MatchingRows')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'MatchingRows', 'ASIRESULTSET', 'Table of link_chain rows matching the specified WHERE clause', 'Matching Rows'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'QueryLinkChain'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'ASIRESULTSET', mp.description = 'Table of link_chain rows matching the specified WHERE clause', mp.label = 'Matching Rows'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'MatchingRows' AND m.mname = 'QueryLinkChain'
        AND (mp.ptype <> 'ASIRESULTSET' OR mp.description <> 'Table of link_chain rows matching the specified WHERE clause' OR mp.label <> 'Matching Rows')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=MatchingRows)
    -- METHOD_PARAM_FLAG(FLAG=collection)
    UPDATE mp SET flag_collection = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'QueryLinkChain' AND mp.pname = 'MatchingRows' AND flag_collection = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    -- METHOD_PARAM_FLAG(FLAG=output)
    UPDATE mp SET flag_output = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'QueryLinkChain' AND mp.pname = 'MatchingRows' AND flag_output = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  -- METHOD_CALLER(CID=BASE)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'BASE' and mname = 'QueryLinkChain'
  )
  begin
    insert obj_method(cid, mid) select 'BASE', mid from method where mname = 'QueryLinkChain'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

-- END_METHOD(NAME=QueryLinkChain)

---------------------------------------------------------------------------------------------------
-- _QueryLinkChain
PRINT 'Creating procedure _QueryLinkChain'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_QueryLinkChain' AND type = 'P')
  DROP PROCEDURE _QueryLinkChain
GO

-- $Archive:   //ARCHIVE/Archive/DB/sql/QueryLinkChain.sqv  $
-- $Date:   Jan 31 2001 16:42:10  $
-- $Author:   BRENT  $
-- $Revision:   1.0  $
CREATE PROCEDURE _QueryLinkChain
  @cid          ClassID = NULL,
  @id           ObjID = NULL,
  @WhereClause  VARCHAR(500) = NULL
AS
  IF DATALENGTH(@WhereClause) > 0 AND UPPER(SUBSTRING(@WhereClause, 1, 5)) <> 'WHERE'
    SET @WhereClause = 'WHERE ' + @WhereClause
  EXEC("
  SELECT * FROM link_chain " + @WhereClause
  )
GO
