-- $Header:   //ARCHIVE/Archive/DB/sql/SNANetwork.sqv   1.27   Feb 14 2001 12:26:40   BRENT  $

-- SNANetwork.sqi
-- Classes for SNA/APPN networking

-- $Header:   //ARCHIVE/Archive/DB/sql/BusinessObject.sqv   1.93   Feb 13 2001 08:09:14   BRENT  $
USE Object
GO
SET NOCOUNT ON
GO
IF NOT EXISTS (SELECT * FROM tempdb..sysobjects WHERE type = 'U' AND name = '##MetaDatabaseVersion')
BEGIN
  EXEC("
  CREATE TABLE ##MetaDatabaseVersion ( verno INT )
  ")
END
GO
TRUNCATE TABLE ##MetaDatabaseVersion
INSERT INTO ##MetaDatabaseVersion SELECT verno FROM Meta..DatabaseVersion
GO


  








---------------------------------------------------------------------------------------------------
-- Enumeration for the RegistrationStatus attribute of the objects.
-- BEGIN_ENUMERATION(NAME=RODMRegistrationStatus, LABEL='RODM Registration Status', DESCRIPTION='RODM Registration Status')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMRegistrationStatus')
  begin
    insert enumeration(name, label, description) select 'RODMRegistrationStatus', 'RODM Registration Status', 'RODM Registration Status'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMRegistrationStatus'
  if not exists (select * from sysobjects where name = 'RODMRegistrationStatus_E' and type = 'U')
  begin
    print 'Creating table RODMRegistrationStatus_E'
    exec("
    create table RODMRegistrationStatus_E
    (
      eid   int,
      value int   CONSTRAINT RODMRegistrationStatus_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
    
  -- ENUM_VALUE(NAME=Unregistered, VALUE=0, LABEL='Unregistered', DESCRIPTION='Unregistered', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Unregistered')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Unregistered', 0, 'Unregistered', 'Unregistered',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationStatus_E where value = 0)
    insert RODMRegistrationStatus_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=Registered, VALUE=1, LABEL='Registered', DESCRIPTION='Registered', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Registered')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Registered', 1, 'Registered', 'Registered',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationStatus_E where value = 1)
    insert RODMRegistrationStatus_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMRegistrationStatus)
  if @@trancount = 1
    commit transaction create_enumeration
go

---------------------------------------------------------------------------------------------------
-- Enumerations for RODMRegister method

-- BEGIN_ENUMERATION(NAME=RODMRegistrationSelection, LABEL='RODM Registration Selection', DESCRIPTION='Specifies type of registration.')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMRegistrationSelection')
  begin
    insert enumeration(name, label, description) select 'RODMRegistrationSelection', 'RODM Registration Selection', 'Specifies type of registration.'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMRegistrationSelection'
  if not exists (select * from sysobjects where name = 'RODMRegistrationSelection_E' and type = 'U')
  begin
    print 'Creating table RODMRegistrationSelection_E'
    exec("
    create table RODMRegistrationSelection_E
    (
      eid   int,
      value int   CONSTRAINT RODMRegistrationSelection_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
    
  -- ENUM_VALUE(NAME=Unregister, VALUE=0, LABEL='Unregister', DESCRIPTION='Unregister so that object(s) so will no longer be monitored', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Unregister')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Unregister', 0, 'Unregister', 'Unregister so that object(s) so will no longer be monitored',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationSelection_E where value = 0)
    insert RODMRegistrationSelection_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=Register, VALUE=1, LABEL='Register', DESCRIPTION='Register so that object(s) will be monitored', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Register')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Register', 1, 'Register', 'Register so that object(s) will be monitored',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationSelection_E where value = 1)
    insert RODMRegistrationSelection_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=Reregister, VALUE=2, LABEL='Reregister', DESCRIPTION='Reregister the object(s). This resends the current Registration Status of the object(s).', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Reregister')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Reregister', 2, 'Reregister', 'Reregister the object(s). This resends the current Registration Status of the object(s).',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationSelection_E where value = 2)
    insert RODMRegistrationSelection_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMRegistrationSelection)
  if @@trancount = 1
    commit transaction create_enumeration
go

-- BEGIN_ENUMERATION(NAME=RODMRegistrationScope, LABEL='RODM Registration Scope', DESCRIPTION='Controls scope of registration. Registration may be made for the object, it''s children, or both.')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMRegistrationScope')
  begin
    insert enumeration(name, label, description) select 'RODMRegistrationScope', 'RODM Registration Scope', 'Controls scope of registration. Registration may be made for the object, it''s children, or both.'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMRegistrationScope'
  if not exists (select * from sysobjects where name = 'RODMRegistrationScope_E' and type = 'U')
  begin
    print 'Creating table RODMRegistrationScope_E'
    exec("
    create table RODMRegistrationScope_E
    (
      eid   int,
      value int   CONSTRAINT RODMRegistrationScope_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
    
  -- ENUM_VALUE(NAME=This, VALUE=1, LABEL='Only this object', DESCRIPTION='Only this object', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'This')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'This', 1, 'Only this object', 'Only this object',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationScope_E where value = 1)
    insert RODMRegistrationScope_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=Child, VALUE=2, LABEL='Only children of this object', DESCRIPTION='Only children of this object', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Child')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Child', 2, 'Only children of this object', 'Only children of this object',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationScope_E where value = 2)
    insert RODMRegistrationScope_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=ThisAndChild, VALUE=3, LABEL='This object and its children', DESCRIPTION='This object and its children', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'ThisAndChild')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'ThisAndChild', 3, 'This object and its children', 'This object and its children',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMRegistrationScope_E where value = 3)
    insert RODMRegistrationScope_E(eid, value) select " + @eid_str + ", 3
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMRegistrationScope)
  if @@trancount = 1
    commit transaction create_enumeration
go

-- BEGIN_ENUMERATION(NAME=RODMResponseType, LABEL='RODM Response Type', DESCRIPTION='Type of response requested from registration command. Normally, only exception responses should be required. Request definite responses when diagnosing network communication problems.')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMResponseType')
  begin
    insert enumeration(name, label, description) select 'RODMResponseType', 'RODM Response Type', 'Type of response requested from registration command. Normally, only exception responses should be required. Request definite responses when diagnosing network communication problems.'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMResponseType'
  if not exists (select * from sysobjects where name = 'RODMResponseType_E' and type = 'U')
  begin
    print 'Creating table RODMResponseType_E'
    exec("
    create table RODMResponseType_E
    (
      eid   int,
      value int   CONSTRAINT RODMResponseType_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
    
  -- ENUM_VALUE(NAME=OFF, VALUE=0, LABEL='Off', DESCRIPTION='No response', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'OFF')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'OFF', 0, 'Off', 'No response',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMResponseType_E where value = 0)
    insert RODMResponseType_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=EX, VALUE=1, LABEL='Exceptions', DESCRIPTION='Send response for errors only', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'EX')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'EX', 1, 'Exceptions', 'Send response for errors only',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMResponseType_E where value = 1)
    insert RODMResponseType_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

    
  -- ENUM_VALUE(NAME=DEF, VALUE=2, LABEL='Definite', DESCRIPTION='Always send response', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'DEF')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'DEF', 2, 'Definite', 'Always send response',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMResponseType_E where value = 2)
    insert RODMResponseType_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMResponseType)
  if @@trancount = 1
    commit transaction create_enumeration
go

---------------------------------------------------------------------------------------------------
/* OBJECT_CLASS(CID=RDMO, CNAME=RODMManagedObject, LABEL='RODMManagedObject', DESCRIPTION='Object class managed by RODM') */

  if not exists (select * from link_type where link_type='RDMO')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'RDMO', 'RODMManagedObject Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='RDMO')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'RDMO', 'RODMManagedObject', 'RODMManagedObject', 'Object class managed by RODM'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'RDMO') <> 'RODMManagedObject'
    begin
      raiserror('Error defining class RDMO. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'RODMManagedObject', description = 'Object class managed by RODM'
      where cid = 'RDMO' and (label <> 'RODMManagedObject' or description <> 'Object class managed by RODM')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=RDMO, BASE_CID=MNO2)
  if not exists (select * from isa where cid = 'RDMO' and base_cid = 'MNO2')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'RDMO', 'MNO2',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'RDMO' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1



update obj_class set flag_abstract=1 where cid = 'RDMO' and flag_abstract<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1

  -- OBJ_ATTRIBUTE(NAME=RODMClass, TYPE=ASIString, LENGTH=60, DEFAULT='NULL', RULE=NULL, DESCRIPTION='RODM Class Name', LABEL='RODM Class')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='RODMClass')
  begin
    exec insert_obj_attr 'RDMO', 'RODMClass', 'ASIString', 60, 'NULL', NULL, 'RODM Class Name', 'RODM Class'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=RODMMyName, TYPE=ASIString, LENGTH=255, DEFAULT='NULL', RULE=NULL, DESCRIPTION='RODM Instance Name (Unique within class)', LABEL='RODM MyName Field')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='RODMMyName')
  begin
    exec insert_obj_attr 'RDMO', 'RODMMyName', 'ASIString', 255, 'NULL', NULL, 'RODM Instance Name (Unique within class)', 'RODM MyName Field'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=NetworkID, TYPE=ASIString, LENGTH=40, DEFAULT='NULL', RULE=NULL, DESCRIPTION='Name of SNA/APPN network', LABEL='Network ID')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='NetworkID')
  begin
    exec insert_obj_attr 'RDMO', 'NetworkID', 'ASIString', 40, 'NULL', NULL, 'Name of SNA/APPN network', 'Network ID'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=DisplayResourceName, TYPE=ASIString, LENGTH=255, DEFAULT='NULL', RULE=NULL, DESCRIPTION='SNATM DisplayResourceName attribute', LABEL='Display Resource Name')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='DisplayResourceName')
  begin
    exec insert_obj_attr 'RDMO', 'DisplayResourceName', 'ASIString', 255, 'NULL', NULL, 'SNATM DisplayResourceName attribute', 'Display Resource Name'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=RegistrationStatus, TYPE=BYTE, LENGTH=0, DEFAULT='0', RULE=NULL, DESCRIPTION='Indicates whether object is monitored by TBSM', LABEL='Registration Status')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='RegistrationStatus')
  begin
    exec insert_obj_attr 'RDMO', 'RegistrationStatus', 'BYTE', 0, '0', NULL, 'Indicates whether object is monitored by TBSM', 'Registration Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
    -- OBJ_ATTR_RANGE(RegistrationStatus=RegistrationStatus, ENAME=RODMRegistrationStatus)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'RegistrationStatus')
    raiserror('Class RDMO has no attribute names ''RegistrationStatus''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'RegistrationStatus' and i.cid = 'RDMO') > 1
    raiserror('Class RDMO has ambiguous attribute definition for RegistrationStatus', 3, 1)
  else if not exists (select * from enumeration where name = 'RODMRegistrationStatus')
    raiserror('Invalid enumeration: ''RODMRegistrationStatus''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDMO' and a.name = 'RegistrationStatus' and e.name = 'RODMRegistrationStatus'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDMO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDMO' and a.name = 'RegistrationStatus' and e.name = 'RODMRegistrationStatus'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDMO' and a.name = 'RegistrationStatus' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=LatestDiscoveryDate, TYPE=ASISystemTime, LENGTH=0, DEFAULT='NULL', RULE=NULL, DESCRIPTION='RODM Last Discovery Date/Time', LABEL='Latest Discovery Date')
  if not exists (select * from obj_attr where cid = 'RDMO' and name='LatestDiscoveryDate')
  begin
    exec insert_obj_attr 'RDMO', 'LatestDiscoveryDate', 'ASISystemTime', 0, 'NULL', NULL, 'RODM Last Discovery Date/Time', 'Latest Discovery Date'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end


---------------------------------------------------------------------------------------------------
-- BEGIN_ENUMERATION(NAME=RODMOperationalState, LABEL='RODM Operational State', DESCRIPTION='RODM Operational State')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMOperationalState')
  begin
    insert enumeration(name, label, description) select 'RODMOperationalState', 'RODM Operational State', 'RODM Operational State'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMOperationalState'
  if not exists (select * from sysobjects where name = 'RODMOperationalState_E' and type = 'U')
  begin
    print 'Creating table RODMOperationalState_E'
    exec("
    create table RODMOperationalState_E
    (
      eid   int,
      value int   CONSTRAINT RODMOperationalState_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
  
  -- ENUM_VALUE(NAME=Disabled, VALUE=0, LABEL='Disabled', DESCRIPTION='Disabled', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Disabled')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Disabled', 0, 'Disabled', 'Disabled',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMOperationalState_E where value = 0)
    insert RODMOperationalState_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Enabled, VALUE=1, LABEL='Enabled', DESCRIPTION='Enabled', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Enabled')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Enabled', 1, 'Enabled', 'Enabled',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMOperationalState_E where value = 1)
    insert RODMOperationalState_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=NotSet, VALUE=255, LABEL='Is Not Currently Set', DESCRIPTION='Is Not Currently Set', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'NotSet')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'NotSet', 255, 'Is Not Currently Set', 'Is Not Currently Set',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMOperationalState_E where value = 255)
    insert RODMOperationalState_E(eid, value) select " + @eid_str + ", 255
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMOperationalState)
  if @@trancount = 1
    commit transaction create_enumeration
go

-- usage state
-- BEGIN_ENUMERATION(NAME=RODMUsageState, LABEL='RODM Usage State', DESCRIPTION='RODM Usage State')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMUsageState')
  begin
    insert enumeration(name, label, description) select 'RODMUsageState', 'RODM Usage State', 'RODM Usage State'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMUsageState'
  if not exists (select * from sysobjects where name = 'RODMUsageState_E' and type = 'U')
  begin
    print 'Creating table RODMUsageState_E'
    exec("
    create table RODMUsageState_E
    (
      eid   int,
      value int   CONSTRAINT RODMUsageState_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
   
  
  -- ENUM_VALUE(NAME=Idle, VALUE=0, LABEL='Idle', DESCRIPTION='Idle', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Idle')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Idle', 0, 'Idle', 'Idle',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMUsageState_E where value = 0)
    insert RODMUsageState_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Active, VALUE=1, LABEL='Active', DESCRIPTION='Active', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Active')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Active', 1, 'Active', 'Active',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMUsageState_E where value = 1)
    insert RODMUsageState_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Busy, VALUE=2, LABEL='Busy', DESCRIPTION='Busy', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Busy')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Busy', 2, 'Busy', 'Busy',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMUsageState_E where value = 2)
    insert RODMUsageState_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=NotSet, VALUE=255, LABEL='Is Not Currently Set' , DESCRIPTION='Is Not Currently Set', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'NotSet')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'NotSet', 255, 'Is Not Currently Set' , 'Is Not Currently Set',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMUsageState_E where value = 255)
    insert RODMUsageState_E(eid, value) select " + @eid_str + ", 255
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMUsageState)
  if @@trancount = 1
    commit transaction create_enumeration
go

-- administrative state
-- BEGIN_ENUMERATION(NAME=RODMAdministrativeState, LABEL='RODM Administrative State', DESCRIPTION='RODM Administrative State')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMAdministrativeState')
  begin
    insert enumeration(name, label, description) select 'RODMAdministrativeState', 'RODM Administrative State', 'RODM Administrative State'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMAdministrativeState'
  if not exists (select * from sysobjects where name = 'RODMAdministrativeState_E' and type = 'U')
  begin
    print 'Creating table RODMAdministrativeState_E'
    exec("
    create table RODMAdministrativeState_E
    (
      eid   int,
      value int   CONSTRAINT RODMAdministrativeState_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
  
  -- ENUM_VALUE(NAME=Locked, VALUE=0, LABEL='Locked', DESCRIPTION='Locked', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Locked')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Locked', 0, 'Locked', 'Locked',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMAdministrativeState_E where value = 0)
    insert RODMAdministrativeState_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Unlocked, VALUE=1, LABEL='Unlocked', DESCRIPTION='Unlocked', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Unlocked')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Unlocked', 1, 'Unlocked', 'Unlocked',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMAdministrativeState_E where value = 1)
    insert RODMAdministrativeState_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=ShuttingDown, VALUE=2, LABEL='Shutting Down', DESCRIPTION='Shutting Down', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'ShuttingDown')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'ShuttingDown', 2, 'Shutting Down', 'Shutting Down',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMAdministrativeState_E where value = 2)
    insert RODMAdministrativeState_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=NotSet, VALUE=255, LABEL='Is Not Currently Set' , DESCRIPTION='Is Not Currently Set', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'NotSet')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'NotSet', 255, 'Is Not Currently Set' , 'Is Not Currently Set',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMAdministrativeState_E where value = 255)
    insert RODMAdministrativeState_E(eid, value) select " + @eid_str + ", 255
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMAdministrativeState)
  if @@trancount = 1
    commit transaction create_enumeration
go

-- unknown status
-- Use TrueFalse Enumeration

-- native status
-- BEGIN_ENUMERATION(NAME=RODMNativeStatus, LABEL='RODM Native Status' , DESCRIPTION='RODM Native Status')
  if @@trancount = 0
    begin transaction create_enumeration
  else
    save transaction create_enumeration
  declare @eid int, @eid_str varchar(9)
  if not exists (select * from enumeration where name = 'RODMNativeStatus')
  begin
    insert enumeration(name, label, description) select 'RODMNativeStatus', 'RODM Native Status' , 'RODM Native Status'
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  select @eid = eid, @eid_str = convert(varchar(9),eid) from enumeration where name = 'RODMNativeStatus'
  if not exists (select * from sysobjects where name = 'RODMNativeStatus_E' and type = 'U')
  begin
    print 'Creating table RODMNativeStatus_E'
    exec("
    create table RODMNativeStatus_E
    (
      eid   int,
      value int   CONSTRAINT RODMNativeStatus_E_PK PRIMARY KEY (value)
    )
    ")
    if @@error <> 0
      rollback transaction create_enumeration
  end
  
  
  -- ENUM_VALUE(NAME=Active, VALUE=0, LABEL='Active', DESCRIPTION='Active', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Active')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Active', 0, 'Active', 'Active',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 0)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 0
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=ActiveWithSession, VALUE=1, LABEL='Active with Session', DESCRIPTION='Active with Session', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'ActiveWithSession')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'ActiveWithSession', 1, 'Active with Session', 'Active with Session',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 1)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 1
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Inactive, VALUE=2, LABEL='Inactive', DESCRIPTION='Inactive', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Inactive')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Inactive', 2, 'Inactive', 'Inactive',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 2)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 2
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=NeverActive, VALUE=3, LABEL='Never Active', DESCRIPTION='Never Active', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'NeverActive')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'NeverActive', 3, 'Never Active', 'Never Active',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 3)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 3
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=PendingActive, VALUE=4, LABEL='Pending Active', DESCRIPTION='Pending Active', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'PendingActive')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'PendingActive', 4, 'Pending Active', 'Pending Active',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 4)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 4
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=PendingInactive, VALUE=5, LABEL='Pending Inactive', DESCRIPTION='Pending Inactive', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'PendingInactive')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'PendingInactive', 5, 'Pending Inactive', 'Pending Inactive',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 5)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 5
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Connectable, VALUE=6, LABEL='Connectable', DESCRIPTION='Connectable', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Connectable')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Connectable', 6, 'Connectable', 'Connectable',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 6)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 6
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Routable, VALUE=7, LABEL='Routable', DESCRIPTION='Routable', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Routable')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Routable', 7, 'Routable', 'Routable',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 7)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 7
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Operative, VALUE=8, LABEL='Operative', DESCRIPTION='Operative', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Operative')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Operative', 8, 'Operative', 'Operative',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 8)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 8
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Congested, VALUE=9, LABEL='Congested', DESCRIPTION='Congested', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Congested')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Congested', 9, 'Congested', 'Congested',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 9)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 9
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Released, VALUE=10, LABEL='Released', DESCRIPTION='Released', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Released')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Released', 10, 'Released', 'Released',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 10)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 10
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Reset, VALUE=11, LABEL='Reset', DESCRIPTION='Reset', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Reset')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Reset', 11, 'Reset', 'Reset',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 11)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 11
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=Inoperative, VALUE=12, LABEL='Inoperative', DESCRIPTION='Inoperative', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'Inoperative')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'Inoperative', 12, 'Inoperative', 'Inoperative',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 12)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 12
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=PendingActiveOrInactive, VALUE=13, LABEL='Pending Active Or Inactive', DESCRIPTION='Pending Active Or Inactive', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'PendingActiveOrInactive')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'PendingActiveOrInactive', 13, 'Pending Active Or Inactive', 'Pending Active Or Inactive',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 13)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 13
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=ReleasedOrReset, VALUE=14, LABEL='Released Or Reset', DESCRIPTION='Released Or Reset', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'ReleasedOrReset')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'ReleasedOrReset', 14, 'Released Or Reset', 'Released Or Reset',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 14)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 14
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=ForceNativeStatusToFF, VALUE=254, LABEL='Force Native Status To FF', DESCRIPTION='Force Native Status To FF', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'ForceNativeStatusToFF')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'ForceNativeStatusToFF', 254, 'Force Native Status To FF', 'Force Native Status To FF',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 254)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 254
  ")
  if @@error <> 0
    rollback transaction create_enumeration

  
  -- ENUM_VALUE(NAME=IsNotCurrentlySet, VALUE=255, LABEL='Is Not Currently Set', DESCRIPTION='Is Not Currently Set', VALUE_CID=, VALUE_ID=, USER_DATA=, FLAGS=)
  if not exists (select * from enum_value where eid = @eid and name = 'IsNotCurrentlySet')
  begin
    insert enum_value(eid, name, value, label, description, val_cid, val_id, userdata, flags)
      select @eid, 'IsNotCurrentlySet', 255, 'Is Not Currently Set', 'Is Not Currently Set',null, null, null, 0
    if @@rowcount <> 1
      rollback transaction create_enumeration
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  exec("
  if not exists (select * from RODMNativeStatus_E where value = 255)
    insert RODMNativeStatus_E(eid, value) select " + @eid_str + ", 255
  ")
  if @@error <> 0
    rollback transaction create_enumeration

-- END_ENUMERATION(NAME=RODMNativeStatus)
  if @@trancount = 1
    commit transaction create_enumeration
go

---------------------------------------------------------------------------------------------------
/* OBJECT_CLASS(CID=RDSO, CNAME=RODMStatesObject, LABEL='RODMStatesObject', DESCRIPTION='RODM Managed Object that has states field') */

  if not exists (select * from link_type where link_type='RDSO')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'RDSO', 'RODMStatesObject Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='RDSO')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'RDSO', 'RODMStatesObject', 'RODMStatesObject', 'RODM Managed Object that has states field'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'RDSO') <> 'RODMStatesObject'
    begin
      raiserror('Error defining class RDSO. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'RODMStatesObject', description = 'RODM Managed Object that has states field'
      where cid = 'RDSO' and (label <> 'RODMStatesObject' or description <> 'RODM Managed Object that has states field')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=RDSO, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'RDSO' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'RDSO', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'RDSO' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1



update obj_class set flag_abstract=1 where cid = 'RDSO' and flag_abstract<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1

  -- OBJ_ATTRIBUTE(NAME=DisplayStatus, TYPE=LONG, LENGTH=0, DEFAULT='132', RULE=NULL, DESCRIPTION='RODM DisplayStatus attribute', LABEL='Display Status')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='DisplayStatus')
  begin
    exec insert_obj_attr 'RDSO', 'DisplayStatus', 'LONG', 0, '132', NULL, 'RODM DisplayStatus attribute', 'Display Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=operationalState, TYPE=BYTE, LENGTH=0, DEFAULT='255', RULE=NULL, DESCRIPTION='RODM operationalState attribute', LABEL='Operational State')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='operationalState')
  begin
    exec insert_obj_attr 'RDSO', 'operationalState', 'BYTE', 0, '255', NULL, 'RODM operationalState attribute', 'Operational State'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
        -- OBJ_ATTR_RANGE(operationalState=operationalState, ENAME=RODMOperationalState)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'operationalState')
    raiserror('Class RDSO has no attribute names ''operationalState''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'operationalState' and i.cid = 'RDSO') > 1
    raiserror('Class RDSO has ambiguous attribute definition for operationalState', 3, 1)
  else if not exists (select * from enumeration where name = 'RODMOperationalState')
    raiserror('Invalid enumeration: ''RODMOperationalState''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDSO' and a.name = 'operationalState' and e.name = 'RODMOperationalState'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDSO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDSO' and a.name = 'operationalState' and e.name = 'RODMOperationalState'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDSO' and a.name = 'operationalState' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=usageState, TYPE=BYTE, LENGTH=0, DEFAULT='255', RULE=NULL, DESCRIPTION='RODM usageState attribute', LABEL='Usage State')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='usageState')
  begin
    exec insert_obj_attr 'RDSO', 'usageState', 'BYTE', 0, '255', NULL, 'RODM usageState attribute', 'Usage State'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
        -- OBJ_ATTR_RANGE(usageState=usageState, ENAME=RODMUsageState)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'usageState')
    raiserror('Class RDSO has no attribute names ''usageState''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'usageState' and i.cid = 'RDSO') > 1
    raiserror('Class RDSO has ambiguous attribute definition for usageState', 3, 1)
  else if not exists (select * from enumeration where name = 'RODMUsageState')
    raiserror('Invalid enumeration: ''RODMUsageState''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDSO' and a.name = 'usageState' and e.name = 'RODMUsageState'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDSO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDSO' and a.name = 'usageState' and e.name = 'RODMUsageState'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDSO' and a.name = 'usageState' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=administrativeState, TYPE=BYTE, LENGTH=0, DEFAULT='255', RULE=NULL, DESCRIPTION='RODM administrativeState attribute', LABEL='Administrative State')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='administrativeState')
  begin
    exec insert_obj_attr 'RDSO', 'administrativeState', 'BYTE', 0, '255', NULL, 'RODM administrativeState attribute', 'Administrative State'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
        -- OBJ_ATTR_RANGE(administrativeState=administrativeState, ENAME=RODMAdministrativeState)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'administrativeState')
    raiserror('Class RDSO has no attribute names ''administrativeState''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'administrativeState' and i.cid = 'RDSO') > 1
    raiserror('Class RDSO has ambiguous attribute definition for administrativeState', 3, 1)
  else if not exists (select * from enumeration where name = 'RODMAdministrativeState')
    raiserror('Invalid enumeration: ''RODMAdministrativeState''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDSO' and a.name = 'administrativeState' and e.name = 'RODMAdministrativeState'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDSO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDSO' and a.name = 'administrativeState' and e.name = 'RODMAdministrativeState'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDSO' and a.name = 'administrativeState' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=availabilityStatus, TYPE=BYTE, LENGTH=0, DEFAULT='0', RULE=NULL, DESCRIPTION='RODM availabilityStatus attribute', LABEL='Availability Status')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='availabilityStatus')
  begin
    exec insert_obj_attr 'RDSO', 'availabilityStatus', 'BYTE', 0, '0', NULL, 'RODM availabilityStatus attribute', 'Availability Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=proceduralStatus, TYPE=BYTE, LENGTH=0, DEFAULT='0', RULE=NULL, DESCRIPTION='RODM proceduralStatus attribute', LABEL='Procedural Status')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='proceduralStatus')
  begin
    exec insert_obj_attr 'RDSO', 'proceduralStatus', 'BYTE', 0, '0', NULL, 'RODM proceduralStatus attribute', 'Procedural Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=unknownStatus, TYPE=BYTE, LENGTH=0, DEFAULT='1', RULE=NULL, DESCRIPTION='RODM unknownStatus attribute', LABEL='Unknown Status')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='unknownStatus')
  begin
    exec insert_obj_attr 'RDSO', 'unknownStatus', 'BYTE', 0, '1', NULL, 'RODM unknownStatus attribute', 'Unknown Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
        -- OBJ_ATTR_RANGE(unknownStatus=unknownStatus, ENAME=TrueFalse)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'unknownStatus')
    raiserror('Class RDSO has no attribute names ''unknownStatus''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'unknownStatus' and i.cid = 'RDSO') > 1
    raiserror('Class RDSO has ambiguous attribute definition for unknownStatus', 3, 1)
  else if not exists (select * from enumeration where name = 'TrueFalse')
    raiserror('Invalid enumeration: ''TrueFalse''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDSO' and a.name = 'unknownStatus' and e.name = 'TrueFalse'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDSO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDSO' and a.name = 'unknownStatus' and e.name = 'TrueFalse'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDSO' and a.name = 'unknownStatus' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  -- OBJ_ATTRIBUTE(NAME=nativeStatus, TYPE=BYTE, LENGTH=0, DEFAULT='255', RULE=NULL, DESCRIPTION='RODM nativeStatus attribute', LABEL='Native Status')
  if not exists (select * from obj_attr where cid = 'RDSO' and name='nativeStatus')
  begin
    exec insert_obj_attr 'RDSO', 'nativeStatus', 'BYTE', 0, '255', NULL, 'RODM nativeStatus attribute', 'Native Status'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
        -- OBJ_ATTR_RANGE(nativeStatus=nativeStatus, ENAME=RODMNativeStatus)
  if not exists (select * from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'nativeStatus')
    raiserror('Class RDSO has no attribute names ''nativeStatus''', 3, 1)
  else if (select count(*) from obj_attr as a join isa_chain as i on a.cid = i.base_cid where a.name = 'nativeStatus' and i.cid = 'RDSO') > 1
    raiserror('Class RDSO has ambiguous attribute definition for nativeStatus', 3, 1)
  else if not exists (select * from enumeration where name = 'RODMNativeStatus')
    raiserror('Invalid enumeration: ''RODMNativeStatus''', 3, 1)
  else
  begin
    if not exists 
    (
      select * from obj_attr_range as r
        join obj_attr as a on a.aid = r.aid
        join isa_chain as i on i.base_cid = a.cid 
        join enumeration as e on e.eid = r.eid
      where i.cid = 'RDSO' and a.name = 'nativeStatus' and e.name = 'RODMNativeStatus'
    )
    begin
      insert obj_attr_range(cid, aid, eid)
        select 'RDSO', a.aid, e.eid
        from
          obj_attr as a join isa_chain as i on i.base_cid = a.cid,
          enumeration as e
        where i.cid = 'RDSO' and a.name = 'nativeStatus' and e.name = 'RODMNativeStatus'
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
    update a set flag_enumeration = 1 
    from 
      obj_attr as a join isa_chain as i on i.base_cid = a.cid
    where i.cid = 'RDSO' and a.name = 'nativeStatus' and a.flag_enumeration = 0
    if @@rowcount > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end






---------------------------------------------------------------------------------------------------
-- New link types
/* LINK_TYPE(TYPE=MMBA, DESCRIPTION='Member Arc Link') */
  IF NOT EXISTS (SELECT * FROM link_type WHERE link_type = 'MMBA')
  BEGIN
    INSERT INTO link_type(link_type, description) VALUES ('MMBA', 'Member Arc Link')
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  ELSE
  BEGIN
    UPDATE link_type SET description = 'Member Arc Link'
    WHERE link_type = 'MMBA' 
    AND 
    (
      ('Member Arc Link' IS NULL AND description IS NOT NULL)
      OR
      ('Member Arc Link' IS NOT NULL AND description IS NULL)
      OR
      (description <> 'Member Arc Link')
    )
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  
/* LINK_TYPE(TYPE=MMBR, DESCRIPTION='Member Link') */
  IF NOT EXISTS (SELECT * FROM link_type WHERE link_type = 'MMBR')
  BEGIN
    INSERT INTO link_type(link_type, description) VALUES ('MMBR', 'Member Link')
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  ELSE
  BEGIN
    UPDATE link_type SET description = 'Member Link'
    WHERE link_type = 'MMBR' 
    AND 
    (
      ('Member Link' IS NULL AND description IS NOT NULL)
      OR
      ('Member Link' IS NOT NULL AND description IS NULL)
      OR
      (description <> 'Member Link')
    )
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  
  UPDATE link_type SET flag_parent_child = 1 WHERE link_type = 'MMBR' AND flag_parent_child = 0
  IF @@ROWCOUNT > 0 UPDATE Meta..DatabaseVersion SET verno = verno + 1
/* LINK_TYPE(TYPE=SATG, DESCRIPTION='Subarea Transmission Group Link') */
  IF NOT EXISTS (SELECT * FROM link_type WHERE link_type = 'SATG')
  BEGIN
    INSERT INTO link_type(link_type, description) VALUES ('SATG', 'Subarea Transmission Group Link')
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  ELSE
  BEGIN
    UPDATE link_type SET description = 'Subarea Transmission Group Link'
    WHERE link_type = 'SATG' 
    AND 
    (
      ('Subarea Transmission Group Link' IS NULL AND description IS NOT NULL)
      OR
      ('Subarea Transmission Group Link' IS NOT NULL AND description IS NULL)
      OR
      (description <> 'Subarea Transmission Group Link')
    )
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  

---------------------------------------------------------------------------------------------------
/* OBJECT_CLASS(CID=SNNT, CNAME=SNANetwork, LABEL='SNA/APPN Network', DESCRIPTION='Uniquely named network with SNA and APPN resources') */

  if not exists (select * from link_type where link_type='SNNT')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'SNNT', 'SNANetwork Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='SNNT')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'SNNT', 'SNANetwork', 'SNA/APPN Network', 'Uniquely named network with SNA and APPN resources'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'SNNT') <> 'SNANetwork'
    begin
      raiserror('Error defining class SNNT. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'SNA/APPN Network', description = 'Uniquely named network with SNA and APPN resources'
      where cid = 'SNNT' and (label <> 'SNA/APPN Network' or description <> 'Uniquely named network with SNA and APPN resources')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=SNNT, BASE_CID=MNO2)
  if not exists (select * from isa where cid = 'SNNT' and base_cid = 'MNO2')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'SNNT', 'MNO2',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'SNNT' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1



-- OBJ_ATTRIBUTE(NAME=MonitoringOSID, TYPE=LONG, LENGTH=0, DEFAULT='NULL', RULE=NULL, DESCRIPTION='Id of MVS image that contains the RODM repository used to monitor the network', LABEL='Monitoring OS')
  if not exists (select * from obj_attr where cid = 'SNNT' and name='MonitoringOSID')
  begin
    exec insert_obj_attr 'SNNT', 'MonitoringOSID', 'LONG', 0, 'NULL', NULL, 'Id of MVS image that contains the RODM repository used to monitor the network', 'Monitoring OS'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

-- BEGIN_ATTRIBUTE_PAGES(CID=SNNT)

if not exists (select * from isa where cid = 'SNNT')
begin
  raiserror('No isa relationship has been established for cid SNNT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE(SRC=STCR, DST=ATPG, TYPE=SNNT)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_SNNT' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_SNNT'
    exec("
    create table STCR_ATPG_SNNT
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_SNNT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_SNNT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_SNNT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_SNNT to public
    grant delete on STCR_ATPG_SNNT to public
    grant select on STCR_ATPG_SNNT to public
    grant update on STCR_ATPG_SNNT to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_SNNT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'SNNT')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_SNNT on STCR_ATPG_SNNT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNNT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_SNNT on STCR_ATPG_SNNT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNNT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgSNNT, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'SNNT_CreatePgSNNT')
    exec asisp_createATPG 'SNNT_CreatePgSNNT', STCR, 1, 'access1.exe', 'CreatePgSNNT', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'SNNT_CreatePgChildEvents')
    exec asisp_createATPG 'SNNT_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'SNNT_CreatePgExceptions')
    exec asisp_createATPG 'SNNT_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'SNNT_CreatePgDefineMsgs')
    exec asisp_createATPG 'SNNT_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'SNNT_CreatePgScheduledTasks')
    exec asisp_createATPG 'SNNT_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
-- END_ATTRIBUTE_PAGES(CID=SNNT)
end


-- BEGIN_LINKS(CID=SNNT)

  -- OBJ_LINK(TYPE='PHYC', SRC='ENT', DST='SNNT')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='ENT' AND dst_cid='SNNT')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'ENT', 'SNNT' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'ENT', 'SNNT')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



  -- OBJ_LINK(TYPE='PHYC', SRC='COMP', DST='SNNT')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='COMP' AND dst_cid='SNNT')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'COMP', 'SNNT' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'COMP', 'SNNT')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



  -- OBJ_LINK(TYPE='PHYC', SRC='MACH', DST='SNNT')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='MACH' AND dst_cid='SNNT')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'MACH', 'SNNT' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'MACH', 'SNNT')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



  -- OBJ_LINK(TYPE='PHYC', SRC='LPAR', DST='SNNT')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='LPAR' AND dst_cid='SNNT')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'LPAR', 'SNNT' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'LPAR', 'SNNT')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



  -- OBJ_LINK(TYPE='PHYC', SRC='OS', DST='SNNT')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='OS' AND dst_cid='SNNT')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'OS', 'SNNT' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'OS', 'SNNT')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



-- END_LINKS(CID=SNNT)
  exec Meta..asisp_make_isa_chain
go

---------------------------------------------------------------------------------------------------
/* OBJECT_CLASS(CID=SHLO, CNAME=SNAHighLevelObject, LABEL='SNAHighLevelObject', DESCRIPTION='Abstract base class for SNA/APPN network objects directly contained under the SNA/APPN Network') */

  if not exists (select * from link_type where link_type='SHLO')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'SHLO', 'SNAHighLevelObject Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='SHLO')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'SHLO', 'SNAHighLevelObject', 'SNAHighLevelObject', 'Abstract base class for SNA/APPN network objects directly contained under the SNA/APPN Network'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'SHLO') <> 'SNAHighLevelObject'
    begin
      raiserror('Error defining class SHLO. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'SNAHighLevelObject', description = 'Abstract base class for SNA/APPN network objects directly contained under the SNA/APPN Network'
      where cid = 'SHLO' and (label <> 'SNAHighLevelObject' or description <> 'Abstract base class for SNA/APPN network objects directly contained under the SNA/APPN Network')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
update obj_class set flag_abstract=1 where cid = 'SHLO' and flag_abstract<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1

-- OBJ_LINK(TYPE='PHYC', SRC='SNNT', DST='SHLO')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='SNNT' AND dst_cid='SHLO')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'SNNT', 'SHLO' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'SNNT', 'SHLO')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END




---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NNDM, CNAME=nnDomain, LABEL='nnDomain', DESCRIPTION='Provides aggregation for the *nnDomainNetwork member objects, and the *interdomainNetworkCircuit memberArcs objects that interconnect the *nnDomainNetwork objects.') */

  if not exists (select * from link_type where link_type='NNDM')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NNDM', 'nnDomain Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NNDM')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NNDM', 'nnDomain', 'nnDomain', 'Provides aggregation for the *nnDomainNetwork member objects, and the *interdomainNetworkCircuit memberArcs objects that interconnect the *nnDomainNetwork objects.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NNDM') <> 'nnDomain'
    begin
      raiserror('Error defining class NNDM. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'nnDomain', description = 'Provides aggregation for the *nnDomainNetwork member objects, and the *interdomainNetworkCircuit memberArcs objects that interconnect the *nnDomainNetwork objects.'
      where cid = 'NNDM' and (label <> 'nnDomain' or description <> 'Provides aggregation for the *nnDomainNetwork member objects, and the *interdomainNetworkCircuit memberArcs objects that interconnect the *nnDomainNetwork objects.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NNDM, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'NNDM' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDM', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NNDM' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NNDM)

if not exists (select * from isa where cid = 'NNDM')
begin
  raiserror('No isa relationship has been established for cid NNDM -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NNDM)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NNDM' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NNDM'
    exec("
    create table STCR_ATPG_NNDM
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NNDM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NNDM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NNDM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NNDM to public
    grant delete on STCR_ATPG_NNDM to public
    grant select on STCR_ATPG_NNDM to public
    grant update on STCR_ATPG_NNDM to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NNDM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NNDM')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDM on STCR_ATPG_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDM on STCR_ATPG_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgBusinessObject')
    exec asisp_createATPG 'NNDM_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgChildEvents')
    exec asisp_createATPG 'NNDM_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgExceptions')
    exec asisp_createATPG 'NNDM_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgDefineMsgs')
    exec asisp_createATPG 'NNDM_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgScheduledTasks')
    exec asisp_createATPG 'NNDM_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NNDM_CreatePgRODM')
    exec asisp_createATPG 'NNDM_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NNDM)
end
  -- IS_A(DERIVED_CID=NNDM, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'NNDM' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDM', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NNDN, CNAME=nnDomainNetwork, LABEL='nnDomainNetwork', DESCRIPTION='Provides aggregation for: APPN network node of the *nnDomain object as an NN server node; APPN branch node of the *nnDomain object; APPN end nodes the network node serves; APPN transmission group circuits that support CP-CP sessions.') */

  if not exists (select * from link_type where link_type='NNDN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NNDN', 'nnDomainNetwork Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NNDN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NNDN', 'nnDomainNetwork', 'nnDomainNetwork', 'Provides aggregation for: APPN network node of the *nnDomain object as an NN server node; APPN branch node of the *nnDomain object; APPN end nodes the network node serves; APPN transmission group circuits that support CP-CP sessions.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NNDN') <> 'nnDomainNetwork'
    begin
      raiserror('Error defining class NNDN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'nnDomainNetwork', description = 'Provides aggregation for: APPN network node of the *nnDomain object as an NN server node; APPN branch node of the *nnDomain object; APPN end nodes the network node serves; APPN transmission group circuits that support CP-CP sessions.'
      where cid = 'NNDN' and (label <> 'nnDomainNetwork' or description <> 'Provides aggregation for: APPN network node of the *nnDomain object as an NN server node; APPN branch node of the *nnDomain object; APPN end nodes the network node serves; APPN transmission group circuits that support CP-CP sessions.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NNDN, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'NNDN' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDN', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NNDN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NNDN)

if not exists (select * from isa where cid = 'NNDN')
begin
  raiserror('No isa relationship has been established for cid NNDN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NNDN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NNDN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NNDN'
    exec("
    create table STCR_ATPG_NNDN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NNDN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NNDN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NNDN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NNDN to public
    grant delete on STCR_ATPG_NNDN to public
    grant select on STCR_ATPG_NNDN to public
    grant update on STCR_ATPG_NNDN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NNDN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NNDN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDN on STCR_ATPG_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDN on STCR_ATPG_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgBusinessObject')
    exec asisp_createATPG 'NNDN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgChildEvents')
    exec asisp_createATPG 'NNDN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgExceptions')
    exec asisp_createATPG 'NNDN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgDefineMsgs')
    exec asisp_createATPG 'NNDN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgScheduledTasks')
    exec asisp_createATPG 'NNDN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NNDN_CreatePgRODM')
    exec asisp_createATPG 'NNDN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NNDN)
end
  -- IS_A(DERIVED_CID=NNDN, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'NNDN' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDN', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NNDC, CNAME=nnDomainNetworkCluster, LABEL='nnDomainNetworkCluster', DESCRIPTION='Provides aggregation for the *nnDomain member objects, and the *interdomainCircuit memberArcs objects that interconnect the *nnDomain objects.') */

  if not exists (select * from link_type where link_type='NNDC')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NNDC', 'nnDomainNetworkCluster Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NNDC')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NNDC', 'nnDomainNetworkCluster', 'nnDomainNetworkCluster', 'Provides aggregation for the *nnDomain member objects, and the *interdomainCircuit memberArcs objects that interconnect the *nnDomain objects.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NNDC') <> 'nnDomainNetworkCluster'
    begin
      raiserror('Error defining class NNDC. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'nnDomainNetworkCluster', description = 'Provides aggregation for the *nnDomain member objects, and the *interdomainCircuit memberArcs objects that interconnect the *nnDomain objects.'
      where cid = 'NNDC' and (label <> 'nnDomainNetworkCluster' or description <> 'Provides aggregation for the *nnDomain member objects, and the *interdomainCircuit memberArcs objects that interconnect the *nnDomain objects.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NNDC, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'NNDC' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDC', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NNDC' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NNDC)

if not exists (select * from isa where cid = 'NNDC')
begin
  raiserror('No isa relationship has been established for cid NNDC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NNDC)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NNDC' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NNDC'
    exec("
    create table STCR_ATPG_NNDC
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NNDC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NNDC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NNDC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NNDC to public
    grant delete on STCR_ATPG_NNDC to public
    grant select on STCR_ATPG_NNDC to public
    grant update on STCR_ATPG_NNDC to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NNDC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NNDC')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDC on STCR_ATPG_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNDC on STCR_ATPG_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgBusinessObject')
    exec asisp_createATPG 'NNDC_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgChildEvents')
    exec asisp_createATPG 'NNDC_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgExceptions')
    exec asisp_createATPG 'NNDC_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgDefineMsgs')
    exec asisp_createATPG 'NNDC_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgScheduledTasks')
    exec asisp_createATPG 'NNDC_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NNDC_CreatePgRODM')
    exec asisp_createATPG 'NNDC_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NNDC)
end
  -- IS_A(DERIVED_CID=NNDC, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'NNDC' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNDC', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=IDCT, CNAME=IDCircuit, LABEL='interdomainCircuit', DESCRIPTION='Defines the fields that apply to aggregate objects representing APPN transmission group (TG) circuits between two APPN network nodes or between a network node and  a virtual routing node.') */

  if not exists (select * from link_type where link_type='IDCT')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'IDCT', 'IDCircuit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='IDCT')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'IDCT', 'IDCircuit', 'interdomainCircuit', 'Defines the fields that apply to aggregate objects representing APPN transmission group (TG) circuits between two APPN network nodes or between a network node and  a virtual routing node.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'IDCT') <> 'IDCircuit'
    begin
      raiserror('Error defining class IDCT. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'interdomainCircuit', description = 'Defines the fields that apply to aggregate objects representing APPN transmission group (TG) circuits between two APPN network nodes or between a network node and  a virtual routing node.'
      where cid = 'IDCT' and (label <> 'interdomainCircuit' or description <> 'Defines the fields that apply to aggregate objects representing APPN transmission group (TG) circuits between two APPN network nodes or between a network node and  a virtual routing node.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=IDCT, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'IDCT' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'IDCT', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'IDCT' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=IDCT)

if not exists (select * from isa where cid = 'IDCT')
begin
  raiserror('No isa relationship has been established for cid IDCT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=IDCT)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_IDCT' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_IDCT'
    exec("
    create table STCR_ATPG_IDCT
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_IDCT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_IDCT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_IDCT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_IDCT to public
    grant delete on STCR_ATPG_IDCT to public
    grant select on STCR_ATPG_IDCT to public
    grant update on STCR_ATPG_IDCT to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_IDCT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'IDCT')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_IDCT on STCR_ATPG_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_IDCT on STCR_ATPG_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgBusinessObject')
    exec asisp_createATPG 'IDCT_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgChildEvents')
    exec asisp_createATPG 'IDCT_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgExceptions')
    exec asisp_createATPG 'IDCT_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgDefineMsgs')
    exec asisp_createATPG 'IDCT_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgScheduledTasks')
    exec asisp_createATPG 'IDCT_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'IDCT_CreatePgRODM')
    exec asisp_createATPG 'IDCT_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=IDCT)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=ENLT, CNAME=enLocalTopology, LABEL='enLocalTopology', DESCRIPTION='Used for creating enLocalTopology views. An object of *enLocalTopology represents a model for an APPN end node (or migrationDataHost), its logically adjacent nodes (if any), and the transmission groups (if any) between the local EN and the adjacent nodes.') */

  if not exists (select * from link_type where link_type='ENLT')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'ENLT', 'enLocalTopology Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='ENLT')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'ENLT', 'enLocalTopology', 'enLocalTopology', 'Used for creating enLocalTopology views. An object of *enLocalTopology represents a model for an APPN end node (or migrationDataHost), its logically adjacent nodes (if any), and the transmission groups (if any) between the local EN and the adjacent nodes.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'ENLT') <> 'enLocalTopology'
    begin
      raiserror('Error defining class ENLT. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'enLocalTopology', description = 'Used for creating enLocalTopology views. An object of *enLocalTopology represents a model for an APPN end node (or migrationDataHost), its logically adjacent nodes (if any), and the transmission groups (if any) between the local EN and the adjacent nodes.'
      where cid = 'ENLT' and (label <> 'enLocalTopology' or description <> 'Used for creating enLocalTopology views. An object of *enLocalTopology represents a model for an APPN end node (or migrationDataHost), its logically adjacent nodes (if any), and the transmission groups (if any) between the local EN and the adjacent nodes.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=ENLT, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'ENLT' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'ENLT', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'ENLT' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=ENLT)

if not exists (select * from isa where cid = 'ENLT')
begin
  raiserror('No isa relationship has been established for cid ENLT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=ENLT)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_ENLT' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_ENLT'
    exec("
    create table STCR_ATPG_ENLT
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_ENLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_ENLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_ENLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_ENLT to public
    grant delete on STCR_ATPG_ENLT to public
    grant select on STCR_ATPG_ENLT to public
    grant update on STCR_ATPG_ENLT to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_ENLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'ENLT')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ENLT on STCR_ATPG_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ENLT on STCR_ATPG_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgBusinessObject')
    exec asisp_createATPG 'ENLT_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgChildEvents')
    exec asisp_createATPG 'ENLT_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgExceptions')
    exec asisp_createATPG 'ENLT_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgDefineMsgs')
    exec asisp_createATPG 'ENLT_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgScheduledTasks')
    exec asisp_createATPG 'ENLT_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'ENLT_CreatePgRODM')
    exec asisp_createATPG 'ENLT_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=ENLT)
end
  -- IS_A(DERIVED_CID=ENLT, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'ENLT' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'ENLT', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NNLT, CNAME=nnLocalTopology, LABEL='nnLocalTopology', DESCRIPTION='Represents a model for an APPN network node (or interchangeNode), its logically adjacent nodes (if any), and the transmission groups (if any) between the local NN and the adjacent nodes.  The object is an aggregate object, but has no aggregation links.') */

  if not exists (select * from link_type where link_type='NNLT')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NNLT', 'nnLocalTopology Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NNLT')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NNLT', 'nnLocalTopology', 'nnLocalTopology', 'Represents a model for an APPN network node (or interchangeNode), its logically adjacent nodes (if any), and the transmission groups (if any) between the local NN and the adjacent nodes.  The object is an aggregate object, but has no aggregation links.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NNLT') <> 'nnLocalTopology'
    begin
      raiserror('Error defining class NNLT. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'nnLocalTopology', description = 'Represents a model for an APPN network node (or interchangeNode), its logically adjacent nodes (if any), and the transmission groups (if any) between the local NN and the adjacent nodes.  The object is an aggregate object, but has no aggregation links.'
      where cid = 'NNLT' and (label <> 'nnLocalTopology' or description <> 'Represents a model for an APPN network node (or interchangeNode), its logically adjacent nodes (if any), and the transmission groups (if any) between the local NN and the adjacent nodes.  The object is an aggregate object, but has no aggregation links.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NNLT, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'NNLT' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNLT', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NNLT' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NNLT)

if not exists (select * from isa where cid = 'NNLT')
begin
  raiserror('No isa relationship has been established for cid NNLT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NNLT)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NNLT' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NNLT'
    exec("
    create table STCR_ATPG_NNLT
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NNLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NNLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NNLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NNLT to public
    grant delete on STCR_ATPG_NNLT to public
    grant select on STCR_ATPG_NNLT to public
    grant update on STCR_ATPG_NNLT to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NNLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NNLT')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNLT on STCR_ATPG_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NNLT on STCR_ATPG_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgBusinessObject')
    exec asisp_createATPG 'NNLT_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgChildEvents')
    exec asisp_createATPG 'NNLT_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgExceptions')
    exec asisp_createATPG 'NNLT_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgDefineMsgs')
    exec asisp_createATPG 'NNLT_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgScheduledTasks')
    exec asisp_createATPG 'NNLT_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NNLT_CreatePgRODM')
    exec asisp_createATPG 'NNLT_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NNLT)
end
  -- IS_A(DERIVED_CID=NNLT, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'NNLT' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NNLT', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=LUG, CNAME=luGroup, LABEL='luGroup', DESCRIPTION='Set of LUs that have been grouped together under one generic resource name. The generic resource function is only available in a sysplex environment  running under a release of MVS that supports coupling facility services.') */

  if not exists (select * from link_type where link_type='LUG')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'LUG', 'luGroup Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='LUG')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'LUG', 'luGroup', 'luGroup', 'Set of LUs that have been grouped together under one generic resource name. The generic resource function is only available in a sysplex environment  running under a release of MVS that supports coupling facility services.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'LUG') <> 'luGroup'
    begin
      raiserror('Error defining class LUG. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'luGroup', description = 'Set of LUs that have been grouped together under one generic resource name. The generic resource function is only available in a sysplex environment  running under a release of MVS that supports coupling facility services.'
      where cid = 'LUG' and (label <> 'luGroup' or description <> 'Set of LUs that have been grouped together under one generic resource name. The generic resource function is only available in a sysplex environment  running under a release of MVS that supports coupling facility services.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=LUG, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'LUG' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'LUG', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'LUG' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=LUG)

if not exists (select * from isa where cid = 'LUG')
begin
  raiserror('No isa relationship has been established for cid LUG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=LUG)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_LUG' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_LUG'
    exec("
    create table STCR_ATPG_LUG
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_LUG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_LUG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_LUG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_LUG to public
    grant delete on STCR_ATPG_LUG to public
    grant select on STCR_ATPG_LUG to public
    grant update on STCR_ATPG_LUG to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_LUG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'LUG')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LUG on STCR_ATPG_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LUG on STCR_ATPG_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgBusinessObject')
    exec asisp_createATPG 'LUG_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgChildEvents')
    exec asisp_createATPG 'LUG_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgExceptions')
    exec asisp_createATPG 'LUG_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgDefineMsgs')
    exec asisp_createATPG 'LUG_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgScheduledTasks')
    exec asisp_createATPG 'LUG_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'LUG_CreatePgRODM')
    exec asisp_createATPG 'LUG_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=LUG)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=STGC, CNAME=subareaTGCircuit, LABEL='subareaTransmissionGroupCircuit', DESCRIPTION='Represents the subarea connection between two subarea nodes.') */

  if not exists (select * from link_type where link_type='STGC')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'STGC', 'subareaTGCircuit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='STGC')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'STGC', 'subareaTGCircuit', 'subareaTransmissionGroupCircuit', 'Represents the subarea connection between two subarea nodes.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'STGC') <> 'subareaTGCircuit'
    begin
      raiserror('Error defining class STGC. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'subareaTransmissionGroupCircuit', description = 'Represents the subarea connection between two subarea nodes.'
      where cid = 'STGC' and (label <> 'subareaTransmissionGroupCircuit' or description <> 'Represents the subarea connection between two subarea nodes.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=STGC, BASE_CID=RDMO)
  if not exists (select * from isa where cid = 'STGC' and base_cid = 'RDMO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'STGC', 'RDMO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'STGC' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=STGC)

if not exists (select * from isa where cid = 'STGC')
begin
  raiserror('No isa relationship has been established for cid STGC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=STGC)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_STGC' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_STGC'
    exec("
    create table STCR_ATPG_STGC
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_STGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_STGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_STGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_STGC to public
    grant delete on STCR_ATPG_STGC to public
    grant select on STCR_ATPG_STGC to public
    grant update on STCR_ATPG_STGC to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_STGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'STGC')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_STGC on STCR_ATPG_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_STGC on STCR_ATPG_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgBusinessObject')
    exec asisp_createATPG 'STGC_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgChildEvents')
    exec asisp_createATPG 'STGC_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgExceptions')
    exec asisp_createATPG 'STGC_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgDefineMsgs')
    exec asisp_createATPG 'STGC_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgScheduledTasks')
    exec asisp_createATPG 'STGC_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'STGC_CreatePgRODM')
    exec asisp_createATPG 'STGC_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=STGC)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=BRNN, CNAME=appnBrNN, LABEL='appnBrNN', DESCRIPTION='To nodes in the WAN including its network node server appears to be an APPN end node. To end nodes in its branch (That is, end nodes to which it is connected by a TG it defines as a branch downlink.), it appears to be a network node.') */

  if not exists (select * from link_type where link_type='BRNN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'BRNN', 'appnBrNN Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='BRNN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'BRNN', 'appnBrNN', 'appnBrNN', 'To nodes in the WAN including its network node server appears to be an APPN end node. To end nodes in its branch (That is, end nodes to which it is connected by a TG it defines as a branch downlink.), it appears to be a network node.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'BRNN') <> 'appnBrNN'
    begin
      raiserror('Error defining class BRNN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnBrNN', description = 'To nodes in the WAN including its network node server appears to be an APPN end node. To end nodes in its branch (That is, end nodes to which it is connected by a TG it defines as a branch downlink.), it appears to be a network node.'
      where cid = 'BRNN' and (label <> 'appnBrNN' or description <> 'To nodes in the WAN including its network node server appears to be an APPN end node. To end nodes in its branch (That is, end nodes to which it is connected by a TG it defines as a branch downlink.), it appears to be a network node.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=BRNN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'BRNN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'BRNN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'BRNN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=BRNN)

if not exists (select * from isa where cid = 'BRNN')
begin
  raiserror('No isa relationship has been established for cid BRNN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=BRNN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_BRNN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_BRNN'
    exec("
    create table STCR_ATPG_BRNN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_BRNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_BRNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_BRNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_BRNN to public
    grant delete on STCR_ATPG_BRNN to public
    grant select on STCR_ATPG_BRNN to public
    grant update on STCR_ATPG_BRNN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_BRNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'BRNN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_BRNN on STCR_ATPG_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_BRNN on STCR_ATPG_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgBusinessObject')
    exec asisp_createATPG 'BRNN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgChildEvents')
    exec asisp_createATPG 'BRNN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgExceptions')
    exec asisp_createATPG 'BRNN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgDefineMsgs')
    exec asisp_createATPG 'BRNN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgScheduledTasks')
    exec asisp_createATPG 'BRNN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'BRNN_CreatePgRODM')
    exec asisp_createATPG 'BRNN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=BRNN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=APEN, CNAME=appnEN, LABEL='appnEN', DESCRIPTION='SNA type 2.1 node that supports its own end users, providing limited directory and route selection services, as well as management services.') */

  if not exists (select * from link_type where link_type='APEN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'APEN', 'appnEN Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='APEN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'APEN', 'appnEN', 'appnEN', 'SNA type 2.1 node that supports its own end users, providing limited directory and route selection services, as well as management services.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'APEN') <> 'appnEN'
    begin
      raiserror('Error defining class APEN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnEN', description = 'SNA type 2.1 node that supports its own end users, providing limited directory and route selection services, as well as management services.'
      where cid = 'APEN' and (label <> 'appnEN' or description <> 'SNA type 2.1 node that supports its own end users, providing limited directory and route selection services, as well as management services.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=APEN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'APEN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'APEN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'APEN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=APEN)

if not exists (select * from isa where cid = 'APEN')
begin
  raiserror('No isa relationship has been established for cid APEN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=APEN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_APEN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_APEN'
    exec("
    create table STCR_ATPG_APEN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_APEN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_APEN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_APEN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_APEN to public
    grant delete on STCR_ATPG_APEN to public
    grant select on STCR_ATPG_APEN to public
    grant update on STCR_ATPG_APEN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_APEN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'APEN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APEN on STCR_ATPG_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APEN on STCR_ATPG_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgBusinessObject')
    exec asisp_createATPG 'APEN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgChildEvents')
    exec asisp_createATPG 'APEN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgExceptions')
    exec asisp_createATPG 'APEN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgDefineMsgs')
    exec asisp_createATPG 'APEN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgScheduledTasks')
    exec asisp_createATPG 'APEN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'APEN_CreatePgRODM')
    exec asisp_createATPG 'APEN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=APEN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=APNN, CNAME=appnNN, LABEL='appnNN', DESCRIPTION='SNA type 2.1 node that provides the following services to end nodes: directory, management, route selection, performs intermediate routing of data on sessions that traverse it.') */

  if not exists (select * from link_type where link_type='APNN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'APNN', 'appnNN Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='APNN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'APNN', 'appnNN', 'appnNN', 'SNA type 2.1 node that provides the following services to end nodes: directory, management, route selection, performs intermediate routing of data on sessions that traverse it.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'APNN') <> 'appnNN'
    begin
      raiserror('Error defining class APNN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnNN', description = 'SNA type 2.1 node that provides the following services to end nodes: directory, management, route selection, performs intermediate routing of data on sessions that traverse it.'
      where cid = 'APNN' and (label <> 'appnNN' or description <> 'SNA type 2.1 node that provides the following services to end nodes: directory, management, route selection, performs intermediate routing of data on sessions that traverse it.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=APNN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'APNN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'APNN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'APNN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=APNN)

if not exists (select * from isa where cid = 'APNN')
begin
  raiserror('No isa relationship has been established for cid APNN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=APNN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_APNN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_APNN'
    exec("
    create table STCR_ATPG_APNN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_APNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_APNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_APNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_APNN to public
    grant delete on STCR_ATPG_APNN to public
    grant select on STCR_ATPG_APNN to public
    grant update on STCR_ATPG_APNN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_APNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'APNN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APNN on STCR_ATPG_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APNN on STCR_ATPG_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgBusinessObject')
    exec asisp_createATPG 'APNN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgChildEvents')
    exec asisp_createATPG 'APNN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgExceptions')
    exec asisp_createATPG 'APNN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgDefineMsgs')
    exec asisp_createATPG 'APNN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgScheduledTasks')
    exec asisp_createATPG 'APNN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'APNN_CreatePgRODM')
    exec asisp_createATPG 'APNN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=APNN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=APTG, CNAME=appnTG, LABEL='appnTransmissionGroup', DESCRIPTION='Provides a route for a session stage between two logically adjacent nodes. Uniquely identified by transmission group number. A route is composed of a series of transmission group numbers and names of associated adjacent nodes..') */

  if not exists (select * from link_type where link_type='APTG')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'APTG', 'appnTG Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='APTG')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'APTG', 'appnTG', 'appnTransmissionGroup', 'Provides a route for a session stage between two logically adjacent nodes. Uniquely identified by transmission group number. A route is composed of a series of transmission group numbers and names of associated adjacent nodes..'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'APTG') <> 'appnTG'
    begin
      raiserror('Error defining class APTG. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnTransmissionGroup', description = 'Provides a route for a session stage between two logically adjacent nodes. Uniquely identified by transmission group number. A route is composed of a series of transmission group numbers and names of associated adjacent nodes..'
      where cid = 'APTG' and (label <> 'appnTransmissionGroup' or description <> 'Provides a route for a session stage between two logically adjacent nodes. Uniquely identified by transmission group number. A route is composed of a series of transmission group numbers and names of associated adjacent nodes..')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=APTG, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'APTG' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'APTG', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'APTG' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=APTG)

if not exists (select * from isa where cid = 'APTG')
begin
  raiserror('No isa relationship has been established for cid APTG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=APTG)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_APTG' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_APTG'
    exec("
    create table STCR_ATPG_APTG
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_APTG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_APTG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_APTG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_APTG to public
    grant delete on STCR_ATPG_APTG to public
    grant select on STCR_ATPG_APTG to public
    grant update on STCR_ATPG_APTG to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_APTG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'APTG')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APTG on STCR_ATPG_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_APTG on STCR_ATPG_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgBusinessObject')
    exec asisp_createATPG 'APTG_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgChildEvents')
    exec asisp_createATPG 'APTG_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgExceptions')
    exec asisp_createATPG 'APTG_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgDefineMsgs')
    exec asisp_createATPG 'APTG_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgScheduledTasks')
    exec asisp_createATPG 'APTG_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'APTG_CreatePgRODM')
    exec asisp_createATPG 'APTG_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=APTG)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=ATGC, CNAME=appnTGCircuit, LABEL='appnTransmissionGroupCircuit', DESCRIPTION='Represents an appnTransmissionGroupCircuit that is connected to a node with the following NTRI-like resources: NTRI, FrameRelay, ESCON, and Ethernet.') */

  if not exists (select * from link_type where link_type='ATGC')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'ATGC', 'appnTGCircuit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='ATGC')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'ATGC', 'appnTGCircuit', 'appnTransmissionGroupCircuit', 'Represents an appnTransmissionGroupCircuit that is connected to a node with the following NTRI-like resources: NTRI, FrameRelay, ESCON, and Ethernet.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'ATGC') <> 'appnTGCircuit'
    begin
      raiserror('Error defining class ATGC. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnTransmissionGroupCircuit', description = 'Represents an appnTransmissionGroupCircuit that is connected to a node with the following NTRI-like resources: NTRI, FrameRelay, ESCON, and Ethernet.'
      where cid = 'ATGC' and (label <> 'appnTransmissionGroupCircuit' or description <> 'Represents an appnTransmissionGroupCircuit that is connected to a node with the following NTRI-like resources: NTRI, FrameRelay, ESCON, and Ethernet.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=ATGC, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'ATGC' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'ATGC', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'ATGC' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=ATGC)

if not exists (select * from isa where cid = 'ATGC')
begin
  raiserror('No isa relationship has been established for cid ATGC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=ATGC)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_ATGC' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_ATGC'
    exec("
    create table STCR_ATPG_ATGC
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_ATGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_ATGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_ATGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_ATGC to public
    grant delete on STCR_ATPG_ATGC to public
    grant select on STCR_ATPG_ATGC to public
    grant update on STCR_ATPG_ATGC to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_ATGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'ATGC')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ATGC on STCR_ATPG_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ATGC on STCR_ATPG_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgBusinessObject')
    exec asisp_createATPG 'ATGC_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgChildEvents')
    exec asisp_createATPG 'ATGC_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgExceptions')
    exec asisp_createATPG 'ATGC_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgDefineMsgs')
    exec asisp_createATPG 'ATGC_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgScheduledTasks')
    exec asisp_createATPG 'ATGC_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'ATGC_CreatePgRODM')
    exec asisp_createATPG 'ATGC_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=ATGC)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=TGCN, CNAME=appnTGCircuitCN, LABEL='appnTransGroupCircuitCN', DESCRIPTION='Comprises one or two underlying appnTransmissionGroup objects, and provides a composite status of the appnTransmissionGroup objects.') */

  if not exists (select * from link_type where link_type='TGCN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'TGCN', 'appnTGCircuitCN Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='TGCN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'TGCN', 'appnTGCircuitCN', 'appnTransGroupCircuitCN', 'Comprises one or two underlying appnTransmissionGroup objects, and provides a composite status of the appnTransmissionGroup objects.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'TGCN') <> 'appnTGCircuitCN'
    begin
      raiserror('Error defining class TGCN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'appnTransGroupCircuitCN', description = 'Comprises one or two underlying appnTransmissionGroup objects, and provides a composite status of the appnTransmissionGroup objects.'
      where cid = 'TGCN' and (label <> 'appnTransGroupCircuitCN' or description <> 'Comprises one or two underlying appnTransmissionGroup objects, and provides a composite status of the appnTransmissionGroup objects.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=TGCN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'TGCN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'TGCN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'TGCN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=TGCN)

if not exists (select * from isa where cid = 'TGCN')
begin
  raiserror('No isa relationship has been established for cid TGCN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=TGCN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_TGCN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_TGCN'
    exec("
    create table STCR_ATPG_TGCN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_TGCN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_TGCN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_TGCN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_TGCN to public
    grant delete on STCR_ATPG_TGCN to public
    grant select on STCR_ATPG_TGCN to public
    grant update on STCR_ATPG_TGCN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_TGCN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'TGCN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_TGCN on STCR_ATPG_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_TGCN on STCR_ATPG_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgBusinessObject')
    exec asisp_createATPG 'TGCN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgChildEvents')
    exec asisp_createATPG 'TGCN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgExceptions')
    exec asisp_createATPG 'TGCN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgDefineMsgs')
    exec asisp_createATPG 'TGCN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgScheduledTasks')
    exec asisp_createATPG 'TGCN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'TGCN_CreatePgRODM')
    exec asisp_createATPG 'TGCN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=TGCN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NTRI, CNAME=ntriTypeAppnTgCircuit, LABEL='ntriTypeAppnTgCircuit', DESCRIPTION='Represents an APPN connection to a composite node (interchange node) or a t5Node that traverses the subarea part of the network') */

  if not exists (select * from link_type where link_type='NTRI')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NTRI', 'ntriTypeAppnTgCircuit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NTRI')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NTRI', 'ntriTypeAppnTgCircuit', 'ntriTypeAppnTgCircuit', 'Represents an APPN connection to a composite node (interchange node) or a t5Node that traverses the subarea part of the network'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NTRI') <> 'ntriTypeAppnTgCircuit'
    begin
      raiserror('Error defining class NTRI. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'ntriTypeAppnTgCircuit', description = 'Represents an APPN connection to a composite node (interchange node) or a t5Node that traverses the subarea part of the network'
      where cid = 'NTRI' and (label <> 'ntriTypeAppnTgCircuit' or description <> 'Represents an APPN connection to a composite node (interchange node) or a t5Node that traverses the subarea part of the network')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NTRI, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'NTRI' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NTRI', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NTRI' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NTRI)

if not exists (select * from isa where cid = 'NTRI')
begin
  raiserror('No isa relationship has been established for cid NTRI -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NTRI)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NTRI' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NTRI'
    exec("
    create table STCR_ATPG_NTRI
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NTRI_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NTRI_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NTRI_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NTRI to public
    grant delete on STCR_ATPG_NTRI to public
    grant select on STCR_ATPG_NTRI to public
    grant update on STCR_ATPG_NTRI to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NTRI'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NTRI')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NTRI on STCR_ATPG_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NTRI on STCR_ATPG_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgBusinessObject')
    exec asisp_createATPG 'NTRI_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgChildEvents')
    exec asisp_createATPG 'NTRI_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgExceptions')
    exec asisp_createATPG 'NTRI_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgDefineMsgs')
    exec asisp_createATPG 'NTRI_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgScheduledTasks')
    exec asisp_createATPG 'NTRI_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NTRI_CreatePgRODM')
    exec asisp_createATPG 'NTRI_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NTRI)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=IDNC, CNAME=IDNetworkCircuit, LABEL='interdomainNetworkCircuit', DESCRIPTION='Defines the fields that apply to aggregate objects representing  APPN intersubnetwork TG circuits.') */

  if not exists (select * from link_type where link_type='IDNC')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'IDNC', 'IDNetworkCircuit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='IDNC')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'IDNC', 'IDNetworkCircuit', 'interdomainNetworkCircuit', 'Defines the fields that apply to aggregate objects representing  APPN intersubnetwork TG circuits.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'IDNC') <> 'IDNetworkCircuit'
    begin
      raiserror('Error defining class IDNC. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'interdomainNetworkCircuit', description = 'Defines the fields that apply to aggregate objects representing  APPN intersubnetwork TG circuits.'
      where cid = 'IDNC' and (label <> 'interdomainNetworkCircuit' or description <> 'Defines the fields that apply to aggregate objects representing  APPN intersubnetwork TG circuits.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=IDNC, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'IDNC' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'IDNC', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'IDNC' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=IDNC)

if not exists (select * from isa where cid = 'IDNC')
begin
  raiserror('No isa relationship has been established for cid IDNC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=IDNC)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_IDNC' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_IDNC'
    exec("
    create table STCR_ATPG_IDNC
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_IDNC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_IDNC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_IDNC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_IDNC to public
    grant delete on STCR_ATPG_IDNC to public
    grant select on STCR_ATPG_IDNC to public
    grant update on STCR_ATPG_IDNC to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_IDNC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'IDNC')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_IDNC on STCR_ATPG_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_IDNC on STCR_ATPG_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgBusinessObject')
    exec asisp_createATPG 'IDNC_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgChildEvents')
    exec asisp_createATPG 'IDNC_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgExceptions')
    exec asisp_createATPG 'IDNC_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgDefineMsgs')
    exec asisp_createATPG 'IDNC_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgScheduledTasks')
    exec asisp_createATPG 'IDNC_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'IDNC_CreatePgRODM')
    exec asisp_createATPG 'IDNC_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=IDNC)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=XDR, CNAME=xDomainResource, LABEL='crossDomainResource', DESCRIPTION='Logical unit (for example, an application program, a peripheral node, or a terminal)  that is controlled by another VTAM domain.') */

  if not exists (select * from link_type where link_type='XDR')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'XDR', 'xDomainResource Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='XDR')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'XDR', 'xDomainResource', 'crossDomainResource', 'Logical unit (for example, an application program, a peripheral node, or a terminal)  that is controlled by another VTAM domain.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'XDR') <> 'xDomainResource'
    begin
      raiserror('Error defining class XDR. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'crossDomainResource', description = 'Logical unit (for example, an application program, a peripheral node, or a terminal)  that is controlled by another VTAM domain.'
      where cid = 'XDR' and (label <> 'crossDomainResource' or description <> 'Logical unit (for example, an application program, a peripheral node, or a terminal)  that is controlled by another VTAM domain.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=XDR, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'XDR' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'XDR', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'XDR' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=XDR)

if not exists (select * from isa where cid = 'XDR')
begin
  raiserror('No isa relationship has been established for cid XDR -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=XDR)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_XDR' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_XDR'
    exec("
    create table STCR_ATPG_XDR
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_XDR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_XDR_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_XDR_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_XDR to public
    grant delete on STCR_ATPG_XDR to public
    grant select on STCR_ATPG_XDR to public
    grant update on STCR_ATPG_XDR to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_XDR'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'XDR')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_XDR on STCR_ATPG_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_XDR on STCR_ATPG_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgBusinessObject')
    exec asisp_createATPG 'XDR_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgChildEvents')
    exec asisp_createATPG 'XDR_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgExceptions')
    exec asisp_createATPG 'XDR_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgDefineMsgs')
    exec asisp_createATPG 'XDR_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgScheduledTasks')
    exec asisp_createATPG 'XDR_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'XDR_CreatePgRODM')
    exec asisp_createATPG 'XDR_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=XDR)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=XDRM, CNAME=xDomainResourceManager, LABEL='crossDomainResourceManager', DESCRIPTION='Part of an SSCP that supports cross-domain session (SSCP-SSCP session) setup and takedown.') */

  if not exists (select * from link_type where link_type='XDRM')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'XDRM', 'xDomainResourceManager Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='XDRM')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'XDRM', 'xDomainResourceManager', 'crossDomainResourceManager', 'Part of an SSCP that supports cross-domain session (SSCP-SSCP session) setup and takedown.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'XDRM') <> 'xDomainResourceManager'
    begin
      raiserror('Error defining class XDRM. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'crossDomainResourceManager', description = 'Part of an SSCP that supports cross-domain session (SSCP-SSCP session) setup and takedown.'
      where cid = 'XDRM' and (label <> 'crossDomainResourceManager' or description <> 'Part of an SSCP that supports cross-domain session (SSCP-SSCP session) setup and takedown.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=XDRM, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'XDRM' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'XDRM', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'XDRM' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=XDRM)

if not exists (select * from isa where cid = 'XDRM')
begin
  raiserror('No isa relationship has been established for cid XDRM -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=XDRM)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_XDRM' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_XDRM'
    exec("
    create table STCR_ATPG_XDRM
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_XDRM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_XDRM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_XDRM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_XDRM to public
    grant delete on STCR_ATPG_XDRM to public
    grant select on STCR_ATPG_XDRM to public
    grant update on STCR_ATPG_XDRM to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_XDRM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'XDRM')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_XDRM on STCR_ATPG_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_XDRM on STCR_ATPG_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgBusinessObject')
    exec asisp_createATPG 'XDRM_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgChildEvents')
    exec asisp_createATPG 'XDRM_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgExceptions')
    exec asisp_createATPG 'XDRM_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgDefineMsgs')
    exec asisp_createATPG 'XDRM_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgScheduledTasks')
    exec asisp_createATPG 'XDRM_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'XDRM_CreatePgRODM')
    exec asisp_createATPG 'XDRM_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=XDRM)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=DG, CNAME=definitionGroup, LABEL='definitionGroup', DESCRIPTION='Defines the fields that apply to major node objects reported by the VTAM agent. A definitionGroup is a VTAM major node, which is a grouping of similar resource definitions.') */

  if not exists (select * from link_type where link_type='DG')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'DG', 'definitionGroup Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='DG')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'DG', 'definitionGroup', 'definitionGroup', 'Defines the fields that apply to major node objects reported by the VTAM agent. A definitionGroup is a VTAM major node, which is a grouping of similar resource definitions.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'DG') <> 'definitionGroup'
    begin
      raiserror('Error defining class DG. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'definitionGroup', description = 'Defines the fields that apply to major node objects reported by the VTAM agent. A definitionGroup is a VTAM major node, which is a grouping of similar resource definitions.'
      where cid = 'DG' and (label <> 'definitionGroup' or description <> 'Defines the fields that apply to major node objects reported by the VTAM agent. A definitionGroup is a VTAM major node, which is a grouping of similar resource definitions.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=DG, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'DG' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'DG', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'DG' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=DG)

if not exists (select * from isa where cid = 'DG')
begin
  raiserror('No isa relationship has been established for cid DG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=DG)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_DG' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_DG'
    exec("
    create table STCR_ATPG_DG
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_DG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_DG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_DG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_DG to public
    grant delete on STCR_ATPG_DG to public
    grant select on STCR_ATPG_DG to public
    grant update on STCR_ATPG_DG to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_DG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'DG')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_DG on STCR_ATPG_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_DG on STCR_ATPG_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgBusinessObject')
    exec asisp_createATPG 'DG_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgChildEvents')
    exec asisp_createATPG 'DG_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgExceptions')
    exec asisp_createATPG 'DG_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgDefineMsgs')
    exec asisp_createATPG 'DG_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgScheduledTasks')
    exec asisp_createATPG 'DG_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'DG_CreatePgRODM')
    exec asisp_createATPG 'DG_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=DG)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=ICND, CNAME=interchangeNode, LABEL='interchangeNode', DESCRIPTION='SNA node that has both the type-5 node function of a subarea node, including an SSCP, and the type 2.1 node function of an APPN network node. The interchange node provides the capability  to interconnect an SNA subarea network and an APPN network.') */

  if not exists (select * from link_type where link_type='ICND')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'ICND', 'interchangeNode Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='ICND')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'ICND', 'interchangeNode', 'interchangeNode', 'SNA node that has both the type-5 node function of a subarea node, including an SSCP, and the type 2.1 node function of an APPN network node. The interchange node provides the capability  to interconnect an SNA subarea network and an APPN network.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'ICND') <> 'interchangeNode'
    begin
      raiserror('Error defining class ICND. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'interchangeNode', description = 'SNA node that has both the type-5 node function of a subarea node, including an SSCP, and the type 2.1 node function of an APPN network node. The interchange node provides the capability  to interconnect an SNA subarea network and an APPN network.'
      where cid = 'ICND' and (label <> 'interchangeNode' or description <> 'SNA node that has both the type-5 node function of a subarea node, including an SSCP, and the type 2.1 node function of an APPN network node. The interchange node provides the capability  to interconnect an SNA subarea network and an APPN network.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=ICND, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'ICND' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'ICND', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'ICND' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=ICND)

if not exists (select * from isa where cid = 'ICND')
begin
  raiserror('No isa relationship has been established for cid ICND -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=ICND)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_ICND' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_ICND'
    exec("
    create table STCR_ATPG_ICND
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_ICND_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_ICND_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_ICND_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_ICND to public
    grant delete on STCR_ATPG_ICND to public
    grant select on STCR_ATPG_ICND to public
    grant update on STCR_ATPG_ICND to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_ICND'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'ICND')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ICND on STCR_ATPG_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_ICND on STCR_ATPG_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgBusinessObject')
    exec asisp_createATPG 'ICND_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgChildEvents')
    exec asisp_createATPG 'ICND_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgExceptions')
    exec asisp_createATPG 'ICND_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgDefineMsgs')
    exec asisp_createATPG 'ICND_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgScheduledTasks')
    exec asisp_createATPG 'ICND_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'ICND_CreatePgRODM')
    exec asisp_createATPG 'ICND_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=ICND)
end
  -- IS_A(DERIVED_CID=ICND, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'ICND' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'ICND', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=LENN, CNAME=lenNode, LABEL='lenNode', DESCRIPTION='Low-Entry Networking. SNA type 2.1 node that: Supports its users and provides the following services: link-connection, local directory and management.') */

  if not exists (select * from link_type where link_type='LENN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'LENN', 'lenNode Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='LENN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'LENN', 'lenNode', 'lenNode', 'Low-Entry Networking. SNA type 2.1 node that: Supports its users and provides the following services: link-connection, local directory and management.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'LENN') <> 'lenNode'
    begin
      raiserror('Error defining class LENN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'lenNode', description = 'Low-Entry Networking. SNA type 2.1 node that: Supports its users and provides the following services: link-connection, local directory and management.'
      where cid = 'LENN' and (label <> 'lenNode' or description <> 'Low-Entry Networking. SNA type 2.1 node that: Supports its users and provides the following services: link-connection, local directory and management.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=LENN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'LENN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'LENN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'LENN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=LENN)

if not exists (select * from isa where cid = 'LENN')
begin
  raiserror('No isa relationship has been established for cid LENN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=LENN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_LENN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_LENN'
    exec("
    create table STCR_ATPG_LENN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_LENN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_LENN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_LENN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_LENN to public
    grant delete on STCR_ATPG_LENN to public
    grant select on STCR_ATPG_LENN to public
    grant update on STCR_ATPG_LENN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_LENN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'LENN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LENN on STCR_ATPG_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LENN on STCR_ATPG_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgBusinessObject')
    exec asisp_createATPG 'LENN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgChildEvents')
    exec asisp_createATPG 'LENN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgExceptions')
    exec asisp_createATPG 'LENN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgDefineMsgs')
    exec asisp_createATPG 'LENN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgScheduledTasks')
    exec asisp_createATPG 'LENN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'LENN_CreatePgRODM')
    exec asisp_createATPG 'LENN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=LENN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=LL, CNAME=logicalLink, LABEL='logicalLink', DESCRIPTION='Provides a connection between two logically adjacent nodes.') */

  if not exists (select * from link_type where link_type='LL')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'LL', 'logicalLink Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='LL')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'LL', 'logicalLink', 'logicalLink', 'Provides a connection between two logically adjacent nodes.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'LL') <> 'logicalLink'
    begin
      raiserror('Error defining class LL. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'logicalLink', description = 'Provides a connection between two logically adjacent nodes.'
      where cid = 'LL' and (label <> 'logicalLink' or description <> 'Provides a connection between two logically adjacent nodes.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=LL, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'LL' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'LL', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'LL' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=LL)

if not exists (select * from isa where cid = 'LL')
begin
  raiserror('No isa relationship has been established for cid LL -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=LL)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_LL' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_LL'
    exec("
    create table STCR_ATPG_LL
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_LL_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_LL_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_LL_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_LL to public
    grant delete on STCR_ATPG_LL to public
    grant select on STCR_ATPG_LL to public
    grant update on STCR_ATPG_LL to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_LL'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'LL')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LL on STCR_ATPG_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LL on STCR_ATPG_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgBusinessObject')
    exec asisp_createATPG 'LL_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgChildEvents')
    exec asisp_createATPG 'LL_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgExceptions')
    exec asisp_createATPG 'LL_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgDefineMsgs')
    exec asisp_createATPG 'LL_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgScheduledTasks')
    exec asisp_createATPG 'LL_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'LL_CreatePgRODM')
    exec asisp_createATPG 'LL_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=LL)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=LU, CNAME=logicalUnit, LABEL='logicalUnit', DESCRIPTION='Access point for applications, transaction programs, and end-users to the network.') */

  if not exists (select * from link_type where link_type='LU')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'LU', 'logicalUnit Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='LU')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'LU', 'logicalUnit', 'logicalUnit', 'Access point for applications, transaction programs, and end-users to the network.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'LU') <> 'logicalUnit'
    begin
      raiserror('Error defining class LU. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'logicalUnit', description = 'Access point for applications, transaction programs, and end-users to the network.'
      where cid = 'LU' and (label <> 'logicalUnit' or description <> 'Access point for applications, transaction programs, and end-users to the network.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=LU, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'LU' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'LU', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'LU' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=LU)

if not exists (select * from isa where cid = 'LU')
begin
  raiserror('No isa relationship has been established for cid LU -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=LU)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_LU' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_LU'
    exec("
    create table STCR_ATPG_LU
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_LU_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_LU_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_LU_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_LU to public
    grant delete on STCR_ATPG_LU to public
    grant select on STCR_ATPG_LU to public
    grant update on STCR_ATPG_LU to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_LU'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'LU')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LU on STCR_ATPG_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_LU on STCR_ATPG_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgBusinessObject')
    exec asisp_createATPG 'LU_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgChildEvents')
    exec asisp_createATPG 'LU_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgExceptions')
    exec asisp_createATPG 'LU_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgDefineMsgs')
    exec asisp_createATPG 'LU_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgScheduledTasks')
    exec asisp_createATPG 'LU_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'LU_CreatePgRODM')
    exec asisp_createATPG 'LU_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=LU)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=MDH, CNAME=migrationDataHost, LABEL='migrationDataHost', DESCRIPTION='SNA node that has both the type-5 node function of a subarea node, including  an SSCP, and the type 2.1 node function of an APPN end node.') */

  if not exists (select * from link_type where link_type='MDH')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'MDH', 'migrationDataHost Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='MDH')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'MDH', 'migrationDataHost', 'migrationDataHost', 'SNA node that has both the type-5 node function of a subarea node, including  an SSCP, and the type 2.1 node function of an APPN end node.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'MDH') <> 'migrationDataHost'
    begin
      raiserror('Error defining class MDH. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'migrationDataHost', description = 'SNA node that has both the type-5 node function of a subarea node, including  an SSCP, and the type 2.1 node function of an APPN end node.'
      where cid = 'MDH' and (label <> 'migrationDataHost' or description <> 'SNA node that has both the type-5 node function of a subarea node, including  an SSCP, and the type 2.1 node function of an APPN end node.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=MDH, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'MDH' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'MDH', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'MDH' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=MDH)

if not exists (select * from isa where cid = 'MDH')
begin
  raiserror('No isa relationship has been established for cid MDH -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=MDH)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_MDH' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_MDH'
    exec("
    create table STCR_ATPG_MDH
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_MDH_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_MDH_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_MDH_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_MDH to public
    grant delete on STCR_ATPG_MDH to public
    grant select on STCR_ATPG_MDH to public
    grant update on STCR_ATPG_MDH to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_MDH'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'MDH')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_MDH on STCR_ATPG_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_MDH on STCR_ATPG_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgBusinessObject')
    exec asisp_createATPG 'MDH_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgChildEvents')
    exec asisp_createATPG 'MDH_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgExceptions')
    exec asisp_createATPG 'MDH_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgDefineMsgs')
    exec asisp_createATPG 'MDH_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgScheduledTasks')
    exec asisp_createATPG 'MDH_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'MDH_CreatePgRODM')
    exec asisp_createATPG 'MDH_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=MDH)
end
  -- IS_A(DERIVED_CID=MDH, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'MDH' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'MDH', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=NVPT, CNAME=NetViewPort, LABEL='port', DESCRIPTION='Provides a data link control (DLC) connection point within a node for a logical link') */

  if not exists (select * from link_type where link_type='NVPT')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'NVPT', 'NetViewPort Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='NVPT')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'NVPT', 'NetViewPort', 'port', 'Provides a data link control (DLC) connection point within a node for a logical link'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'NVPT') <> 'NetViewPort'
    begin
      raiserror('Error defining class NVPT. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'port', description = 'Provides a data link control (DLC) connection point within a node for a logical link'
      where cid = 'NVPT' and (label <> 'port' or description <> 'Provides a data link control (DLC) connection point within a node for a logical link')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=NVPT, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'NVPT' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'NVPT', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'NVPT' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=NVPT)

if not exists (select * from isa where cid = 'NVPT')
begin
  raiserror('No isa relationship has been established for cid NVPT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=NVPT)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_NVPT' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_NVPT'
    exec("
    create table STCR_ATPG_NVPT
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_NVPT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_NVPT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_NVPT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_NVPT to public
    grant delete on STCR_ATPG_NVPT to public
    grant select on STCR_ATPG_NVPT to public
    grant update on STCR_ATPG_NVPT to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_NVPT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'NVPT')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NVPT on STCR_ATPG_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_NVPT on STCR_ATPG_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgBusinessObject')
    exec asisp_createATPG 'NVPT_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgChildEvents')
    exec asisp_createATPG 'NVPT_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgExceptions')
    exec asisp_createATPG 'NVPT_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgDefineMsgs')
    exec asisp_createATPG 'NVPT_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgScheduledTasks')
    exec asisp_createATPG 'NVPT_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'NVPT_CreatePgRODM')
    exec asisp_createATPG 'NVPT_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=NVPT)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=SNAN, CNAME=snaNode, LABEL='snaNode', DESCRIPTION='Used when the class of a node object is unknown. This class is used when the SNA topology manager is monitoring an individual logicalUnit or luCollection and the owning node''s name is known, but the class of the owning node is not known.') */

  if not exists (select * from link_type where link_type='SNAN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'SNAN', 'snaNode Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='SNAN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'SNAN', 'snaNode', 'snaNode', 'Used when the class of a node object is unknown. This class is used when the SNA topology manager is monitoring an individual logicalUnit or luCollection and the owning node''s name is known, but the class of the owning node is not known.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'SNAN') <> 'snaNode'
    begin
      raiserror('Error defining class SNAN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'snaNode', description = 'Used when the class of a node object is unknown. This class is used when the SNA topology manager is monitoring an individual logicalUnit or luCollection and the owning node''s name is known, but the class of the owning node is not known.'
      where cid = 'SNAN' and (label <> 'snaNode' or description <> 'Used when the class of a node object is unknown. This class is used when the SNA topology manager is monitoring an individual logicalUnit or luCollection and the owning node''s name is known, but the class of the owning node is not known.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=SNAN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'SNAN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'SNAN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'SNAN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=SNAN)

if not exists (select * from isa where cid = 'SNAN')
begin
  raiserror('No isa relationship has been established for cid SNAN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=SNAN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_SNAN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_SNAN'
    exec("
    create table STCR_ATPG_SNAN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_SNAN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_SNAN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_SNAN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_SNAN to public
    grant delete on STCR_ATPG_SNAN to public
    grant select on STCR_ATPG_SNAN to public
    grant update on STCR_ATPG_SNAN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_SNAN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'SNAN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_SNAN on STCR_ATPG_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_SNAN on STCR_ATPG_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgBusinessObject')
    exec asisp_createATPG 'SNAN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgChildEvents')
    exec asisp_createATPG 'SNAN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgExceptions')
    exec asisp_createATPG 'SNAN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgDefineMsgs')
    exec asisp_createATPG 'SNAN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgScheduledTasks')
    exec asisp_createATPG 'SNAN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'SNAN_CreatePgRODM')
    exec asisp_createATPG 'SNAN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=SNAN)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=T21N, CNAME=t21Node, LABEL='t2-1Node', DESCRIPTION='Represents an adjacent node defined to the reporting agent node, where: the adjacent node type is not yet known to the agent node or the topology manager; or a logical link between the agent node and the adjacent node has not been activated.') */

  if not exists (select * from link_type where link_type='T21N')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'T21N', 't21Node Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='T21N')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'T21N', 't21Node', 't2-1Node', 'Represents an adjacent node defined to the reporting agent node, where: the adjacent node type is not yet known to the agent node or the topology manager; or a logical link between the agent node and the adjacent node has not been activated.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'T21N') <> 't21Node'
    begin
      raiserror('Error defining class T21N. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 't2-1Node', description = 'Represents an adjacent node defined to the reporting agent node, where: the adjacent node type is not yet known to the agent node or the topology manager; or a logical link between the agent node and the adjacent node has not been activated.'
      where cid = 'T21N' and (label <> 't2-1Node' or description <> 'Represents an adjacent node defined to the reporting agent node, where: the adjacent node type is not yet known to the agent node or the topology manager; or a logical link between the agent node and the adjacent node has not been activated.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=T21N, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'T21N' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T21N', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'T21N' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=T21N)

if not exists (select * from isa where cid = 'T21N')
begin
  raiserror('No isa relationship has been established for cid T21N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=T21N)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_T21N' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_T21N'
    exec("
    create table STCR_ATPG_T21N
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_T21N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_T21N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_T21N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_T21N to public
    grant delete on STCR_ATPG_T21N to public
    grant select on STCR_ATPG_T21N to public
    grant update on STCR_ATPG_T21N to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_T21N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'T21N')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T21N on STCR_ATPG_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T21N on STCR_ATPG_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgBusinessObject')
    exec asisp_createATPG 'T21N_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgChildEvents')
    exec asisp_createATPG 'T21N_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgExceptions')
    exec asisp_createATPG 'T21N_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgDefineMsgs')
    exec asisp_createATPG 'T21N_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgScheduledTasks')
    exec asisp_createATPG 'T21N_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'T21N_CreatePgRODM')
    exec asisp_createATPG 'T21N_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=T21N)
end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=T4N, CNAME=t4Node, LABEL='t4Node', DESCRIPTION='Used to interconnect subarea networks. A gateway node translates between the network name and address used by one subarea network to represent a resource, and the network name and address used by another subarea network to represent the same resource.') */

  if not exists (select * from link_type where link_type='T4N')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'T4N', 't4Node Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='T4N')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'T4N', 't4Node', 't4Node', 'Used to interconnect subarea networks. A gateway node translates between the network name and address used by one subarea network to represent a resource, and the network name and address used by another subarea network to represent the same resource.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'T4N') <> 't4Node'
    begin
      raiserror('Error defining class T4N. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 't4Node', description = 'Used to interconnect subarea networks. A gateway node translates between the network name and address used by one subarea network to represent a resource, and the network name and address used by another subarea network to represent the same resource.'
      where cid = 'T4N' and (label <> 't4Node' or description <> 'Used to interconnect subarea networks. A gateway node translates between the network name and address used by one subarea network to represent a resource, and the network name and address used by another subarea network to represent the same resource.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=T4N, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'T4N' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T4N', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'T4N' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=T4N)

if not exists (select * from isa where cid = 'T4N')
begin
  raiserror('No isa relationship has been established for cid T4N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=T4N)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_T4N' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_T4N'
    exec("
    create table STCR_ATPG_T4N
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_T4N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_T4N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_T4N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_T4N to public
    grant delete on STCR_ATPG_T4N to public
    grant select on STCR_ATPG_T4N to public
    grant update on STCR_ATPG_T4N to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_T4N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'T4N')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T4N on STCR_ATPG_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T4N on STCR_ATPG_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgBusinessObject')
    exec asisp_createATPG 'T4N_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgChildEvents')
    exec asisp_createATPG 'T4N_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgExceptions')
    exec asisp_createATPG 'T4N_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgDefineMsgs')
    exec asisp_createATPG 'T4N_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgScheduledTasks')
    exec asisp_createATPG 'T4N_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'T4N_CreatePgRODM')
    exec asisp_createATPG 'T4N_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=T4N)
end
  -- IS_A(DERIVED_CID=T4N, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'T4N' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T4N', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=T4NG, CNAME=t4NodeGateway, LABEL='t4NodeGateway', DESCRIPTION='SNA type-4 node that provides communication controller support for single-domain, multiple-domain, and interconnected network capability. It can also provide gateway function, intermediate routing function, and boundary function') */

  if not exists (select * from link_type where link_type='T4NG')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'T4NG', 't4NodeGateway Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='T4NG')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'T4NG', 't4NodeGateway', 't4NodeGateway', 'SNA type-4 node that provides communication controller support for single-domain, multiple-domain, and interconnected network capability. It can also provide gateway function, intermediate routing function, and boundary function'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'T4NG') <> 't4NodeGateway'
    begin
      raiserror('Error defining class T4NG. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 't4NodeGateway', description = 'SNA type-4 node that provides communication controller support for single-domain, multiple-domain, and interconnected network capability. It can also provide gateway function, intermediate routing function, and boundary function'
      where cid = 'T4NG' and (label <> 't4NodeGateway' or description <> 'SNA type-4 node that provides communication controller support for single-domain, multiple-domain, and interconnected network capability. It can also provide gateway function, intermediate routing function, and boundary function')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=T4NG, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'T4NG' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T4NG', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'T4NG' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=T4NG)

if not exists (select * from isa where cid = 'T4NG')
begin
  raiserror('No isa relationship has been established for cid T4NG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=T4NG)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_T4NG' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_T4NG'
    exec("
    create table STCR_ATPG_T4NG
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_T4NG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_T4NG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_T4NG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_T4NG to public
    grant delete on STCR_ATPG_T4NG to public
    grant select on STCR_ATPG_T4NG to public
    grant update on STCR_ATPG_T4NG to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_T4NG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'T4NG')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T4NG on STCR_ATPG_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T4NG on STCR_ATPG_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgBusinessObject')
    exec asisp_createATPG 'T4NG_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgChildEvents')
    exec asisp_createATPG 'T4NG_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgExceptions')
    exec asisp_createATPG 'T4NG_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgDefineMsgs')
    exec asisp_createATPG 'T4NG_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgScheduledTasks')
    exec asisp_createATPG 'T4NG_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'T4NG_CreatePgRODM')
    exec asisp_createATPG 'T4NG_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=T4NG)
end
  -- IS_A(DERIVED_CID=T4NG, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'T4NG' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T4NG', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end

---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=T5N, CNAME=t5Node, LABEL='t5Node', DESCRIPTION='Represents a type-5 SNA node. A type-5 node is a subarea node containing an SSCP that has hierarchical control of type 4 nodes and peripheral nodes. A type-5 node is usually referred to as a host node.') */

  if not exists (select * from link_type where link_type='T5N')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'T5N', 't5Node Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='T5N')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'T5N', 't5Node', 't5Node', 'Represents a type-5 SNA node. A type-5 node is a subarea node containing an SSCP that has hierarchical control of type 4 nodes and peripheral nodes. A type-5 node is usually referred to as a host node.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'T5N') <> 't5Node'
    begin
      raiserror('Error defining class T5N. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 't5Node', description = 'Represents a type-5 SNA node. A type-5 node is a subarea node containing an SSCP that has hierarchical control of type 4 nodes and peripheral nodes. A type-5 node is usually referred to as a host node.'
      where cid = 'T5N' and (label <> 't5Node' or description <> 'Represents a type-5 SNA node. A type-5 node is a subarea node containing an SSCP that has hierarchical control of type 4 nodes and peripheral nodes. A type-5 node is usually referred to as a host node.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=T5N, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'T5N' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T5N', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'T5N' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=T5N)

if not exists (select * from isa where cid = 'T5N')
begin
  raiserror('No isa relationship has been established for cid T5N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=ATPG, 'PHYC'=T5N)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_T5N' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_T5N'
    exec("
    create table STCR_ATPG_T5N
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_T5N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_T5N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_T5N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_T5N to public
    grant delete on STCR_ATPG_T5N to public
    grant select on STCR_ATPG_T5N to public
    grant update on STCR_ATPG_T5N to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_T5N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'T5N')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T5N on STCR_ATPG_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_T5N on STCR_ATPG_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgBusinessObject')
    exec asisp_createATPG 'T5N_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgChildEvents')
    exec asisp_createATPG 'T5N_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgExceptions')
    exec asisp_createATPG 'T5N_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgDefineMsgs')
    exec asisp_createATPG 'T5N_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgScheduledTasks')
    exec asisp_createATPG 'T5N_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'T5N_CreatePgRODM')
    exec asisp_createATPG 'T5N_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=T5N)
end
  -- IS_A(DERIVED_CID=T5N, BASE_CID=SHLO)
  if not exists (select * from isa where cid = 'T5N' and base_cid = 'SHLO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'T5N', 'SHLO',0
    exec Meta..asisp_make_isa_chain
  end
  -- OBJ_LINK(TYPE='PHYC', SRC='T5N', DST='LU')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='T5N' AND dst_cid='LU')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'T5N', 'LU' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'T5N', 'LU')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END



  -- OBJ_LINK(TYPE='PHYC', SRC='T5N', DST='XDRM')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='PHYC' AND src_cid='T5N' AND dst_cid='XDRM')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'PHYC', 'T5N', 'XDRM' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'PHYC', 'T5N', 'XDRM')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END




---------------------------------------------------------------------------------------------------

/* OBJECT_CLASS(CID=VRN, CNAME=virtualRoutingNode, LABEL='virtualRoutingNode', DESCRIPTION='Connection network used in an APPN network, not a node. Used by APPN nodes to calculate and establish direct routes for sessions between origin and destination nodes within a shared-access transport facility, such as a token-ring LAN.') */

  if not exists (select * from link_type where link_type='VRN')
  begin
    print 'Defining new link_type record'
    insert link_type(link_type, description, flags) select 'VRN', 'virtualRoutingNode Static Link', 1
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  if not exists (select * from obj_class where cid='VRN')
  begin
    print 'Defining new obj_class record'
    insert obj_class(cid, cname, label, description) select 'VRN', 'virtualRoutingNode', 'virtualRoutingNode', 'Connection network used in an APPN network, not a node. Used by APPN nodes to calculate and establish direct routes for sessions between origin and destination nodes within a shared-access transport facility, such as a token-ring LAN.'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end
  else
  begin
    -- Make sure the class name has not changed
    if (select cname from obj_class where cid = 'VRN') <> 'virtualRoutingNode'
    begin
      raiserror('Error defining class VRN. Cannot change the name of an existing class', 3, 1)
    end
    else -- update label and description fields
    begin
      update obj_class set label = 'virtualRoutingNode', description = 'Connection network used in an APPN network, not a node. Used by APPN nodes to calculate and establish direct routes for sessions between origin and destination nodes within a shared-access transport facility, such as a token-ring LAN.'
      where cid = 'VRN' and (label <> 'virtualRoutingNode' or description <> 'Connection network used in an APPN network, not a node. Used by APPN nodes to calculate and establish direct routes for sessions between origin and destination nodes within a shared-access transport facility, such as a token-ring LAN.')
      if @@rowcount > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    end
  end
-- IS_A(DERIVED_CID=VRN, BASE_CID=RDSO)
  if not exists (select * from isa where cid = 'VRN' and base_cid = 'RDSO')
  begin
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
    insert isa(cid, base_cid,flags) select 'VRN', 'RDSO',0
    exec Meta..asisp_make_isa_chain
  end
update obj_class set flag_consolidated=1 where cid = 'VRN' and flag_consolidated<>1
  if @@rowcount > 0
    UPDATE Meta..DatabaseVersion SET verno = verno + 1






-- BEGIN_ATTRIBUTE_PAGES(CID=VRN)

if not exists (select * from isa where cid = 'VRN')
begin
  raiserror('No isa relationship has been established for cid VRN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('T5N'=STCR, 'XDRM'=ATPG, 'PHYC'=VRN)
  if not exists (select * from sysobjects where name = 'STCR_ATPG_VRN' and type = 'U')
  begin
    print 'Creating table STCR_ATPG_VRN'
    exec("
    create table STCR_ATPG_VRN
    (
      src_id       ObjID    CONSTRAINT STCR_ATPG_VRN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_ATPG_VRN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_ATPG_VRN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_ATPG_VRN to public
    grant delete on STCR_ATPG_VRN to public
    grant select on STCR_ATPG_VRN to public
    grant update on STCR_ATPG_VRN to public
    ")
  end
  print 'Creating trigger tI_STCR_ATPG_VRN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'ATPG' AND dol.link_type = 'VRN')
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_VRN on STCR_ATPG_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'ATPG', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_ATPG_VRN on STCR_ATPG_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'ATPG', dst_id FROM inserted
  ")

  -- ATTRIBUTE_PAGE(NAME=CreatePgBusinessObject, ORDER=0)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgBusinessObject')
    exec asisp_createATPG 'VRN_CreatePgBusinessObject', STCR, 1, 'access1.exe', 'CreatePgBusinessObject', 0
  -- ATTRIBUTE_PAGE(NAME=CreatePgChildEvents, ORDER=1)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgChildEvents')
    exec asisp_createATPG 'VRN_CreatePgChildEvents', STCR, 1, 'access1.exe', 'CreatePgChildEvents', 1
  -- ATTRIBUTE_PAGE(NAME=CreatePgExceptions, ORDER=2)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgExceptions')
    exec asisp_createATPG 'VRN_CreatePgExceptions', STCR, 1, 'access1.exe', 'CreatePgExceptions', 2
  -- ATTRIBUTE_PAGE(NAME=CreatePgDefineMsgs, ORDER=3)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgDefineMsgs')
    exec asisp_createATPG 'VRN_CreatePgDefineMsgs', STCR, 1, 'access1.exe', 'CreatePgDefineMsgs', 3
  -- ATTRIBUTE_PAGE(NAME=CreatePgScheduledTasks, ORDER=4)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgScheduledTasks')
    exec asisp_createATPG 'VRN_CreatePgScheduledTasks', STCR, 1, 'access1.exe', 'CreatePgScheduledTasks', 4
  -- ATTRIBUTE_PAGE(NAME=CreatePgRODM, ORDER=5)
  if not exists (select * from AttributePageSpec_V where name = 'VRN_CreatePgRODM')
    exec asisp_createATPG 'VRN_CreatePgRODM', STCR, 1, 'access1.exe', 'CreatePgRODM', 5
-- END_ATTRIBUTE_PAGES(CID=VRN)
end


-- BEGIN_LINKS(CID=NNDN)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='NNDN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='NNDN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'NNDN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'NNDN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- NNDN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDM', DST='NNDN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDM' AND dst_cid='NNDN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDM', 'NNDN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDM', 'NNDN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- NNDN
-- END_LINKS(CID=NNDN)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=NNDC)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDN', DST='NNDC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDN' AND dst_cid='NNDC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDN', 'NNDC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDN', 'NNDC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- NNDC
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDN', DST='NNDC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDN' AND dst_cid='NNDC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDN', 'NNDC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDN', 'NNDC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- NNDC
-- END_LINKS(CID=NNDC)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=APEN)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDM', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDM' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDM', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDM', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDC', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDC' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDC', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDC', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MMBR', SRC='ENLT', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='ENLT' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'ENLT', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'ENLT', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNLT', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNLT' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNLT', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNLT', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MAGC', SRC='T4N', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='T4N' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'T4N', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'T4N', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
  -- OBJ_LINK(TYPE='MAGC', SRC='T4NG', DST='APEN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='T4NG' AND dst_cid='APEN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'T4NG', 'APEN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'T4NG', 'APEN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APEN
-- END_LINKS(CID=APEN)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=APNN)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='APNN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='APNN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'APNN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'APNN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APNN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDM', DST='APNN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDM' AND dst_cid='APNN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDM', 'APNN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDM', 'APNN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APNN
  -- OBJ_LINK(TYPE='MMBR', SRC='ENLT', DST='APNN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='ENLT' AND dst_cid='APNN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'ENLT', 'APNN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'ENLT', 'APNN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APNN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNLT', DST='APNN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNLT' AND dst_cid='APNN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNLT', 'APNN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNLT', 'APNN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APNN
-- END_LINKS(CID=APNN)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=APTG)

  -- OBJ_LINK(TYPE='SATG', SRC='APNN', DST='APTG')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='SATG' AND src_cid='APNN' AND dst_cid='APTG')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'SATG', 'APNN', 'APTG' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'SATG', 'APNN', 'APTG')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APTG
  -- OBJ_LINK(TYPE='SATG', SRC='ICND', DST='APTG')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='SATG' AND src_cid='ICND' AND dst_cid='APTG')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'SATG', 'ICND', 'APTG' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'SATG', 'ICND', 'APTG')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APTG
  -- OBJ_LINK(TYPE='SATG', SRC='MDH', DST='APTG')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='SATG' AND src_cid='MDH' AND dst_cid='APTG')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'SATG', 'MDH', 'APTG' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'SATG', 'MDH', 'APTG')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APTG
  -- OBJ_LINK(TYPE='SATG', SRC='T4N', DST='APTG')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='SATG' AND src_cid='T4N' AND dst_cid='APTG')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'SATG', 'T4N', 'APTG' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'SATG', 'T4N', 'APTG')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APTG
  -- OBJ_LINK(TYPE='SATG', SRC='T4NG', DST='APTG')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='SATG' AND src_cid='T4NG' AND dst_cid='APTG')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'SATG', 'T4NG', 'APTG' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'SATG', 'T4NG', 'APTG')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- APTG
-- END_LINKS(CID=APTG)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=IDNC)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
  -- OBJ_LINK(TYPE='MAGC', SRC='NNDN', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDN' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDN', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDN', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
  -- OBJ_LINK(TYPE='MAGC', SRC='NNDC', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDC' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDC', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDC', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
  -- OBJ_LINK(TYPE='MMBA', SRC='NNDM', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBA' AND src_cid='NNDM' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBA', 'NNDM', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBA', 'NNDM', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
  -- OBJ_LINK(TYPE='MMBA', SRC='NNDN', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBA' AND src_cid='NNDN' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBA', 'NNDN', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBA', 'NNDN', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
  -- OBJ_LINK(TYPE='MMBA', SRC='NNDC', DST='IDNC')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBA' AND src_cid='NNDC' AND dst_cid='IDNC')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBA', 'NNDC', 'IDNC' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBA', 'NNDC', 'IDNC')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- IDNC
-- END_LINKS(CID=IDNC)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=ICND)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='ICND')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='ICND')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'ICND' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'ICND')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- ICND
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDM', DST='ICND')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDM' AND dst_cid='ICND')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDM', 'ICND' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDM', 'ICND')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- ICND
  -- OBJ_LINK(TYPE='MMBR', SRC='ENLT', DST='ICND')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='ENLT' AND dst_cid='ICND')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'ENLT', 'ICND' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'ENLT', 'ICND')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- ICND
  -- OBJ_LINK(TYPE='MMBR', SRC='NNLT', DST='ICND')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNLT' AND dst_cid='ICND')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNLT', 'ICND' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNLT', 'ICND')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- ICND
-- END_LINKS(CID=ICND)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=MDH)

  -- OBJ_LINK(TYPE='MAGC', SRC='NNDM', DST='MDH')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MAGC' AND src_cid='NNDM' AND dst_cid='MDH')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MAGC', 'NNDM', 'MDH' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MAGC', 'NNDM', 'MDH')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- MDH
  -- OBJ_LINK(TYPE='MMBR', SRC='NNDM', DST='MDH')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNDM' AND dst_cid='MDH')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNDM', 'MDH' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNDM', 'MDH')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- MDH
  -- OBJ_LINK(TYPE='MMBR', SRC='ENLT', DST='MDH')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='ENLT' AND dst_cid='MDH')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'ENLT', 'MDH' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'ENLT', 'MDH')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- MDH
  -- OBJ_LINK(TYPE='MMBR', SRC='NNLT', DST='MDH')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNLT' AND dst_cid='MDH')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNLT', 'MDH' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNLT', 'MDH')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- MDH
-- END_LINKS(CID=MDH)
  exec Meta..asisp_make_isa_chain
go

-- BEGIN_LINKS(CID=VRN)

  -- OBJ_LINK(TYPE='MMBR', SRC='ENLT', DST='VRN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='ENLT' AND dst_cid='VRN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'ENLT', 'VRN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'ENLT', 'VRN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- VRN
  -- OBJ_LINK(TYPE='MMBR', SRC='NNLT', DST='VRN')
  IF NOT EXISTS (SELECT * FROM obj_link WHERE link_type='MMBR' AND src_cid='NNLT' AND dst_cid='VRN')
  BEGIN
    INSERT INTO obj_link(link_type, src_cid, dst_cid) VALUES ( 'MMBR', 'NNLT', 'VRN' )
    IF @@ERROR <> 0
    BEGIN
      RAISERROR('Could not insert obj_link(link_type, src_cid, dst_cid) VALUES (''%s'', ''%s'', ''%s'')', 3, 1, 'MMBR', 'NNLT', 'VRN')
    END
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


 -- VRN
-- END_LINKS(CID=VRN)
  exec Meta..asisp_make_isa_chain
go


-- BEGIN_METHOD(NAME=RODMRegister, DESCRIPTION='Sends registration statements for RODM-managed objects', LABEL='RODM Register')
  IF NOT EXISTS (SELECT * FROM method WHERE mname = 'RODMRegister')
  BEGIN
    PRINT 'Defining method RODMRegister'
    INSERT INTO method(mid, mname, description, label)
      SELECT
        MAX(mid)+1,
        'RODMRegister',
        'Sends registration statements for RODM-managed objects',
        'RODM Register'
      FROM method
      WHERE mid < 0x40000000
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END
  ELSE
  BEGIN
    UPDATE method SET
      description = 'Sends registration statements for RODM-managed objects',
      label = 'RODM Register'
    WHERE
      mname = 'RODMRegister'
      AND
      (
        description <> 'Sends registration statements for RODM-managed objects'
        OR
        label <> 'RODM Register'
      )
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  END


  BEGIN /* METHOD_PARAM(NAME=RegistrationStatus, 'MMBR'=ASIVARIANT, DESCRIPTION='Specifies the registration action (Unregister, Register, Reregister)', LABEL='Status') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'RODMRegister' and pname = 'RegistrationStatus')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'RegistrationStatus', 'ASIVARIANT', 'Specifies the registration action (Unregister, Register, Reregister)', 'Status'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'RODMRegister'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'ASIVARIANT', mp.description = 'Specifies the registration action (Unregister, Register, Reregister)', mp.label = 'Status'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'RegistrationStatus' AND m.mname = 'RODMRegister'
        AND (mp.ptype <> 'ASIVARIANT' OR mp.description <> 'Specifies the registration action (Unregister, Register, Reregister)' OR mp.label <> 'Status')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=RegistrationStatus)
    -- METHOD_PARAM_FLAG(FLAG=input)
    UPDATE mp SET flag_input = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'RODMRegister' AND mp.pname = 'RegistrationStatus' AND flag_input = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  BEGIN /* METHOD_PARAM(NAME=RegistrationScope, 'MMBR'=ASIVARIANT, DESCRIPTION='Specifies whether child objects are to be registered', LABEL='Scope') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'RODMRegister' and pname = 'RegistrationScope')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'RegistrationScope', 'ASIVARIANT', 'Specifies whether child objects are to be registered', 'Scope'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'RODMRegister'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'ASIVARIANT', mp.description = 'Specifies whether child objects are to be registered', mp.label = 'Scope'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'RegistrationScope' AND m.mname = 'RODMRegister'
        AND (mp.ptype <> 'ASIVARIANT' OR mp.description <> 'Specifies whether child objects are to be registered' OR mp.label <> 'Scope')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=RegistrationScope)
    -- METHOD_PARAM_FLAG(FLAG=input)
    UPDATE mp SET flag_input = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'RODMRegister' AND mp.pname = 'RegistrationScope' AND flag_input = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  BEGIN /* METHOD_PARAM(NAME=ResponseType, 'MMBR'=ASIVARIANT, DESCRIPTION='Specifies the type of response required from the registration', LABEL='Response Type') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'RODMRegister' and pname = 'ResponseType')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'ResponseType', 'ASIVARIANT', 'Specifies the type of response required from the registration', 'Response Type'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'RODMRegister'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'ASIVARIANT', mp.description = 'Specifies the type of response required from the registration', mp.label = 'Response Type'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'ResponseType' AND m.mname = 'RODMRegister'
        AND (mp.ptype <> 'ASIVARIANT' OR mp.description <> 'Specifies the type of response required from the registration' OR mp.label <> 'Response Type')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=ResponseType)
    -- METHOD_PARAM_FLAG(FLAG=input)
    UPDATE mp SET flag_input = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'RODMRegister' AND mp.pname = 'ResponseType' AND flag_input = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
  BEGIN /* METHOD_PARAM(NAME=Objects, 'MMBR'=OBJID, DESCRIPTION='Optional specific list of objects to register.', LABEL='Objects') */

    IF NOT EXISTS (SELECT * FROM method_param AS mp JOIN method AS m ON mp.mid = m.mid WHERE m.mname = 'RODMRegister' and pname = 'Objects')
    BEGIN
      INSERT INTO method_param(mid, pid, pname, ptype, description, label)
        SELECT m.mid, isnull(max(pid),0)+1, 'Objects', 'OBJID', 'Optional specific list of objects to register.', 'Objects'
        FROM method AS m LEFT OUTER JOIN method_param AS mp ON mp.mid = m.mid
        WHERE m.mname = 'RODMRegister'
        GROUP BY m.mid
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
    ELSE
    BEGIN
      UPDATE mp SET mp.ptype = 'OBJID', mp.description = 'Optional specific list of objects to register.', mp.label = 'Objects'
      FROM method_param AS mp JOIN method AS m on m.mid = mp.mid
      WHERE mp.pname = 'Objects' AND m.mname = 'RODMRegister'
        AND (mp.ptype <> 'OBJID' OR mp.description <> 'Optional specific list of objects to register.' OR mp.label <> 'Objects')
      IF @@ROWCOUNT > 0
        UPDATE Meta..DatabaseVersion SET verno = verno + 1
    END
  END -- METHOD_PARAM(NAME=Objects)
    -- METHOD_PARAM_FLAG(FLAG=input)
    UPDATE mp SET flag_input = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'RODMRegister' AND mp.pname = 'Objects' AND flag_input = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
    -- METHOD_PARAM_FLAG(FLAG=collection)
    UPDATE mp SET flag_collection = 1 FROM method_param AS mp JOIN method AS m ON m.mid = mp.mid WHERE m.mname = 'RODMRegister' AND mp.pname = 'Objects' AND flag_collection = 0
    IF @@ROWCOUNT > 0
      UPDATE Meta..DatabaseVersion SET verno = verno + 1
-- END_METHOD(NAME=RODMRegister)

-- BEGIN_METHOD_CALLERS(MNAME=RODMRegister)

  -- METHOD_CALLER(CID=ENT)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'ENT' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'ENT', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=COMP)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'COMP' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'COMP', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=MACH)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'MACH' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'MACH', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=LPAR)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'LPAR' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'LPAR', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=OS)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'OS' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'OS', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=SNNT)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'SNNT' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'SNNT', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

  -- METHOD_CALLER(CID=RDMO)
  if not exists 
  (
    select * from obj_method as om join method as m on om.mid = m.mid
    where cid = 'RDMO' and mname = 'RODMRegister'
  )
  begin
    insert obj_method(cid, mid) select 'RDMO', mid from method where mname = 'RODMRegister'
    UPDATE Meta..DatabaseVersion SET verno = verno + 1
  end

-- END_METHOD_CALLERS(RODMRegister=RODMRegister)
go


-- Register the RODM audit messages on OS.
-- BEGIN_MESSAGE_DESCRIPTIONS(CID=OS, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for OS-'
  -- MESSAGE_DESCRIPTION(MESSAGE=ASI_05\01, DESCRIPTION='Audit message for RODM connection status', STATE=Unknown, ALERTSTATE=Unknown, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'OS',
  @MsgID              = 'ASI_05\01',
  @Description        = 'Audit message for RODM connection status',
  @State              = 'Unknown',
  @AlertState         = 'Unknown',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=ASI_05\02, DESCRIPTION='Audit message for RODM object registration', STATE=Unknown, ALERTSTATE=Unknown, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'OS',
  @MsgID              = 'ASI_05\02',
  @Description        = 'Audit message for RODM object registration',
  @State              = 'Unknown',
  @AlertState         = 'Unknown',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=OS)
END

-- Register the RODM connection status exception on OS
-- BEGIN_EXCEPTION_CATEGORY(CID=OS, NAME='RODM', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'OS' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM'
  )
  begin
    exec asisp_createEXCT 'RODM', STCR, 1, @Desc='RODM', @Order=0, @link_type = 'OS'
  end
  /* EXCEPTION_TYPE(EXCP=RODMSTATUS DOWN, DESC='TBSM Object Pump has lost connection to RODM', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'OS', 'RODM', 'RODMSTATUS DOWN', 'TBSM Object Pump has lost connection to RODM', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMSTATUS UP, DESC='TBSM Object Pump has restored connection to RODM', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'OS', 'RODM', 'RODMSTATUS UP', 'TBSM Object Pump has restored connection to RODM', 'Green', 'High', 0
end

-- Add RODM registration menu items to Source/390 menu tree

-- BEGIN_MENUS
  declare
    @current_menu_name      sysname,
    @current_menu_obj_cid   ClassID,
    @current_menu_obj_id    ObjID,
    @parent_menu_name       sysname,
    @parent_menu_obj_cid    ClassID,
    @parent_menu_obj_id     ObjID,
    @ret                    int,
    @parent_id              int,
    @prev_id                int

  
  -- BEGIN_MENU(NAME=Source/390_RODM, CID=SNNT, ID=0, LABEL='&RODM', FLAGS=0x40000000|0x20000000, SECURITY_KEY='', PREVIOUS_ID='MJOB/0/Source/390_ParentRegister', OVERRIDE_ID=)
  select @parent_menu_name = '',
         @parent_menu_obj_cid = '',
         @parent_menu_obj_id = 0,
         @current_menu_name = 'Source/390_RODM',
         @current_menu_obj_cid = 'SNNT',
         @current_menu_obj_id = 0
  select @parent_id = id
    from MenuItem 
    where 
      name = @parent_menu_name 
      and obj_cid = @parent_menu_obj_cid
      and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  if 'MJOB/0/Source/390_ParentRegister' <> '' and 'MJOB/0/Source/390_ParentRegister' IS NOT NULL
    exec asisp_lookupmenuitem 'MJOB/0/Source/390_ParentRegister', @prev_id OUT, @parent_id OUT
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&RODM',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1610612744,
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=Source/390_RODM_Register, CID=SNNT, ID=0, LABEL='&Register All Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=1,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'Source/390_RODM_Register', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'Source/390_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&Register All Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=1,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=Source/390_RODM_Unregister, CID=SNNT, ID=0, LABEL='&Unregister All Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=0,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'Source/390_RODM_Unregister', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'Source/390_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&Unregister All Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=0,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=Source/390_RODM_Reregister, CID=SNNT, ID=0, LABEL='R&eregister Registered Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=2,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'Source/390_RODM_Reregister', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'Source/390_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = 'R&eregister Registered Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=2,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

  
  -- END_MENU(NAME=Source/390_RODM, CID=SNNT, ID=0)
  select @prev_id = id from MenuItem where name = 'Source/390_RODM' and obj_cid = 'SNNT' and obj_id = 0
  if @@rowcount = 0
    select @prev_id = null
  select @parent_menu_name = '', @parent_menu_obj_cid = '', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id


  update MenuItemVersion set verno = verno + 1
go
-- END_MENUS



-- BEGIN_MENUS
  declare
    @current_menu_name      sysname,
    @current_menu_obj_cid   ClassID,
    @current_menu_obj_id    ObjID,
    @parent_menu_name       sysname,
    @parent_menu_obj_cid    ClassID,
    @parent_menu_obj_id     ObjID,
    @ret                    int,
    @parent_id              int,
    @prev_id                int

  
  -- BEGIN_MENU(NAME=SNANetwork_RODM, CID=SNNT, ID=0, LABEL='&RODM', FLAGS=0x40000000|0x10000000, SECURITY_KEY='ftp_settings_modify', PREVIOUS_ID='MNO2/0/Rename', OVERRIDE_ID=)
  select @parent_menu_name = '',
         @parent_menu_obj_cid = '',
         @parent_menu_obj_id = 0,
         @current_menu_name = 'SNANetwork_RODM',
         @current_menu_obj_cid = 'SNNT',
         @current_menu_obj_id = 0
  select @parent_id = id
    from MenuItem 
    where 
      name = @parent_menu_name 
      and obj_cid = @parent_menu_obj_cid
      and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  if 'MNO2/0/Rename' <> '' and 'MNO2/0/Rename' IS NOT NULL
    exec asisp_lookupmenuitem 'MNO2/0/Rename', @prev_id OUT, @parent_id OUT
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&RODM',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1342177288,
    @security     = 'ftp_settings_modify',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=SNANetwork_RODM_Register, CID=SNNT, ID=0, LABEL='&Register All Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=1,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'SNANetwork_RODM_Register', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'SNANetwork_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&Register All Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=1,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=SNANetwork_RODM_Unregister, CID=SNNT, ID=0, LABEL='&Unregister All Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=0,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'SNANetwork_RODM_Unregister', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'SNANetwork_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = '&Unregister All Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=0,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

    
  -- MENU_ITEM(NAME=SNANetwork_RODM_Reregister, CID=SNNT, ID=0, LABEL='R&eregister Registered Objects', FLAGS=(0x10000000|0x20000000|0x40000000)|0x00001000, ACTION='_RODMRegister @RegistrationStatus=2,@RegistrationScope=2,@ResponseType=1', SECURITY_KEY=, PREVIOUS_ID=, OVERRIDE_ID=)
  select @current_menu_name = 'SNANetwork_RODM_Reregister', @current_menu_obj_cid = 'SNNT', @current_menu_obj_id = 0
  select @parent_menu_name = 'SNANetwork_RODM', @parent_menu_obj_cid = 'SNNT', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id
  if @@rowcount = 0 select @parent_id = null
  
  exec @ret = asisp_definemenuitem
    @name         = @current_menu_name,
    @obj_cid      = @current_menu_obj_cid,
    @obj_id       = @current_menu_obj_id,
    @label        = 'R&eregister Registered Objects',
    @parent_id    = @parent_id,
    @prev_id      = @prev_id,
    @flags        = 1879052288,
    @control_id   = '_RODMRegister @RegistrationStatus=2,@RegistrationScope=2,@ResponseType=1',
    @security     = '',
    @override     = ''
  if @ret > 0
    select @prev_id = @ret
  else
    select @prev_id = null

  
  -- END_MENU(NAME=SNANetwork_RODM, CID=SNNT, ID=0)
  select @prev_id = id from MenuItem where name = 'SNANetwork_RODM' and obj_cid = 'SNNT' and obj_id = 0
  if @@rowcount = 0
    select @prev_id = null
  select @parent_menu_name = '', @parent_menu_obj_cid = '', @parent_menu_obj_id = 0
  select @parent_id = id from MenuItem where name = @parent_menu_name and obj_cid = @parent_menu_obj_cid and obj_id = @parent_menu_obj_id


  update MenuItemVersion set verno = verno + 1
go
-- END_MENUS


-- Performing Meta database post-update tasks
EXEC("DECLARE @NewMetaVersion INT, @OldMetaVersion INT
SELECT @OldMetaVersion = verno FROM ##MetaDatabaseVersion
SELECT @NewMetaVersion = verno FROM Meta..DatabaseVersion
IF @NewMetaVersion > @OldMetaVersion
BEGIN
  PRINT 'MetaDatabase version updated from ' + CAST(@OldMetaVersion AS VARCHAR(9)) + ' to ' + CAST(@NewMetaVersion AS VARCHAR(9)) 
  PRINT 'Rebuilding isa_chain'
  EXEC Meta..asisp_make_isa_chain
  PRINT 'Rebuilding link_chain'
  EXEC Meta..asisp_makelinkchain
  PRINT 'Rebuilding link_path and link_path_detail'
  EXEC Meta..asisp_makelinkpath
END
")























































































-- BEGIN RODM_EVENT_DEFINITIONS(NNDM)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NNDM)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NNDM' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NNDM'
    exec("
    create table STCR_EXCT_NNDM
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NNDM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NNDM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NNDM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NNDM to public
    grant delete on STCR_EXCT_NNDM to public
    grant select on STCR_EXCT_NNDM to public
    grant update on STCR_EXCT_NNDM to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NNDM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NNDM')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDM on STCR_EXCT_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDM on STCR_EXCT_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDM)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDM' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDM'
    exec("
    create table STCR_STTP_NNDM
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDM to public
    grant delete on STCR_STTP_NNDM to public
    grant select on STCR_STTP_NNDM to public
    grant update on STCR_STTP_NNDM to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDM')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDM on STCR_STTP_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDM on STCR_STTP_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NNDM)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NNDM' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NNDM'
    exec("
    create table STCR_MSGD_NNDM
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NNDM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NNDM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NNDM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NNDM to public
    grant delete on STCR_MSGD_NNDM to public
    grant select on STCR_MSGD_NNDM to public
    grant update on STCR_MSGD_NNDM to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NNDM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NNDM')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDM on STCR_MSGD_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDM on STCR_MSGD_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDM, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NNDM'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDM', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NNDM)

if not exists (select * from isa where cid = 'NNDM')
begin
  raiserror('No isa relationship has been established for cid NNDM -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDM)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDM' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDM'
    exec("
    create table STCR_STTP_NNDM
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDM to public
    grant delete on STCR_STTP_NNDM to public
    grant select on STCR_STTP_NNDM to public
    grant update on STCR_STTP_NNDM to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDM')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDM on STCR_STTP_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDM on STCR_STTP_NNDM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_degraded')
    exec asisp_createSTTP 'NNDM_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_intermediate')
    exec asisp_createSTTP 'NNDM_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_low satisfactory')
    exec asisp_createSTTP 'NNDM_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_low unsatisfactory')
    exec asisp_createSTTP 'NNDM_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_medium satisfactory')
    exec asisp_createSTTP 'NNDM_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_medium unsatisfactory')
    exec asisp_createSTTP 'NNDM_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (152)')
    exec asisp_createSTTP 'NNDM_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (153)')
    exec asisp_createSTTP 'NNDM_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (154)')
    exec asisp_createSTTP 'NNDM_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (155)')
    exec asisp_createSTTP 'NNDM_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (156)')
    exec asisp_createSTTP 'NNDM_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (157)')
    exec asisp_createSTTP 'NNDM_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (158)')
    exec asisp_createSTTP 'NNDM_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_negative user-defined (159)')
    exec asisp_createSTTP 'NNDM_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (136)')
    exec asisp_createSTTP 'NNDM_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (137)')
    exec asisp_createSTTP 'NNDM_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (138)')
    exec asisp_createSTTP 'NNDM_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (139)')
    exec asisp_createSTTP 'NNDM_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (140)')
    exec asisp_createSTTP 'NNDM_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (141)')
    exec asisp_createSTTP 'NNDM_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (142)')
    exec asisp_createSTTP 'NNDM_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_positive user-defined (143)')
    exec asisp_createSTTP 'NNDM_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDM_satisfactory')
    exec asisp_createSTTP 'NNDM_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_severely degraded')
    exec asisp_createSTTP 'NNDM_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_unknown')
    exec asisp_createSTTP 'NNDM_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDM_unsatisfactory')
    exec asisp_createSTTP 'NNDM_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NNDM)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NNDM, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NNDM-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDM',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NNDM)
END
-- END RODM_EVENT_DEFINITIONS(NNDM)

-- BEGIN RODM_EVENT_DEFINITIONS(NNDN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NNDN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NNDN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NNDN'
    exec("
    create table STCR_EXCT_NNDN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NNDN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NNDN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NNDN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NNDN to public
    grant delete on STCR_EXCT_NNDN to public
    grant select on STCR_EXCT_NNDN to public
    grant update on STCR_EXCT_NNDN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NNDN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NNDN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDN on STCR_EXCT_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDN on STCR_EXCT_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDN'
    exec("
    create table STCR_STTP_NNDN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDN to public
    grant delete on STCR_STTP_NNDN to public
    grant select on STCR_STTP_NNDN to public
    grant update on STCR_STTP_NNDN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDN on STCR_STTP_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDN on STCR_STTP_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NNDN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NNDN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NNDN'
    exec("
    create table STCR_MSGD_NNDN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NNDN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NNDN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NNDN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NNDN to public
    grant delete on STCR_MSGD_NNDN to public
    grant select on STCR_MSGD_NNDN to public
    grant update on STCR_MSGD_NNDN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NNDN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NNDN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDN on STCR_MSGD_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDN on STCR_MSGD_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NNDN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NNDN)

if not exists (select * from isa where cid = 'NNDN')
begin
  raiserror('No isa relationship has been established for cid NNDN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDN'
    exec("
    create table STCR_STTP_NNDN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDN to public
    grant delete on STCR_STTP_NNDN to public
    grant select on STCR_STTP_NNDN to public
    grant update on STCR_STTP_NNDN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDN on STCR_STTP_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDN on STCR_STTP_NNDN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_degraded')
    exec asisp_createSTTP 'NNDN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_intermediate')
    exec asisp_createSTTP 'NNDN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_low satisfactory')
    exec asisp_createSTTP 'NNDN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_low unsatisfactory')
    exec asisp_createSTTP 'NNDN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_medium satisfactory')
    exec asisp_createSTTP 'NNDN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_medium unsatisfactory')
    exec asisp_createSTTP 'NNDN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (152)')
    exec asisp_createSTTP 'NNDN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (153)')
    exec asisp_createSTTP 'NNDN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (154)')
    exec asisp_createSTTP 'NNDN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (155)')
    exec asisp_createSTTP 'NNDN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (156)')
    exec asisp_createSTTP 'NNDN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (157)')
    exec asisp_createSTTP 'NNDN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (158)')
    exec asisp_createSTTP 'NNDN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_negative user-defined (159)')
    exec asisp_createSTTP 'NNDN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (136)')
    exec asisp_createSTTP 'NNDN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (137)')
    exec asisp_createSTTP 'NNDN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (138)')
    exec asisp_createSTTP 'NNDN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (139)')
    exec asisp_createSTTP 'NNDN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (140)')
    exec asisp_createSTTP 'NNDN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (141)')
    exec asisp_createSTTP 'NNDN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (142)')
    exec asisp_createSTTP 'NNDN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_positive user-defined (143)')
    exec asisp_createSTTP 'NNDN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDN_satisfactory')
    exec asisp_createSTTP 'NNDN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_severely degraded')
    exec asisp_createSTTP 'NNDN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_unknown')
    exec asisp_createSTTP 'NNDN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDN_unsatisfactory')
    exec asisp_createSTTP 'NNDN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NNDN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NNDN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NNDN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NNDN)
END
-- END RODM_EVENT_DEFINITIONS(NNDN)

-- BEGIN RODM_EVENT_DEFINITIONS(NNDC)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NNDC)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NNDC' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NNDC'
    exec("
    create table STCR_EXCT_NNDC
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NNDC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NNDC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NNDC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NNDC to public
    grant delete on STCR_EXCT_NNDC to public
    grant select on STCR_EXCT_NNDC to public
    grant update on STCR_EXCT_NNDC to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NNDC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NNDC')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDC on STCR_EXCT_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNDC on STCR_EXCT_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDC'
    exec("
    create table STCR_STTP_NNDC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDC to public
    grant delete on STCR_STTP_NNDC to public
    grant select on STCR_STTP_NNDC to public
    grant update on STCR_STTP_NNDC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDC on STCR_STTP_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDC on STCR_STTP_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NNDC)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NNDC' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NNDC'
    exec("
    create table STCR_MSGD_NNDC
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NNDC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NNDC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NNDC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NNDC to public
    grant delete on STCR_MSGD_NNDC to public
    grant select on STCR_MSGD_NNDC to public
    grant update on STCR_MSGD_NNDC to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NNDC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NNDC')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDC on STCR_MSGD_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNDC on STCR_MSGD_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNDC, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNDC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NNDC'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNDC', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NNDC)

if not exists (select * from isa where cid = 'NNDC')
begin
  raiserror('No isa relationship has been established for cid NNDC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNDC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNDC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNDC'
    exec("
    create table STCR_STTP_NNDC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNDC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNDC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNDC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNDC to public
    grant delete on STCR_STTP_NNDC to public
    grant select on STCR_STTP_NNDC to public
    grant update on STCR_STTP_NNDC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNDC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNDC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDC on STCR_STTP_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNDC on STCR_STTP_NNDC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNDC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_degraded')
    exec asisp_createSTTP 'NNDC_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_intermediate')
    exec asisp_createSTTP 'NNDC_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_low satisfactory')
    exec asisp_createSTTP 'NNDC_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_low unsatisfactory')
    exec asisp_createSTTP 'NNDC_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_medium satisfactory')
    exec asisp_createSTTP 'NNDC_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_medium unsatisfactory')
    exec asisp_createSTTP 'NNDC_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (152)')
    exec asisp_createSTTP 'NNDC_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (153)')
    exec asisp_createSTTP 'NNDC_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (154)')
    exec asisp_createSTTP 'NNDC_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (155)')
    exec asisp_createSTTP 'NNDC_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (156)')
    exec asisp_createSTTP 'NNDC_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (157)')
    exec asisp_createSTTP 'NNDC_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (158)')
    exec asisp_createSTTP 'NNDC_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_negative user-defined (159)')
    exec asisp_createSTTP 'NNDC_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (136)')
    exec asisp_createSTTP 'NNDC_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (137)')
    exec asisp_createSTTP 'NNDC_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (138)')
    exec asisp_createSTTP 'NNDC_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (139)')
    exec asisp_createSTTP 'NNDC_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (140)')
    exec asisp_createSTTP 'NNDC_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (141)')
    exec asisp_createSTTP 'NNDC_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (142)')
    exec asisp_createSTTP 'NNDC_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_positive user-defined (143)')
    exec asisp_createSTTP 'NNDC_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNDC_satisfactory')
    exec asisp_createSTTP 'NNDC_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_severely degraded')
    exec asisp_createSTTP 'NNDC_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_unknown')
    exec asisp_createSTTP 'NNDC_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNDC_unsatisfactory')
    exec asisp_createSTTP 'NNDC_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NNDC)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NNDC, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NNDC-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNDC',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NNDC)
END
-- END RODM_EVENT_DEFINITIONS(NNDC)

-- BEGIN RODM_EVENT_DEFINITIONS(IDCT)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=IDCT)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_IDCT' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_IDCT'
    exec("
    create table STCR_EXCT_IDCT
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_IDCT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_IDCT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_IDCT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_IDCT to public
    grant delete on STCR_EXCT_IDCT to public
    grant select on STCR_EXCT_IDCT to public
    grant update on STCR_EXCT_IDCT to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_IDCT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'IDCT')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_IDCT on STCR_EXCT_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_IDCT on STCR_EXCT_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=IDCT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_IDCT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_IDCT'
    exec("
    create table STCR_STTP_IDCT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_IDCT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_IDCT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_IDCT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_IDCT to public
    grant delete on STCR_STTP_IDCT to public
    grant select on STCR_STTP_IDCT to public
    grant update on STCR_STTP_IDCT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_IDCT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'IDCT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDCT on STCR_STTP_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDCT on STCR_STTP_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=IDCT)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_IDCT' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_IDCT'
    exec("
    create table STCR_MSGD_IDCT
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_IDCT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_IDCT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_IDCT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_IDCT to public
    grant delete on STCR_MSGD_IDCT to public
    grant select on STCR_MSGD_IDCT to public
    grant update on STCR_MSGD_IDCT to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_IDCT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'IDCT')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_IDCT on STCR_MSGD_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_IDCT on STCR_MSGD_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDCT, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDCT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'IDCT'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDCT', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=IDCT)

if not exists (select * from isa where cid = 'IDCT')
begin
  raiserror('No isa relationship has been established for cid IDCT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=IDCT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_IDCT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_IDCT'
    exec("
    create table STCR_STTP_IDCT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_IDCT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_IDCT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_IDCT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_IDCT to public
    grant delete on STCR_STTP_IDCT to public
    grant select on STCR_STTP_IDCT to public
    grant update on STCR_STTP_IDCT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_IDCT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'IDCT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDCT on STCR_STTP_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDCT on STCR_STTP_IDCT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDCT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_degraded')
    exec asisp_createSTTP 'IDCT_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_intermediate')
    exec asisp_createSTTP 'IDCT_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_low satisfactory')
    exec asisp_createSTTP 'IDCT_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_low unsatisfactory')
    exec asisp_createSTTP 'IDCT_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_medium satisfactory')
    exec asisp_createSTTP 'IDCT_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_medium unsatisfactory')
    exec asisp_createSTTP 'IDCT_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (152)')
    exec asisp_createSTTP 'IDCT_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (153)')
    exec asisp_createSTTP 'IDCT_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (154)')
    exec asisp_createSTTP 'IDCT_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (155)')
    exec asisp_createSTTP 'IDCT_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (156)')
    exec asisp_createSTTP 'IDCT_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (157)')
    exec asisp_createSTTP 'IDCT_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (158)')
    exec asisp_createSTTP 'IDCT_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_negative user-defined (159)')
    exec asisp_createSTTP 'IDCT_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (136)')
    exec asisp_createSTTP 'IDCT_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (137)')
    exec asisp_createSTTP 'IDCT_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (138)')
    exec asisp_createSTTP 'IDCT_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (139)')
    exec asisp_createSTTP 'IDCT_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (140)')
    exec asisp_createSTTP 'IDCT_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (141)')
    exec asisp_createSTTP 'IDCT_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (142)')
    exec asisp_createSTTP 'IDCT_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_positive user-defined (143)')
    exec asisp_createSTTP 'IDCT_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDCT_satisfactory')
    exec asisp_createSTTP 'IDCT_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_severely degraded')
    exec asisp_createSTTP 'IDCT_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_unknown')
    exec asisp_createSTTP 'IDCT_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDCT_unsatisfactory')
    exec asisp_createSTTP 'IDCT_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=IDCT)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=IDCT, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for IDCT-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDCT',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=IDCT)
END
-- END RODM_EVENT_DEFINITIONS(IDCT)

-- BEGIN RODM_EVENT_DEFINITIONS(ENLT)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=ENLT)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_ENLT' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_ENLT'
    exec("
    create table STCR_EXCT_ENLT
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_ENLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_ENLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_ENLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_ENLT to public
    grant delete on STCR_EXCT_ENLT to public
    grant select on STCR_EXCT_ENLT to public
    grant update on STCR_EXCT_ENLT to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_ENLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'ENLT')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ENLT on STCR_EXCT_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ENLT on STCR_EXCT_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ENLT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ENLT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ENLT'
    exec("
    create table STCR_STTP_ENLT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ENLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ENLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ENLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ENLT to public
    grant delete on STCR_STTP_ENLT to public
    grant select on STCR_STTP_ENLT to public
    grant update on STCR_STTP_ENLT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ENLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ENLT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ENLT on STCR_STTP_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ENLT on STCR_STTP_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=ENLT)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_ENLT' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_ENLT'
    exec("
    create table STCR_MSGD_ENLT
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_ENLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_ENLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_ENLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_ENLT to public
    grant delete on STCR_MSGD_ENLT to public
    grant select on STCR_MSGD_ENLT to public
    grant update on STCR_MSGD_ENLT to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_ENLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'ENLT')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ENLT on STCR_MSGD_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ENLT on STCR_MSGD_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ENLT, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ENLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'ENLT'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ENLT', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=ENLT)

if not exists (select * from isa where cid = 'ENLT')
begin
  raiserror('No isa relationship has been established for cid ENLT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ENLT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ENLT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ENLT'
    exec("
    create table STCR_STTP_ENLT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ENLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ENLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ENLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ENLT to public
    grant delete on STCR_STTP_ENLT to public
    grant select on STCR_STTP_ENLT to public
    grant update on STCR_STTP_ENLT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ENLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ENLT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ENLT on STCR_STTP_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ENLT on STCR_STTP_ENLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ENLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_degraded')
    exec asisp_createSTTP 'ENLT_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_intermediate')
    exec asisp_createSTTP 'ENLT_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_low satisfactory')
    exec asisp_createSTTP 'ENLT_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_low unsatisfactory')
    exec asisp_createSTTP 'ENLT_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_medium satisfactory')
    exec asisp_createSTTP 'ENLT_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_medium unsatisfactory')
    exec asisp_createSTTP 'ENLT_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (152)')
    exec asisp_createSTTP 'ENLT_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (153)')
    exec asisp_createSTTP 'ENLT_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (154)')
    exec asisp_createSTTP 'ENLT_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (155)')
    exec asisp_createSTTP 'ENLT_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (156)')
    exec asisp_createSTTP 'ENLT_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (157)')
    exec asisp_createSTTP 'ENLT_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (158)')
    exec asisp_createSTTP 'ENLT_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_negative user-defined (159)')
    exec asisp_createSTTP 'ENLT_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (136)')
    exec asisp_createSTTP 'ENLT_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (137)')
    exec asisp_createSTTP 'ENLT_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (138)')
    exec asisp_createSTTP 'ENLT_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (139)')
    exec asisp_createSTTP 'ENLT_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (140)')
    exec asisp_createSTTP 'ENLT_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (141)')
    exec asisp_createSTTP 'ENLT_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (142)')
    exec asisp_createSTTP 'ENLT_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_positive user-defined (143)')
    exec asisp_createSTTP 'ENLT_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ENLT_satisfactory')
    exec asisp_createSTTP 'ENLT_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_severely degraded')
    exec asisp_createSTTP 'ENLT_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_unknown')
    exec asisp_createSTTP 'ENLT_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ENLT_unsatisfactory')
    exec asisp_createSTTP 'ENLT_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=ENLT)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=ENLT, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for ENLT-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ENLT',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=ENLT)
END
-- END RODM_EVENT_DEFINITIONS(ENLT)

-- BEGIN RODM_EVENT_DEFINITIONS(NNLT)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NNLT)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NNLT' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NNLT'
    exec("
    create table STCR_EXCT_NNLT
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NNLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NNLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NNLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NNLT to public
    grant delete on STCR_EXCT_NNLT to public
    grant select on STCR_EXCT_NNLT to public
    grant update on STCR_EXCT_NNLT to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NNLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NNLT')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNLT on STCR_EXCT_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NNLT on STCR_EXCT_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNLT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNLT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNLT'
    exec("
    create table STCR_STTP_NNLT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNLT to public
    grant delete on STCR_STTP_NNLT to public
    grant select on STCR_STTP_NNLT to public
    grant update on STCR_STTP_NNLT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNLT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNLT on STCR_STTP_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNLT on STCR_STTP_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NNLT)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NNLT' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NNLT'
    exec("
    create table STCR_MSGD_NNLT
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NNLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NNLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NNLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NNLT to public
    grant delete on STCR_MSGD_NNLT to public
    grant select on STCR_MSGD_NNLT to public
    grant update on STCR_MSGD_NNLT to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NNLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NNLT')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNLT on STCR_MSGD_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NNLT on STCR_MSGD_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NNLT, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NNLT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NNLT'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NNLT', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NNLT)

if not exists (select * from isa where cid = 'NNLT')
begin
  raiserror('No isa relationship has been established for cid NNLT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NNLT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NNLT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NNLT'
    exec("
    create table STCR_STTP_NNLT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NNLT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NNLT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NNLT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NNLT to public
    grant delete on STCR_STTP_NNLT to public
    grant select on STCR_STTP_NNLT to public
    grant update on STCR_STTP_NNLT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NNLT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NNLT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNLT on STCR_STTP_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NNLT on STCR_STTP_NNLT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NNLT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_degraded')
    exec asisp_createSTTP 'NNLT_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_intermediate')
    exec asisp_createSTTP 'NNLT_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_low satisfactory')
    exec asisp_createSTTP 'NNLT_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_low unsatisfactory')
    exec asisp_createSTTP 'NNLT_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_medium satisfactory')
    exec asisp_createSTTP 'NNLT_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_medium unsatisfactory')
    exec asisp_createSTTP 'NNLT_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (152)')
    exec asisp_createSTTP 'NNLT_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (153)')
    exec asisp_createSTTP 'NNLT_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (154)')
    exec asisp_createSTTP 'NNLT_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (155)')
    exec asisp_createSTTP 'NNLT_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (156)')
    exec asisp_createSTTP 'NNLT_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (157)')
    exec asisp_createSTTP 'NNLT_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (158)')
    exec asisp_createSTTP 'NNLT_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_negative user-defined (159)')
    exec asisp_createSTTP 'NNLT_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (136)')
    exec asisp_createSTTP 'NNLT_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (137)')
    exec asisp_createSTTP 'NNLT_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (138)')
    exec asisp_createSTTP 'NNLT_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (139)')
    exec asisp_createSTTP 'NNLT_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (140)')
    exec asisp_createSTTP 'NNLT_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (141)')
    exec asisp_createSTTP 'NNLT_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (142)')
    exec asisp_createSTTP 'NNLT_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_positive user-defined (143)')
    exec asisp_createSTTP 'NNLT_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NNLT_satisfactory')
    exec asisp_createSTTP 'NNLT_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_severely degraded')
    exec asisp_createSTTP 'NNLT_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_unknown')
    exec asisp_createSTTP 'NNLT_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NNLT_unsatisfactory')
    exec asisp_createSTTP 'NNLT_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NNLT)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NNLT, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NNLT-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NNLT',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NNLT)
END
-- END RODM_EVENT_DEFINITIONS(NNLT)

-- BEGIN RODM_EVENT_DEFINITIONS(LUG)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=LUG)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_LUG' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_LUG'
    exec("
    create table STCR_EXCT_LUG
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_LUG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_LUG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_LUG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_LUG to public
    grant delete on STCR_EXCT_LUG to public
    grant select on STCR_EXCT_LUG to public
    grant update on STCR_EXCT_LUG to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_LUG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'LUG')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LUG on STCR_EXCT_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LUG on STCR_EXCT_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LUG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LUG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LUG'
    exec("
    create table STCR_STTP_LUG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LUG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LUG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LUG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LUG to public
    grant delete on STCR_STTP_LUG to public
    grant select on STCR_STTP_LUG to public
    grant update on STCR_STTP_LUG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LUG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LUG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LUG on STCR_STTP_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LUG on STCR_STTP_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=LUG)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_LUG' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_LUG'
    exec("
    create table STCR_MSGD_LUG
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_LUG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_LUG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_LUG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_LUG to public
    grant delete on STCR_MSGD_LUG to public
    grant select on STCR_MSGD_LUG to public
    grant update on STCR_MSGD_LUG to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_LUG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'LUG')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LUG on STCR_MSGD_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LUG on STCR_MSGD_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LUG, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LUG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'LUG'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LUG', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=LUG)

if not exists (select * from isa where cid = 'LUG')
begin
  raiserror('No isa relationship has been established for cid LUG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LUG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LUG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LUG'
    exec("
    create table STCR_STTP_LUG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LUG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LUG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LUG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LUG to public
    grant delete on STCR_STTP_LUG to public
    grant select on STCR_STTP_LUG to public
    grant update on STCR_STTP_LUG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LUG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LUG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LUG on STCR_STTP_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LUG on STCR_STTP_LUG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LUG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_degraded')
    exec asisp_createSTTP 'LUG_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_intermediate')
    exec asisp_createSTTP 'LUG_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_low satisfactory')
    exec asisp_createSTTP 'LUG_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_low unsatisfactory')
    exec asisp_createSTTP 'LUG_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_medium satisfactory')
    exec asisp_createSTTP 'LUG_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_medium unsatisfactory')
    exec asisp_createSTTP 'LUG_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (152)')
    exec asisp_createSTTP 'LUG_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (153)')
    exec asisp_createSTTP 'LUG_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (154)')
    exec asisp_createSTTP 'LUG_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (155)')
    exec asisp_createSTTP 'LUG_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (156)')
    exec asisp_createSTTP 'LUG_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (157)')
    exec asisp_createSTTP 'LUG_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (158)')
    exec asisp_createSTTP 'LUG_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_negative user-defined (159)')
    exec asisp_createSTTP 'LUG_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (136)')
    exec asisp_createSTTP 'LUG_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (137)')
    exec asisp_createSTTP 'LUG_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (138)')
    exec asisp_createSTTP 'LUG_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (139)')
    exec asisp_createSTTP 'LUG_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (140)')
    exec asisp_createSTTP 'LUG_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (141)')
    exec asisp_createSTTP 'LUG_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (142)')
    exec asisp_createSTTP 'LUG_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_positive user-defined (143)')
    exec asisp_createSTTP 'LUG_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LUG_satisfactory')
    exec asisp_createSTTP 'LUG_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_severely degraded')
    exec asisp_createSTTP 'LUG_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_unknown')
    exec asisp_createSTTP 'LUG_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LUG_unsatisfactory')
    exec asisp_createSTTP 'LUG_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=LUG)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=LUG, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for LUG-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LUG',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=LUG)
END
-- END RODM_EVENT_DEFINITIONS(LUG)

-- BEGIN RODM_EVENT_DEFINITIONS(STGC)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=STGC)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_STGC' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_STGC'
    exec("
    create table STCR_EXCT_STGC
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_STGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_STGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_STGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_STGC to public
    grant delete on STCR_EXCT_STGC to public
    grant select on STCR_EXCT_STGC to public
    grant update on STCR_EXCT_STGC to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_STGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'STGC')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_STGC on STCR_EXCT_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_STGC on STCR_EXCT_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=STGC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_STGC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_STGC'
    exec("
    create table STCR_STTP_STGC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_STGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_STGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_STGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_STGC to public
    grant delete on STCR_STTP_STGC to public
    grant select on STCR_STTP_STGC to public
    grant update on STCR_STTP_STGC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_STGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'STGC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_STGC on STCR_STTP_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_STGC on STCR_STTP_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=STGC)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_STGC' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_STGC'
    exec("
    create table STCR_MSGD_STGC
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_STGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_STGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_STGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_STGC to public
    grant delete on STCR_MSGD_STGC to public
    grant select on STCR_MSGD_STGC to public
    grant update on STCR_MSGD_STGC to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_STGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'STGC')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_STGC on STCR_MSGD_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_STGC on STCR_MSGD_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=STGC, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'STGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'STGC'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'STGC', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=STGC)

if not exists (select * from isa where cid = 'STGC')
begin
  raiserror('No isa relationship has been established for cid STGC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=STGC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_STGC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_STGC'
    exec("
    create table STCR_STTP_STGC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_STGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_STGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_STGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_STGC to public
    grant delete on STCR_STTP_STGC to public
    grant select on STCR_STTP_STGC to public
    grant update on STCR_STTP_STGC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_STGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'STGC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_STGC on STCR_STTP_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_STGC on STCR_STTP_STGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'STGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_degraded')
    exec asisp_createSTTP 'STGC_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_intermediate')
    exec asisp_createSTTP 'STGC_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_low satisfactory')
    exec asisp_createSTTP 'STGC_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_low unsatisfactory')
    exec asisp_createSTTP 'STGC_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_medium satisfactory')
    exec asisp_createSTTP 'STGC_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_medium unsatisfactory')
    exec asisp_createSTTP 'STGC_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (152)')
    exec asisp_createSTTP 'STGC_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (153)')
    exec asisp_createSTTP 'STGC_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (154)')
    exec asisp_createSTTP 'STGC_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (155)')
    exec asisp_createSTTP 'STGC_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (156)')
    exec asisp_createSTTP 'STGC_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (157)')
    exec asisp_createSTTP 'STGC_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (158)')
    exec asisp_createSTTP 'STGC_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_negative user-defined (159)')
    exec asisp_createSTTP 'STGC_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (136)')
    exec asisp_createSTTP 'STGC_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (137)')
    exec asisp_createSTTP 'STGC_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (138)')
    exec asisp_createSTTP 'STGC_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (139)')
    exec asisp_createSTTP 'STGC_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (140)')
    exec asisp_createSTTP 'STGC_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (141)')
    exec asisp_createSTTP 'STGC_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (142)')
    exec asisp_createSTTP 'STGC_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_positive user-defined (143)')
    exec asisp_createSTTP 'STGC_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='STGC_satisfactory')
    exec asisp_createSTTP 'STGC_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_severely degraded')
    exec asisp_createSTTP 'STGC_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_unknown')
    exec asisp_createSTTP 'STGC_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='STGC_unsatisfactory')
    exec asisp_createSTTP 'STGC_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=STGC)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=STGC, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for STGC-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'STGC',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=STGC)
END
-- END RODM_EVENT_DEFINITIONS(STGC)

-- BEGIN RODM_EVENT_DEFINITIONS(BRNN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=BRNN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_BRNN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_BRNN'
    exec("
    create table STCR_EXCT_BRNN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_BRNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_BRNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_BRNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_BRNN to public
    grant delete on STCR_EXCT_BRNN to public
    grant select on STCR_EXCT_BRNN to public
    grant update on STCR_EXCT_BRNN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_BRNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'BRNN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_BRNN on STCR_EXCT_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_BRNN on STCR_EXCT_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=BRNN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_BRNN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_BRNN'
    exec("
    create table STCR_STTP_BRNN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_BRNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_BRNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_BRNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_BRNN to public
    grant delete on STCR_STTP_BRNN to public
    grant select on STCR_STTP_BRNN to public
    grant update on STCR_STTP_BRNN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_BRNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'BRNN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_BRNN on STCR_STTP_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_BRNN on STCR_STTP_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=BRNN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_BRNN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_BRNN'
    exec("
    create table STCR_MSGD_BRNN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_BRNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_BRNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_BRNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_BRNN to public
    grant delete on STCR_MSGD_BRNN to public
    grant select on STCR_MSGD_BRNN to public
    grant update on STCR_MSGD_BRNN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_BRNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'BRNN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_BRNN on STCR_MSGD_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_BRNN on STCR_MSGD_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=BRNN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'BRNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'BRNN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'BRNN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=BRNN)

if not exists (select * from isa where cid = 'BRNN')
begin
  raiserror('No isa relationship has been established for cid BRNN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=BRNN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_BRNN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_BRNN'
    exec("
    create table STCR_STTP_BRNN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_BRNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_BRNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_BRNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_BRNN to public
    grant delete on STCR_STTP_BRNN to public
    grant select on STCR_STTP_BRNN to public
    grant update on STCR_STTP_BRNN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_BRNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'BRNN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_BRNN on STCR_STTP_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_BRNN on STCR_STTP_BRNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'BRNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_degraded')
    exec asisp_createSTTP 'BRNN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_intermediate')
    exec asisp_createSTTP 'BRNN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_low satisfactory')
    exec asisp_createSTTP 'BRNN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_low unsatisfactory')
    exec asisp_createSTTP 'BRNN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_medium satisfactory')
    exec asisp_createSTTP 'BRNN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_medium unsatisfactory')
    exec asisp_createSTTP 'BRNN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (152)')
    exec asisp_createSTTP 'BRNN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (153)')
    exec asisp_createSTTP 'BRNN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (154)')
    exec asisp_createSTTP 'BRNN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (155)')
    exec asisp_createSTTP 'BRNN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (156)')
    exec asisp_createSTTP 'BRNN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (157)')
    exec asisp_createSTTP 'BRNN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (158)')
    exec asisp_createSTTP 'BRNN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_negative user-defined (159)')
    exec asisp_createSTTP 'BRNN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (136)')
    exec asisp_createSTTP 'BRNN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (137)')
    exec asisp_createSTTP 'BRNN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (138)')
    exec asisp_createSTTP 'BRNN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (139)')
    exec asisp_createSTTP 'BRNN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (140)')
    exec asisp_createSTTP 'BRNN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (141)')
    exec asisp_createSTTP 'BRNN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (142)')
    exec asisp_createSTTP 'BRNN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_positive user-defined (143)')
    exec asisp_createSTTP 'BRNN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='BRNN_satisfactory')
    exec asisp_createSTTP 'BRNN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_severely degraded')
    exec asisp_createSTTP 'BRNN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_unknown')
    exec asisp_createSTTP 'BRNN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='BRNN_unsatisfactory')
    exec asisp_createSTTP 'BRNN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=BRNN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=BRNN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for BRNN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'BRNN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=BRNN)
END
-- END RODM_EVENT_DEFINITIONS(BRNN)

-- BEGIN RODM_EVENT_DEFINITIONS(APEN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=APEN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_APEN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_APEN'
    exec("
    create table STCR_EXCT_APEN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_APEN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_APEN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_APEN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_APEN to public
    grant delete on STCR_EXCT_APEN to public
    grant select on STCR_EXCT_APEN to public
    grant update on STCR_EXCT_APEN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_APEN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'APEN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APEN on STCR_EXCT_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APEN on STCR_EXCT_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APEN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APEN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APEN'
    exec("
    create table STCR_STTP_APEN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APEN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APEN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APEN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APEN to public
    grant delete on STCR_STTP_APEN to public
    grant select on STCR_STTP_APEN to public
    grant update on STCR_STTP_APEN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APEN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APEN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APEN on STCR_STTP_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APEN on STCR_STTP_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=APEN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_APEN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_APEN'
    exec("
    create table STCR_MSGD_APEN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_APEN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_APEN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_APEN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_APEN to public
    grant delete on STCR_MSGD_APEN to public
    grant select on STCR_MSGD_APEN to public
    grant update on STCR_MSGD_APEN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_APEN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'APEN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APEN on STCR_MSGD_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APEN on STCR_MSGD_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APEN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APEN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'APEN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APEN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=APEN)

if not exists (select * from isa where cid = 'APEN')
begin
  raiserror('No isa relationship has been established for cid APEN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APEN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APEN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APEN'
    exec("
    create table STCR_STTP_APEN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APEN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APEN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APEN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APEN to public
    grant delete on STCR_STTP_APEN to public
    grant select on STCR_STTP_APEN to public
    grant update on STCR_STTP_APEN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APEN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APEN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APEN on STCR_STTP_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APEN on STCR_STTP_APEN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APEN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_degraded')
    exec asisp_createSTTP 'APEN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_intermediate')
    exec asisp_createSTTP 'APEN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_low satisfactory')
    exec asisp_createSTTP 'APEN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_low unsatisfactory')
    exec asisp_createSTTP 'APEN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_medium satisfactory')
    exec asisp_createSTTP 'APEN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_medium unsatisfactory')
    exec asisp_createSTTP 'APEN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (152)')
    exec asisp_createSTTP 'APEN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (153)')
    exec asisp_createSTTP 'APEN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (154)')
    exec asisp_createSTTP 'APEN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (155)')
    exec asisp_createSTTP 'APEN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (156)')
    exec asisp_createSTTP 'APEN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (157)')
    exec asisp_createSTTP 'APEN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (158)')
    exec asisp_createSTTP 'APEN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_negative user-defined (159)')
    exec asisp_createSTTP 'APEN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (136)')
    exec asisp_createSTTP 'APEN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (137)')
    exec asisp_createSTTP 'APEN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (138)')
    exec asisp_createSTTP 'APEN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (139)')
    exec asisp_createSTTP 'APEN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (140)')
    exec asisp_createSTTP 'APEN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (141)')
    exec asisp_createSTTP 'APEN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (142)')
    exec asisp_createSTTP 'APEN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_positive user-defined (143)')
    exec asisp_createSTTP 'APEN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APEN_satisfactory')
    exec asisp_createSTTP 'APEN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_severely degraded')
    exec asisp_createSTTP 'APEN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_unknown')
    exec asisp_createSTTP 'APEN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APEN_unsatisfactory')
    exec asisp_createSTTP 'APEN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=APEN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=APEN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for APEN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APEN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=APEN)
END
-- END RODM_EVENT_DEFINITIONS(APEN)

-- BEGIN RODM_EVENT_DEFINITIONS(APNN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=APNN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_APNN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_APNN'
    exec("
    create table STCR_EXCT_APNN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_APNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_APNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_APNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_APNN to public
    grant delete on STCR_EXCT_APNN to public
    grant select on STCR_EXCT_APNN to public
    grant update on STCR_EXCT_APNN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_APNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'APNN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APNN on STCR_EXCT_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APNN on STCR_EXCT_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APNN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APNN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APNN'
    exec("
    create table STCR_STTP_APNN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APNN to public
    grant delete on STCR_STTP_APNN to public
    grant select on STCR_STTP_APNN to public
    grant update on STCR_STTP_APNN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APNN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APNN on STCR_STTP_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APNN on STCR_STTP_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=APNN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_APNN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_APNN'
    exec("
    create table STCR_MSGD_APNN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_APNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_APNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_APNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_APNN to public
    grant delete on STCR_MSGD_APNN to public
    grant select on STCR_MSGD_APNN to public
    grant update on STCR_MSGD_APNN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_APNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'APNN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APNN on STCR_MSGD_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APNN on STCR_MSGD_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APNN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APNN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'APNN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APNN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=APNN)

if not exists (select * from isa where cid = 'APNN')
begin
  raiserror('No isa relationship has been established for cid APNN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APNN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APNN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APNN'
    exec("
    create table STCR_STTP_APNN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APNN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APNN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APNN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APNN to public
    grant delete on STCR_STTP_APNN to public
    grant select on STCR_STTP_APNN to public
    grant update on STCR_STTP_APNN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APNN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APNN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APNN on STCR_STTP_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APNN on STCR_STTP_APNN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APNN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_degraded')
    exec asisp_createSTTP 'APNN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_intermediate')
    exec asisp_createSTTP 'APNN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_low satisfactory')
    exec asisp_createSTTP 'APNN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_low unsatisfactory')
    exec asisp_createSTTP 'APNN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_medium satisfactory')
    exec asisp_createSTTP 'APNN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_medium unsatisfactory')
    exec asisp_createSTTP 'APNN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (152)')
    exec asisp_createSTTP 'APNN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (153)')
    exec asisp_createSTTP 'APNN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (154)')
    exec asisp_createSTTP 'APNN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (155)')
    exec asisp_createSTTP 'APNN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (156)')
    exec asisp_createSTTP 'APNN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (157)')
    exec asisp_createSTTP 'APNN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (158)')
    exec asisp_createSTTP 'APNN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_negative user-defined (159)')
    exec asisp_createSTTP 'APNN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (136)')
    exec asisp_createSTTP 'APNN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (137)')
    exec asisp_createSTTP 'APNN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (138)')
    exec asisp_createSTTP 'APNN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (139)')
    exec asisp_createSTTP 'APNN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (140)')
    exec asisp_createSTTP 'APNN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (141)')
    exec asisp_createSTTP 'APNN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (142)')
    exec asisp_createSTTP 'APNN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_positive user-defined (143)')
    exec asisp_createSTTP 'APNN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APNN_satisfactory')
    exec asisp_createSTTP 'APNN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_severely degraded')
    exec asisp_createSTTP 'APNN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_unknown')
    exec asisp_createSTTP 'APNN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APNN_unsatisfactory')
    exec asisp_createSTTP 'APNN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=APNN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=APNN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for APNN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APNN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=APNN)
END
-- END RODM_EVENT_DEFINITIONS(APNN)

-- BEGIN RODM_EVENT_DEFINITIONS(APTG)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=APTG)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_APTG' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_APTG'
    exec("
    create table STCR_EXCT_APTG
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_APTG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_APTG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_APTG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_APTG to public
    grant delete on STCR_EXCT_APTG to public
    grant select on STCR_EXCT_APTG to public
    grant update on STCR_EXCT_APTG to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_APTG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'APTG')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APTG on STCR_EXCT_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_APTG on STCR_EXCT_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APTG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APTG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APTG'
    exec("
    create table STCR_STTP_APTG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APTG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APTG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APTG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APTG to public
    grant delete on STCR_STTP_APTG to public
    grant select on STCR_STTP_APTG to public
    grant update on STCR_STTP_APTG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APTG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APTG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APTG on STCR_STTP_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APTG on STCR_STTP_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=APTG)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_APTG' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_APTG'
    exec("
    create table STCR_MSGD_APTG
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_APTG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_APTG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_APTG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_APTG to public
    grant delete on STCR_MSGD_APTG to public
    grant select on STCR_MSGD_APTG to public
    grant update on STCR_MSGD_APTG to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_APTG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'APTG')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APTG on STCR_MSGD_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_APTG on STCR_MSGD_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=APTG, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'APTG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'APTG'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'APTG', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=APTG)

if not exists (select * from isa where cid = 'APTG')
begin
  raiserror('No isa relationship has been established for cid APTG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=APTG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_APTG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_APTG'
    exec("
    create table STCR_STTP_APTG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_APTG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_APTG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_APTG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_APTG to public
    grant delete on STCR_STTP_APTG to public
    grant select on STCR_STTP_APTG to public
    grant update on STCR_STTP_APTG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_APTG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'APTG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APTG on STCR_STTP_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_APTG on STCR_STTP_APTG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'APTG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_degraded')
    exec asisp_createSTTP 'APTG_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_intermediate')
    exec asisp_createSTTP 'APTG_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_low satisfactory')
    exec asisp_createSTTP 'APTG_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_low unsatisfactory')
    exec asisp_createSTTP 'APTG_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_medium satisfactory')
    exec asisp_createSTTP 'APTG_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_medium unsatisfactory')
    exec asisp_createSTTP 'APTG_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (152)')
    exec asisp_createSTTP 'APTG_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (153)')
    exec asisp_createSTTP 'APTG_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (154)')
    exec asisp_createSTTP 'APTG_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (155)')
    exec asisp_createSTTP 'APTG_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (156)')
    exec asisp_createSTTP 'APTG_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (157)')
    exec asisp_createSTTP 'APTG_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (158)')
    exec asisp_createSTTP 'APTG_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_negative user-defined (159)')
    exec asisp_createSTTP 'APTG_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (136)')
    exec asisp_createSTTP 'APTG_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (137)')
    exec asisp_createSTTP 'APTG_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (138)')
    exec asisp_createSTTP 'APTG_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (139)')
    exec asisp_createSTTP 'APTG_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (140)')
    exec asisp_createSTTP 'APTG_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (141)')
    exec asisp_createSTTP 'APTG_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (142)')
    exec asisp_createSTTP 'APTG_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_positive user-defined (143)')
    exec asisp_createSTTP 'APTG_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='APTG_satisfactory')
    exec asisp_createSTTP 'APTG_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_severely degraded')
    exec asisp_createSTTP 'APTG_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_unknown')
    exec asisp_createSTTP 'APTG_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='APTG_unsatisfactory')
    exec asisp_createSTTP 'APTG_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=APTG)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=APTG, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for APTG-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'APTG',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=APTG)
END
-- END RODM_EVENT_DEFINITIONS(APTG)

-- BEGIN RODM_EVENT_DEFINITIONS(ATGC)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=ATGC)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_ATGC' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_ATGC'
    exec("
    create table STCR_EXCT_ATGC
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_ATGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_ATGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_ATGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_ATGC to public
    grant delete on STCR_EXCT_ATGC to public
    grant select on STCR_EXCT_ATGC to public
    grant update on STCR_EXCT_ATGC to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_ATGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'ATGC')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ATGC on STCR_EXCT_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ATGC on STCR_EXCT_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ATGC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ATGC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ATGC'
    exec("
    create table STCR_STTP_ATGC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ATGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ATGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ATGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ATGC to public
    grant delete on STCR_STTP_ATGC to public
    grant select on STCR_STTP_ATGC to public
    grant update on STCR_STTP_ATGC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ATGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ATGC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ATGC on STCR_STTP_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ATGC on STCR_STTP_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=ATGC)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_ATGC' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_ATGC'
    exec("
    create table STCR_MSGD_ATGC
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_ATGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_ATGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_ATGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_ATGC to public
    grant delete on STCR_MSGD_ATGC to public
    grant select on STCR_MSGD_ATGC to public
    grant update on STCR_MSGD_ATGC to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_ATGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'ATGC')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ATGC on STCR_MSGD_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ATGC on STCR_MSGD_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ATGC, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ATGC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'ATGC'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ATGC', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=ATGC)

if not exists (select * from isa where cid = 'ATGC')
begin
  raiserror('No isa relationship has been established for cid ATGC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ATGC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ATGC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ATGC'
    exec("
    create table STCR_STTP_ATGC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ATGC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ATGC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ATGC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ATGC to public
    grant delete on STCR_STTP_ATGC to public
    grant select on STCR_STTP_ATGC to public
    grant update on STCR_STTP_ATGC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ATGC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ATGC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ATGC on STCR_STTP_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ATGC on STCR_STTP_ATGC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ATGC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_degraded')
    exec asisp_createSTTP 'ATGC_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_intermediate')
    exec asisp_createSTTP 'ATGC_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_low satisfactory')
    exec asisp_createSTTP 'ATGC_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_low unsatisfactory')
    exec asisp_createSTTP 'ATGC_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_medium satisfactory')
    exec asisp_createSTTP 'ATGC_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_medium unsatisfactory')
    exec asisp_createSTTP 'ATGC_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (152)')
    exec asisp_createSTTP 'ATGC_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (153)')
    exec asisp_createSTTP 'ATGC_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (154)')
    exec asisp_createSTTP 'ATGC_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (155)')
    exec asisp_createSTTP 'ATGC_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (156)')
    exec asisp_createSTTP 'ATGC_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (157)')
    exec asisp_createSTTP 'ATGC_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (158)')
    exec asisp_createSTTP 'ATGC_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_negative user-defined (159)')
    exec asisp_createSTTP 'ATGC_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (136)')
    exec asisp_createSTTP 'ATGC_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (137)')
    exec asisp_createSTTP 'ATGC_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (138)')
    exec asisp_createSTTP 'ATGC_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (139)')
    exec asisp_createSTTP 'ATGC_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (140)')
    exec asisp_createSTTP 'ATGC_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (141)')
    exec asisp_createSTTP 'ATGC_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (142)')
    exec asisp_createSTTP 'ATGC_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_positive user-defined (143)')
    exec asisp_createSTTP 'ATGC_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ATGC_satisfactory')
    exec asisp_createSTTP 'ATGC_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_severely degraded')
    exec asisp_createSTTP 'ATGC_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_unknown')
    exec asisp_createSTTP 'ATGC_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ATGC_unsatisfactory')
    exec asisp_createSTTP 'ATGC_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=ATGC)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=ATGC, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for ATGC-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ATGC',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=ATGC)
END
-- END RODM_EVENT_DEFINITIONS(ATGC)

-- BEGIN RODM_EVENT_DEFINITIONS(TGCN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=TGCN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_TGCN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_TGCN'
    exec("
    create table STCR_EXCT_TGCN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_TGCN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_TGCN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_TGCN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_TGCN to public
    grant delete on STCR_EXCT_TGCN to public
    grant select on STCR_EXCT_TGCN to public
    grant update on STCR_EXCT_TGCN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_TGCN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'TGCN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_TGCN on STCR_EXCT_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_TGCN on STCR_EXCT_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=TGCN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_TGCN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_TGCN'
    exec("
    create table STCR_STTP_TGCN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_TGCN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_TGCN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_TGCN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_TGCN to public
    grant delete on STCR_STTP_TGCN to public
    grant select on STCR_STTP_TGCN to public
    grant update on STCR_STTP_TGCN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_TGCN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'TGCN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_TGCN on STCR_STTP_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_TGCN on STCR_STTP_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=TGCN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_TGCN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_TGCN'
    exec("
    create table STCR_MSGD_TGCN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_TGCN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_TGCN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_TGCN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_TGCN to public
    grant delete on STCR_MSGD_TGCN to public
    grant select on STCR_MSGD_TGCN to public
    grant update on STCR_MSGD_TGCN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_TGCN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'TGCN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_TGCN on STCR_MSGD_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_TGCN on STCR_MSGD_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=TGCN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'TGCN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'TGCN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'TGCN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=TGCN)

if not exists (select * from isa where cid = 'TGCN')
begin
  raiserror('No isa relationship has been established for cid TGCN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=TGCN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_TGCN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_TGCN'
    exec("
    create table STCR_STTP_TGCN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_TGCN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_TGCN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_TGCN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_TGCN to public
    grant delete on STCR_STTP_TGCN to public
    grant select on STCR_STTP_TGCN to public
    grant update on STCR_STTP_TGCN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_TGCN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'TGCN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_TGCN on STCR_STTP_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_TGCN on STCR_STTP_TGCN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'TGCN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_degraded')
    exec asisp_createSTTP 'TGCN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_intermediate')
    exec asisp_createSTTP 'TGCN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_low satisfactory')
    exec asisp_createSTTP 'TGCN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_low unsatisfactory')
    exec asisp_createSTTP 'TGCN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_medium satisfactory')
    exec asisp_createSTTP 'TGCN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_medium unsatisfactory')
    exec asisp_createSTTP 'TGCN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (152)')
    exec asisp_createSTTP 'TGCN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (153)')
    exec asisp_createSTTP 'TGCN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (154)')
    exec asisp_createSTTP 'TGCN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (155)')
    exec asisp_createSTTP 'TGCN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (156)')
    exec asisp_createSTTP 'TGCN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (157)')
    exec asisp_createSTTP 'TGCN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (158)')
    exec asisp_createSTTP 'TGCN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_negative user-defined (159)')
    exec asisp_createSTTP 'TGCN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (136)')
    exec asisp_createSTTP 'TGCN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (137)')
    exec asisp_createSTTP 'TGCN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (138)')
    exec asisp_createSTTP 'TGCN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (139)')
    exec asisp_createSTTP 'TGCN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (140)')
    exec asisp_createSTTP 'TGCN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (141)')
    exec asisp_createSTTP 'TGCN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (142)')
    exec asisp_createSTTP 'TGCN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_positive user-defined (143)')
    exec asisp_createSTTP 'TGCN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='TGCN_satisfactory')
    exec asisp_createSTTP 'TGCN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_severely degraded')
    exec asisp_createSTTP 'TGCN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_unknown')
    exec asisp_createSTTP 'TGCN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='TGCN_unsatisfactory')
    exec asisp_createSTTP 'TGCN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=TGCN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=TGCN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for TGCN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'TGCN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=TGCN)
END
-- END RODM_EVENT_DEFINITIONS(TGCN)

-- BEGIN RODM_EVENT_DEFINITIONS(NTRI)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NTRI)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NTRI' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NTRI'
    exec("
    create table STCR_EXCT_NTRI
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NTRI_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NTRI_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NTRI_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NTRI to public
    grant delete on STCR_EXCT_NTRI to public
    grant select on STCR_EXCT_NTRI to public
    grant update on STCR_EXCT_NTRI to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NTRI'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NTRI')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NTRI on STCR_EXCT_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NTRI on STCR_EXCT_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NTRI)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NTRI' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NTRI'
    exec("
    create table STCR_STTP_NTRI
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NTRI_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NTRI_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NTRI_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NTRI to public
    grant delete on STCR_STTP_NTRI to public
    grant select on STCR_STTP_NTRI to public
    grant update on STCR_STTP_NTRI to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NTRI'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NTRI')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NTRI on STCR_STTP_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NTRI on STCR_STTP_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NTRI)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NTRI' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NTRI'
    exec("
    create table STCR_MSGD_NTRI
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NTRI_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NTRI_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NTRI_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NTRI to public
    grant delete on STCR_MSGD_NTRI to public
    grant select on STCR_MSGD_NTRI to public
    grant update on STCR_MSGD_NTRI to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NTRI'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NTRI')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NTRI on STCR_MSGD_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NTRI on STCR_MSGD_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NTRI, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NTRI' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NTRI'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NTRI', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NTRI)

if not exists (select * from isa where cid = 'NTRI')
begin
  raiserror('No isa relationship has been established for cid NTRI -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NTRI)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NTRI' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NTRI'
    exec("
    create table STCR_STTP_NTRI
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NTRI_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NTRI_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NTRI_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NTRI to public
    grant delete on STCR_STTP_NTRI to public
    grant select on STCR_STTP_NTRI to public
    grant update on STCR_STTP_NTRI to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NTRI'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NTRI')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NTRI on STCR_STTP_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NTRI on STCR_STTP_NTRI FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NTRI', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_degraded')
    exec asisp_createSTTP 'NTRI_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_intermediate')
    exec asisp_createSTTP 'NTRI_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_low satisfactory')
    exec asisp_createSTTP 'NTRI_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_low unsatisfactory')
    exec asisp_createSTTP 'NTRI_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_medium satisfactory')
    exec asisp_createSTTP 'NTRI_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_medium unsatisfactory')
    exec asisp_createSTTP 'NTRI_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (152)')
    exec asisp_createSTTP 'NTRI_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (153)')
    exec asisp_createSTTP 'NTRI_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (154)')
    exec asisp_createSTTP 'NTRI_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (155)')
    exec asisp_createSTTP 'NTRI_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (156)')
    exec asisp_createSTTP 'NTRI_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (157)')
    exec asisp_createSTTP 'NTRI_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (158)')
    exec asisp_createSTTP 'NTRI_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_negative user-defined (159)')
    exec asisp_createSTTP 'NTRI_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (136)')
    exec asisp_createSTTP 'NTRI_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (137)')
    exec asisp_createSTTP 'NTRI_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (138)')
    exec asisp_createSTTP 'NTRI_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (139)')
    exec asisp_createSTTP 'NTRI_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (140)')
    exec asisp_createSTTP 'NTRI_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (141)')
    exec asisp_createSTTP 'NTRI_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (142)')
    exec asisp_createSTTP 'NTRI_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_positive user-defined (143)')
    exec asisp_createSTTP 'NTRI_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NTRI_satisfactory')
    exec asisp_createSTTP 'NTRI_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_severely degraded')
    exec asisp_createSTTP 'NTRI_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_unknown')
    exec asisp_createSTTP 'NTRI_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NTRI_unsatisfactory')
    exec asisp_createSTTP 'NTRI_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NTRI)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NTRI, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NTRI-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NTRI',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NTRI)
END
-- END RODM_EVENT_DEFINITIONS(NTRI)

-- BEGIN RODM_EVENT_DEFINITIONS(IDNC)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=IDNC)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_IDNC' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_IDNC'
    exec("
    create table STCR_EXCT_IDNC
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_IDNC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_IDNC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_IDNC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_IDNC to public
    grant delete on STCR_EXCT_IDNC to public
    grant select on STCR_EXCT_IDNC to public
    grant update on STCR_EXCT_IDNC to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_IDNC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'IDNC')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_IDNC on STCR_EXCT_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_IDNC on STCR_EXCT_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=IDNC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_IDNC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_IDNC'
    exec("
    create table STCR_STTP_IDNC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_IDNC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_IDNC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_IDNC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_IDNC to public
    grant delete on STCR_STTP_IDNC to public
    grant select on STCR_STTP_IDNC to public
    grant update on STCR_STTP_IDNC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_IDNC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'IDNC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDNC on STCR_STTP_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDNC on STCR_STTP_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=IDNC)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_IDNC' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_IDNC'
    exec("
    create table STCR_MSGD_IDNC
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_IDNC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_IDNC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_IDNC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_IDNC to public
    grant delete on STCR_MSGD_IDNC to public
    grant select on STCR_MSGD_IDNC to public
    grant update on STCR_MSGD_IDNC to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_IDNC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'IDNC')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_IDNC on STCR_MSGD_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_IDNC on STCR_MSGD_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=IDNC, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'IDNC' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'IDNC'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'IDNC', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=IDNC)

if not exists (select * from isa where cid = 'IDNC')
begin
  raiserror('No isa relationship has been established for cid IDNC -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=IDNC)
  if not exists (select * from sysobjects where name = 'STCR_STTP_IDNC' and type = 'U')
  begin
    print 'Creating table STCR_STTP_IDNC'
    exec("
    create table STCR_STTP_IDNC
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_IDNC_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_IDNC_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_IDNC_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_IDNC to public
    grant delete on STCR_STTP_IDNC to public
    grant select on STCR_STTP_IDNC to public
    grant update on STCR_STTP_IDNC to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_IDNC'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'IDNC')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDNC on STCR_STTP_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_IDNC on STCR_STTP_IDNC FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'IDNC', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_degraded')
    exec asisp_createSTTP 'IDNC_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_intermediate')
    exec asisp_createSTTP 'IDNC_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_low satisfactory')
    exec asisp_createSTTP 'IDNC_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_low unsatisfactory')
    exec asisp_createSTTP 'IDNC_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_medium satisfactory')
    exec asisp_createSTTP 'IDNC_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_medium unsatisfactory')
    exec asisp_createSTTP 'IDNC_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (152)')
    exec asisp_createSTTP 'IDNC_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (153)')
    exec asisp_createSTTP 'IDNC_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (154)')
    exec asisp_createSTTP 'IDNC_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (155)')
    exec asisp_createSTTP 'IDNC_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (156)')
    exec asisp_createSTTP 'IDNC_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (157)')
    exec asisp_createSTTP 'IDNC_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (158)')
    exec asisp_createSTTP 'IDNC_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_negative user-defined (159)')
    exec asisp_createSTTP 'IDNC_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (136)')
    exec asisp_createSTTP 'IDNC_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (137)')
    exec asisp_createSTTP 'IDNC_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (138)')
    exec asisp_createSTTP 'IDNC_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (139)')
    exec asisp_createSTTP 'IDNC_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (140)')
    exec asisp_createSTTP 'IDNC_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (141)')
    exec asisp_createSTTP 'IDNC_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (142)')
    exec asisp_createSTTP 'IDNC_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_positive user-defined (143)')
    exec asisp_createSTTP 'IDNC_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='IDNC_satisfactory')
    exec asisp_createSTTP 'IDNC_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_severely degraded')
    exec asisp_createSTTP 'IDNC_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_unknown')
    exec asisp_createSTTP 'IDNC_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='IDNC_unsatisfactory')
    exec asisp_createSTTP 'IDNC_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=IDNC)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=IDNC, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for IDNC-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'IDNC',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=IDNC)
END
-- END RODM_EVENT_DEFINITIONS(IDNC)

-- BEGIN RODM_EVENT_DEFINITIONS(XDR)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=XDR)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_XDR' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_XDR'
    exec("
    create table STCR_EXCT_XDR
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_XDR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_XDR_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_XDR_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_XDR to public
    grant delete on STCR_EXCT_XDR to public
    grant select on STCR_EXCT_XDR to public
    grant update on STCR_EXCT_XDR to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_XDR'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'XDR')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_XDR on STCR_EXCT_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_XDR on STCR_EXCT_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=XDR)
  if not exists (select * from sysobjects where name = 'STCR_STTP_XDR' and type = 'U')
  begin
    print 'Creating table STCR_STTP_XDR'
    exec("
    create table STCR_STTP_XDR
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_XDR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_XDR_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_XDR_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_XDR to public
    grant delete on STCR_STTP_XDR to public
    grant select on STCR_STTP_XDR to public
    grant update on STCR_STTP_XDR to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_XDR'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'XDR')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDR on STCR_STTP_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDR on STCR_STTP_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=XDR)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_XDR' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_XDR'
    exec("
    create table STCR_MSGD_XDR
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_XDR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_XDR_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_XDR_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_XDR to public
    grant delete on STCR_MSGD_XDR to public
    grant select on STCR_MSGD_XDR to public
    grant update on STCR_MSGD_XDR to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_XDR'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'XDR')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_XDR on STCR_MSGD_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_XDR on STCR_MSGD_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDR, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDR' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'XDR'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDR', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=XDR)

if not exists (select * from isa where cid = 'XDR')
begin
  raiserror('No isa relationship has been established for cid XDR -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=XDR)
  if not exists (select * from sysobjects where name = 'STCR_STTP_XDR' and type = 'U')
  begin
    print 'Creating table STCR_STTP_XDR'
    exec("
    create table STCR_STTP_XDR
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_XDR_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_XDR_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_XDR_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_XDR to public
    grant delete on STCR_STTP_XDR to public
    grant select on STCR_STTP_XDR to public
    grant update on STCR_STTP_XDR to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_XDR'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'XDR')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDR on STCR_STTP_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDR on STCR_STTP_XDR FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDR', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_degraded')
    exec asisp_createSTTP 'XDR_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_intermediate')
    exec asisp_createSTTP 'XDR_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_low satisfactory')
    exec asisp_createSTTP 'XDR_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_low unsatisfactory')
    exec asisp_createSTTP 'XDR_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_medium satisfactory')
    exec asisp_createSTTP 'XDR_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_medium unsatisfactory')
    exec asisp_createSTTP 'XDR_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (152)')
    exec asisp_createSTTP 'XDR_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (153)')
    exec asisp_createSTTP 'XDR_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (154)')
    exec asisp_createSTTP 'XDR_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (155)')
    exec asisp_createSTTP 'XDR_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (156)')
    exec asisp_createSTTP 'XDR_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (157)')
    exec asisp_createSTTP 'XDR_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (158)')
    exec asisp_createSTTP 'XDR_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_negative user-defined (159)')
    exec asisp_createSTTP 'XDR_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (136)')
    exec asisp_createSTTP 'XDR_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (137)')
    exec asisp_createSTTP 'XDR_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (138)')
    exec asisp_createSTTP 'XDR_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (139)')
    exec asisp_createSTTP 'XDR_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (140)')
    exec asisp_createSTTP 'XDR_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (141)')
    exec asisp_createSTTP 'XDR_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (142)')
    exec asisp_createSTTP 'XDR_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_positive user-defined (143)')
    exec asisp_createSTTP 'XDR_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDR_satisfactory')
    exec asisp_createSTTP 'XDR_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_severely degraded')
    exec asisp_createSTTP 'XDR_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_unknown')
    exec asisp_createSTTP 'XDR_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDR_unsatisfactory')
    exec asisp_createSTTP 'XDR_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=XDR)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=XDR, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for XDR-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDR',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=XDR)
END
-- END RODM_EVENT_DEFINITIONS(XDR)

-- BEGIN RODM_EVENT_DEFINITIONS(XDRM)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=XDRM)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_XDRM' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_XDRM'
    exec("
    create table STCR_EXCT_XDRM
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_XDRM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_XDRM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_XDRM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_XDRM to public
    grant delete on STCR_EXCT_XDRM to public
    grant select on STCR_EXCT_XDRM to public
    grant update on STCR_EXCT_XDRM to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_XDRM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'XDRM')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_XDRM on STCR_EXCT_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_XDRM on STCR_EXCT_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=XDRM)
  if not exists (select * from sysobjects where name = 'STCR_STTP_XDRM' and type = 'U')
  begin
    print 'Creating table STCR_STTP_XDRM'
    exec("
    create table STCR_STTP_XDRM
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_XDRM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_XDRM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_XDRM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_XDRM to public
    grant delete on STCR_STTP_XDRM to public
    grant select on STCR_STTP_XDRM to public
    grant update on STCR_STTP_XDRM to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_XDRM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'XDRM')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDRM on STCR_STTP_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDRM on STCR_STTP_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=XDRM)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_XDRM' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_XDRM'
    exec("
    create table STCR_MSGD_XDRM
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_XDRM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_XDRM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_XDRM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_XDRM to public
    grant delete on STCR_MSGD_XDRM to public
    grant select on STCR_MSGD_XDRM to public
    grant update on STCR_MSGD_XDRM to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_XDRM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'XDRM')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_XDRM on STCR_MSGD_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_XDRM on STCR_MSGD_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=XDRM, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'XDRM' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'XDRM'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'XDRM', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=XDRM)

if not exists (select * from isa where cid = 'XDRM')
begin
  raiserror('No isa relationship has been established for cid XDRM -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=XDRM)
  if not exists (select * from sysobjects where name = 'STCR_STTP_XDRM' and type = 'U')
  begin
    print 'Creating table STCR_STTP_XDRM'
    exec("
    create table STCR_STTP_XDRM
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_XDRM_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_XDRM_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_XDRM_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_XDRM to public
    grant delete on STCR_STTP_XDRM to public
    grant select on STCR_STTP_XDRM to public
    grant update on STCR_STTP_XDRM to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_XDRM'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'XDRM')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDRM on STCR_STTP_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_XDRM on STCR_STTP_XDRM FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'XDRM', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_degraded')
    exec asisp_createSTTP 'XDRM_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_intermediate')
    exec asisp_createSTTP 'XDRM_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_low satisfactory')
    exec asisp_createSTTP 'XDRM_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_low unsatisfactory')
    exec asisp_createSTTP 'XDRM_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_medium satisfactory')
    exec asisp_createSTTP 'XDRM_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_medium unsatisfactory')
    exec asisp_createSTTP 'XDRM_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (152)')
    exec asisp_createSTTP 'XDRM_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (153)')
    exec asisp_createSTTP 'XDRM_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (154)')
    exec asisp_createSTTP 'XDRM_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (155)')
    exec asisp_createSTTP 'XDRM_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (156)')
    exec asisp_createSTTP 'XDRM_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (157)')
    exec asisp_createSTTP 'XDRM_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (158)')
    exec asisp_createSTTP 'XDRM_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_negative user-defined (159)')
    exec asisp_createSTTP 'XDRM_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (136)')
    exec asisp_createSTTP 'XDRM_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (137)')
    exec asisp_createSTTP 'XDRM_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (138)')
    exec asisp_createSTTP 'XDRM_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (139)')
    exec asisp_createSTTP 'XDRM_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (140)')
    exec asisp_createSTTP 'XDRM_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (141)')
    exec asisp_createSTTP 'XDRM_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (142)')
    exec asisp_createSTTP 'XDRM_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_positive user-defined (143)')
    exec asisp_createSTTP 'XDRM_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='XDRM_satisfactory')
    exec asisp_createSTTP 'XDRM_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_severely degraded')
    exec asisp_createSTTP 'XDRM_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_unknown')
    exec asisp_createSTTP 'XDRM_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='XDRM_unsatisfactory')
    exec asisp_createSTTP 'XDRM_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=XDRM)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=XDRM, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for XDRM-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'XDRM',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=XDRM)
END
-- END RODM_EVENT_DEFINITIONS(XDRM)

-- BEGIN RODM_EVENT_DEFINITIONS(DG)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=DG)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_DG' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_DG'
    exec("
    create table STCR_EXCT_DG
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_DG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_DG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_DG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_DG to public
    grant delete on STCR_EXCT_DG to public
    grant select on STCR_EXCT_DG to public
    grant update on STCR_EXCT_DG to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_DG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'DG')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_DG on STCR_EXCT_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_DG on STCR_EXCT_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=DG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_DG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_DG'
    exec("
    create table STCR_STTP_DG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_DG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_DG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_DG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_DG to public
    grant delete on STCR_STTP_DG to public
    grant select on STCR_STTP_DG to public
    grant update on STCR_STTP_DG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_DG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'DG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_DG on STCR_STTP_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_DG on STCR_STTP_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=DG)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_DG' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_DG'
    exec("
    create table STCR_MSGD_DG
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_DG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_DG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_DG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_DG to public
    grant delete on STCR_MSGD_DG to public
    grant select on STCR_MSGD_DG to public
    grant update on STCR_MSGD_DG to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_DG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'DG')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_DG on STCR_MSGD_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_DG on STCR_MSGD_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=DG, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'DG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'DG'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'DG', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=DG)

if not exists (select * from isa where cid = 'DG')
begin
  raiserror('No isa relationship has been established for cid DG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=DG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_DG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_DG'
    exec("
    create table STCR_STTP_DG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_DG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_DG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_DG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_DG to public
    grant delete on STCR_STTP_DG to public
    grant select on STCR_STTP_DG to public
    grant update on STCR_STTP_DG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_DG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'DG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_DG on STCR_STTP_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_DG on STCR_STTP_DG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'DG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_degraded')
    exec asisp_createSTTP 'DG_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_intermediate')
    exec asisp_createSTTP 'DG_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_low satisfactory')
    exec asisp_createSTTP 'DG_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_low unsatisfactory')
    exec asisp_createSTTP 'DG_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_medium satisfactory')
    exec asisp_createSTTP 'DG_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_medium unsatisfactory')
    exec asisp_createSTTP 'DG_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (152)')
    exec asisp_createSTTP 'DG_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (153)')
    exec asisp_createSTTP 'DG_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (154)')
    exec asisp_createSTTP 'DG_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (155)')
    exec asisp_createSTTP 'DG_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (156)')
    exec asisp_createSTTP 'DG_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (157)')
    exec asisp_createSTTP 'DG_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (158)')
    exec asisp_createSTTP 'DG_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_negative user-defined (159)')
    exec asisp_createSTTP 'DG_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (136)')
    exec asisp_createSTTP 'DG_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (137)')
    exec asisp_createSTTP 'DG_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (138)')
    exec asisp_createSTTP 'DG_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (139)')
    exec asisp_createSTTP 'DG_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (140)')
    exec asisp_createSTTP 'DG_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (141)')
    exec asisp_createSTTP 'DG_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (142)')
    exec asisp_createSTTP 'DG_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_positive user-defined (143)')
    exec asisp_createSTTP 'DG_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='DG_satisfactory')
    exec asisp_createSTTP 'DG_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_severely degraded')
    exec asisp_createSTTP 'DG_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_unknown')
    exec asisp_createSTTP 'DG_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='DG_unsatisfactory')
    exec asisp_createSTTP 'DG_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=DG)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=DG, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for DG-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'DG',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=DG)
END
-- END RODM_EVENT_DEFINITIONS(DG)

-- BEGIN RODM_EVENT_DEFINITIONS(ICND)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=ICND)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_ICND' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_ICND'
    exec("
    create table STCR_EXCT_ICND
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_ICND_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_ICND_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_ICND_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_ICND to public
    grant delete on STCR_EXCT_ICND to public
    grant select on STCR_EXCT_ICND to public
    grant update on STCR_EXCT_ICND to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_ICND'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'ICND')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ICND on STCR_EXCT_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_ICND on STCR_EXCT_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ICND)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ICND' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ICND'
    exec("
    create table STCR_STTP_ICND
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ICND_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ICND_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ICND_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ICND to public
    grant delete on STCR_STTP_ICND to public
    grant select on STCR_STTP_ICND to public
    grant update on STCR_STTP_ICND to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ICND'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ICND')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ICND on STCR_STTP_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ICND on STCR_STTP_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=ICND)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_ICND' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_ICND'
    exec("
    create table STCR_MSGD_ICND
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_ICND_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_ICND_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_ICND_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_ICND to public
    grant delete on STCR_MSGD_ICND to public
    grant select on STCR_MSGD_ICND to public
    grant update on STCR_MSGD_ICND to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_ICND'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'ICND')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ICND on STCR_MSGD_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_ICND on STCR_MSGD_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=ICND, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'ICND' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'ICND'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'ICND', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=ICND)

if not exists (select * from isa where cid = 'ICND')
begin
  raiserror('No isa relationship has been established for cid ICND -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=ICND)
  if not exists (select * from sysobjects where name = 'STCR_STTP_ICND' and type = 'U')
  begin
    print 'Creating table STCR_STTP_ICND'
    exec("
    create table STCR_STTP_ICND
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_ICND_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_ICND_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_ICND_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_ICND to public
    grant delete on STCR_STTP_ICND to public
    grant select on STCR_STTP_ICND to public
    grant update on STCR_STTP_ICND to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_ICND'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'ICND')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ICND on STCR_STTP_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_ICND on STCR_STTP_ICND FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'ICND', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_degraded')
    exec asisp_createSTTP 'ICND_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_intermediate')
    exec asisp_createSTTP 'ICND_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_low satisfactory')
    exec asisp_createSTTP 'ICND_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_low unsatisfactory')
    exec asisp_createSTTP 'ICND_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_medium satisfactory')
    exec asisp_createSTTP 'ICND_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_medium unsatisfactory')
    exec asisp_createSTTP 'ICND_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (152)')
    exec asisp_createSTTP 'ICND_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (153)')
    exec asisp_createSTTP 'ICND_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (154)')
    exec asisp_createSTTP 'ICND_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (155)')
    exec asisp_createSTTP 'ICND_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (156)')
    exec asisp_createSTTP 'ICND_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (157)')
    exec asisp_createSTTP 'ICND_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (158)')
    exec asisp_createSTTP 'ICND_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_negative user-defined (159)')
    exec asisp_createSTTP 'ICND_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (136)')
    exec asisp_createSTTP 'ICND_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (137)')
    exec asisp_createSTTP 'ICND_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (138)')
    exec asisp_createSTTP 'ICND_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (139)')
    exec asisp_createSTTP 'ICND_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (140)')
    exec asisp_createSTTP 'ICND_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (141)')
    exec asisp_createSTTP 'ICND_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (142)')
    exec asisp_createSTTP 'ICND_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_positive user-defined (143)')
    exec asisp_createSTTP 'ICND_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='ICND_satisfactory')
    exec asisp_createSTTP 'ICND_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_severely degraded')
    exec asisp_createSTTP 'ICND_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_unknown')
    exec asisp_createSTTP 'ICND_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='ICND_unsatisfactory')
    exec asisp_createSTTP 'ICND_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=ICND)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=ICND, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for ICND-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'ICND',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=ICND)
END
-- END RODM_EVENT_DEFINITIONS(ICND)

-- BEGIN RODM_EVENT_DEFINITIONS(LENN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=LENN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_LENN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_LENN'
    exec("
    create table STCR_EXCT_LENN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_LENN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_LENN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_LENN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_LENN to public
    grant delete on STCR_EXCT_LENN to public
    grant select on STCR_EXCT_LENN to public
    grant update on STCR_EXCT_LENN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_LENN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'LENN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LENN on STCR_EXCT_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LENN on STCR_EXCT_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LENN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LENN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LENN'
    exec("
    create table STCR_STTP_LENN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LENN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LENN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LENN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LENN to public
    grant delete on STCR_STTP_LENN to public
    grant select on STCR_STTP_LENN to public
    grant update on STCR_STTP_LENN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LENN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LENN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LENN on STCR_STTP_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LENN on STCR_STTP_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=LENN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_LENN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_LENN'
    exec("
    create table STCR_MSGD_LENN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_LENN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_LENN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_LENN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_LENN to public
    grant delete on STCR_MSGD_LENN to public
    grant select on STCR_MSGD_LENN to public
    grant update on STCR_MSGD_LENN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_LENN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'LENN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LENN on STCR_MSGD_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LENN on STCR_MSGD_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LENN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LENN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'LENN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LENN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=LENN)

if not exists (select * from isa where cid = 'LENN')
begin
  raiserror('No isa relationship has been established for cid LENN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LENN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LENN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LENN'
    exec("
    create table STCR_STTP_LENN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LENN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LENN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LENN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LENN to public
    grant delete on STCR_STTP_LENN to public
    grant select on STCR_STTP_LENN to public
    grant update on STCR_STTP_LENN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LENN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LENN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LENN on STCR_STTP_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LENN on STCR_STTP_LENN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LENN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_degraded')
    exec asisp_createSTTP 'LENN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_intermediate')
    exec asisp_createSTTP 'LENN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_low satisfactory')
    exec asisp_createSTTP 'LENN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_low unsatisfactory')
    exec asisp_createSTTP 'LENN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_medium satisfactory')
    exec asisp_createSTTP 'LENN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_medium unsatisfactory')
    exec asisp_createSTTP 'LENN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (152)')
    exec asisp_createSTTP 'LENN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (153)')
    exec asisp_createSTTP 'LENN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (154)')
    exec asisp_createSTTP 'LENN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (155)')
    exec asisp_createSTTP 'LENN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (156)')
    exec asisp_createSTTP 'LENN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (157)')
    exec asisp_createSTTP 'LENN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (158)')
    exec asisp_createSTTP 'LENN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_negative user-defined (159)')
    exec asisp_createSTTP 'LENN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (136)')
    exec asisp_createSTTP 'LENN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (137)')
    exec asisp_createSTTP 'LENN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (138)')
    exec asisp_createSTTP 'LENN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (139)')
    exec asisp_createSTTP 'LENN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (140)')
    exec asisp_createSTTP 'LENN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (141)')
    exec asisp_createSTTP 'LENN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (142)')
    exec asisp_createSTTP 'LENN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_positive user-defined (143)')
    exec asisp_createSTTP 'LENN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LENN_satisfactory')
    exec asisp_createSTTP 'LENN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_severely degraded')
    exec asisp_createSTTP 'LENN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_unknown')
    exec asisp_createSTTP 'LENN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LENN_unsatisfactory')
    exec asisp_createSTTP 'LENN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=LENN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=LENN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for LENN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LENN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=LENN)
END
-- END RODM_EVENT_DEFINITIONS(LENN)

-- BEGIN RODM_EVENT_DEFINITIONS(LL)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=LL)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_LL' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_LL'
    exec("
    create table STCR_EXCT_LL
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_LL_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_LL_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_LL_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_LL to public
    grant delete on STCR_EXCT_LL to public
    grant select on STCR_EXCT_LL to public
    grant update on STCR_EXCT_LL to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_LL'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'LL')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LL on STCR_EXCT_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LL on STCR_EXCT_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LL)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LL' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LL'
    exec("
    create table STCR_STTP_LL
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LL_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LL_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LL_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LL to public
    grant delete on STCR_STTP_LL to public
    grant select on STCR_STTP_LL to public
    grant update on STCR_STTP_LL to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LL'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LL')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LL on STCR_STTP_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LL on STCR_STTP_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=LL)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_LL' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_LL'
    exec("
    create table STCR_MSGD_LL
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_LL_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_LL_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_LL_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_LL to public
    grant delete on STCR_MSGD_LL to public
    grant select on STCR_MSGD_LL to public
    grant update on STCR_MSGD_LL to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_LL'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'LL')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LL on STCR_MSGD_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LL on STCR_MSGD_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LL, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LL' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'LL'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LL', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=LL)

if not exists (select * from isa where cid = 'LL')
begin
  raiserror('No isa relationship has been established for cid LL -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LL)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LL' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LL'
    exec("
    create table STCR_STTP_LL
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LL_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LL_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LL_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LL to public
    grant delete on STCR_STTP_LL to public
    grant select on STCR_STTP_LL to public
    grant update on STCR_STTP_LL to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LL'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LL')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LL on STCR_STTP_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LL on STCR_STTP_LL FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LL', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_degraded')
    exec asisp_createSTTP 'LL_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_intermediate')
    exec asisp_createSTTP 'LL_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_low satisfactory')
    exec asisp_createSTTP 'LL_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_low unsatisfactory')
    exec asisp_createSTTP 'LL_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_medium satisfactory')
    exec asisp_createSTTP 'LL_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_medium unsatisfactory')
    exec asisp_createSTTP 'LL_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (152)')
    exec asisp_createSTTP 'LL_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (153)')
    exec asisp_createSTTP 'LL_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (154)')
    exec asisp_createSTTP 'LL_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (155)')
    exec asisp_createSTTP 'LL_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (156)')
    exec asisp_createSTTP 'LL_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (157)')
    exec asisp_createSTTP 'LL_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (158)')
    exec asisp_createSTTP 'LL_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_negative user-defined (159)')
    exec asisp_createSTTP 'LL_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (136)')
    exec asisp_createSTTP 'LL_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (137)')
    exec asisp_createSTTP 'LL_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (138)')
    exec asisp_createSTTP 'LL_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (139)')
    exec asisp_createSTTP 'LL_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (140)')
    exec asisp_createSTTP 'LL_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (141)')
    exec asisp_createSTTP 'LL_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (142)')
    exec asisp_createSTTP 'LL_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_positive user-defined (143)')
    exec asisp_createSTTP 'LL_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LL_satisfactory')
    exec asisp_createSTTP 'LL_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_severely degraded')
    exec asisp_createSTTP 'LL_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_unknown')
    exec asisp_createSTTP 'LL_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LL_unsatisfactory')
    exec asisp_createSTTP 'LL_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=LL)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=LL, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for LL-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LL',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=LL)
END
-- END RODM_EVENT_DEFINITIONS(LL)

-- BEGIN RODM_EVENT_DEFINITIONS(LU)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=LU)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_LU' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_LU'
    exec("
    create table STCR_EXCT_LU
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_LU_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_LU_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_LU_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_LU to public
    grant delete on STCR_EXCT_LU to public
    grant select on STCR_EXCT_LU to public
    grant update on STCR_EXCT_LU to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_LU'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'LU')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LU on STCR_EXCT_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_LU on STCR_EXCT_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LU)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LU' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LU'
    exec("
    create table STCR_STTP_LU
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LU_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LU_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LU_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LU to public
    grant delete on STCR_STTP_LU to public
    grant select on STCR_STTP_LU to public
    grant update on STCR_STTP_LU to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LU'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LU')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LU on STCR_STTP_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LU on STCR_STTP_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=LU)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_LU' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_LU'
    exec("
    create table STCR_MSGD_LU
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_LU_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_LU_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_LU_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_LU to public
    grant delete on STCR_MSGD_LU to public
    grant select on STCR_MSGD_LU to public
    grant update on STCR_MSGD_LU to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_LU'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'LU')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LU on STCR_MSGD_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_LU on STCR_MSGD_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=LU, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'LU' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'LU'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'LU', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=LU)

if not exists (select * from isa where cid = 'LU')
begin
  raiserror('No isa relationship has been established for cid LU -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=LU)
  if not exists (select * from sysobjects where name = 'STCR_STTP_LU' and type = 'U')
  begin
    print 'Creating table STCR_STTP_LU'
    exec("
    create table STCR_STTP_LU
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_LU_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_LU_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_LU_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_LU to public
    grant delete on STCR_STTP_LU to public
    grant select on STCR_STTP_LU to public
    grant update on STCR_STTP_LU to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_LU'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'LU')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LU on STCR_STTP_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_LU on STCR_STTP_LU FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'LU', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_degraded')
    exec asisp_createSTTP 'LU_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_intermediate')
    exec asisp_createSTTP 'LU_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_low satisfactory')
    exec asisp_createSTTP 'LU_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_low unsatisfactory')
    exec asisp_createSTTP 'LU_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_medium satisfactory')
    exec asisp_createSTTP 'LU_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_medium unsatisfactory')
    exec asisp_createSTTP 'LU_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (152)')
    exec asisp_createSTTP 'LU_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (153)')
    exec asisp_createSTTP 'LU_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (154)')
    exec asisp_createSTTP 'LU_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (155)')
    exec asisp_createSTTP 'LU_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (156)')
    exec asisp_createSTTP 'LU_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (157)')
    exec asisp_createSTTP 'LU_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (158)')
    exec asisp_createSTTP 'LU_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_negative user-defined (159)')
    exec asisp_createSTTP 'LU_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (136)')
    exec asisp_createSTTP 'LU_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (137)')
    exec asisp_createSTTP 'LU_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (138)')
    exec asisp_createSTTP 'LU_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (139)')
    exec asisp_createSTTP 'LU_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (140)')
    exec asisp_createSTTP 'LU_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (141)')
    exec asisp_createSTTP 'LU_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (142)')
    exec asisp_createSTTP 'LU_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_positive user-defined (143)')
    exec asisp_createSTTP 'LU_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='LU_satisfactory')
    exec asisp_createSTTP 'LU_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_severely degraded')
    exec asisp_createSTTP 'LU_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_unknown')
    exec asisp_createSTTP 'LU_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='LU_unsatisfactory')
    exec asisp_createSTTP 'LU_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=LU)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=LU, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for LU-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'LU',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=LU)
END
-- END RODM_EVENT_DEFINITIONS(LU)

-- BEGIN RODM_EVENT_DEFINITIONS(MDH)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=MDH)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_MDH' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_MDH'
    exec("
    create table STCR_EXCT_MDH
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_MDH_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_MDH_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_MDH_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_MDH to public
    grant delete on STCR_EXCT_MDH to public
    grant select on STCR_EXCT_MDH to public
    grant update on STCR_EXCT_MDH to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_MDH'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'MDH')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_MDH on STCR_EXCT_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_MDH on STCR_EXCT_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=MDH)
  if not exists (select * from sysobjects where name = 'STCR_STTP_MDH' and type = 'U')
  begin
    print 'Creating table STCR_STTP_MDH'
    exec("
    create table STCR_STTP_MDH
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_MDH_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_MDH_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_MDH_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_MDH to public
    grant delete on STCR_STTP_MDH to public
    grant select on STCR_STTP_MDH to public
    grant update on STCR_STTP_MDH to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_MDH'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'MDH')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_MDH on STCR_STTP_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_MDH on STCR_STTP_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=MDH)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_MDH' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_MDH'
    exec("
    create table STCR_MSGD_MDH
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_MDH_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_MDH_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_MDH_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_MDH to public
    grant delete on STCR_MSGD_MDH to public
    grant select on STCR_MSGD_MDH to public
    grant update on STCR_MSGD_MDH to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_MDH'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'MDH')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_MDH on STCR_MSGD_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_MDH on STCR_MSGD_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=MDH, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'MDH' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'MDH'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'MDH', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=MDH)

if not exists (select * from isa where cid = 'MDH')
begin
  raiserror('No isa relationship has been established for cid MDH -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=MDH)
  if not exists (select * from sysobjects where name = 'STCR_STTP_MDH' and type = 'U')
  begin
    print 'Creating table STCR_STTP_MDH'
    exec("
    create table STCR_STTP_MDH
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_MDH_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_MDH_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_MDH_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_MDH to public
    grant delete on STCR_STTP_MDH to public
    grant select on STCR_STTP_MDH to public
    grant update on STCR_STTP_MDH to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_MDH'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'MDH')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_MDH on STCR_STTP_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_MDH on STCR_STTP_MDH FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'MDH', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_degraded')
    exec asisp_createSTTP 'MDH_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_intermediate')
    exec asisp_createSTTP 'MDH_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_low satisfactory')
    exec asisp_createSTTP 'MDH_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_low unsatisfactory')
    exec asisp_createSTTP 'MDH_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_medium satisfactory')
    exec asisp_createSTTP 'MDH_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_medium unsatisfactory')
    exec asisp_createSTTP 'MDH_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (152)')
    exec asisp_createSTTP 'MDH_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (153)')
    exec asisp_createSTTP 'MDH_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (154)')
    exec asisp_createSTTP 'MDH_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (155)')
    exec asisp_createSTTP 'MDH_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (156)')
    exec asisp_createSTTP 'MDH_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (157)')
    exec asisp_createSTTP 'MDH_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (158)')
    exec asisp_createSTTP 'MDH_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_negative user-defined (159)')
    exec asisp_createSTTP 'MDH_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (136)')
    exec asisp_createSTTP 'MDH_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (137)')
    exec asisp_createSTTP 'MDH_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (138)')
    exec asisp_createSTTP 'MDH_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (139)')
    exec asisp_createSTTP 'MDH_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (140)')
    exec asisp_createSTTP 'MDH_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (141)')
    exec asisp_createSTTP 'MDH_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (142)')
    exec asisp_createSTTP 'MDH_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_positive user-defined (143)')
    exec asisp_createSTTP 'MDH_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='MDH_satisfactory')
    exec asisp_createSTTP 'MDH_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_severely degraded')
    exec asisp_createSTTP 'MDH_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_unknown')
    exec asisp_createSTTP 'MDH_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='MDH_unsatisfactory')
    exec asisp_createSTTP 'MDH_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=MDH)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=MDH, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for MDH-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'MDH',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=MDH)
END
-- END RODM_EVENT_DEFINITIONS(MDH)

-- BEGIN RODM_EVENT_DEFINITIONS(NVPT)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=NVPT)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_NVPT' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_NVPT'
    exec("
    create table STCR_EXCT_NVPT
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_NVPT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_NVPT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_NVPT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_NVPT to public
    grant delete on STCR_EXCT_NVPT to public
    grant select on STCR_EXCT_NVPT to public
    grant update on STCR_EXCT_NVPT to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_NVPT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'NVPT')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NVPT on STCR_EXCT_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_NVPT on STCR_EXCT_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NVPT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NVPT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NVPT'
    exec("
    create table STCR_STTP_NVPT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NVPT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NVPT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NVPT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NVPT to public
    grant delete on STCR_STTP_NVPT to public
    grant select on STCR_STTP_NVPT to public
    grant update on STCR_STTP_NVPT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NVPT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NVPT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NVPT on STCR_STTP_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NVPT on STCR_STTP_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=NVPT)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_NVPT' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_NVPT'
    exec("
    create table STCR_MSGD_NVPT
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_NVPT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_NVPT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_NVPT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_NVPT to public
    grant delete on STCR_MSGD_NVPT to public
    grant select on STCR_MSGD_NVPT to public
    grant update on STCR_MSGD_NVPT to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_NVPT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'NVPT')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NVPT on STCR_MSGD_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_NVPT on STCR_MSGD_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=NVPT, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'NVPT' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'NVPT'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'NVPT', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=NVPT)

if not exists (select * from isa where cid = 'NVPT')
begin
  raiserror('No isa relationship has been established for cid NVPT -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=NVPT)
  if not exists (select * from sysobjects where name = 'STCR_STTP_NVPT' and type = 'U')
  begin
    print 'Creating table STCR_STTP_NVPT'
    exec("
    create table STCR_STTP_NVPT
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_NVPT_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_NVPT_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_NVPT_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_NVPT to public
    grant delete on STCR_STTP_NVPT to public
    grant select on STCR_STTP_NVPT to public
    grant update on STCR_STTP_NVPT to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_NVPT'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'NVPT')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NVPT on STCR_STTP_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_NVPT on STCR_STTP_NVPT FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'NVPT', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_degraded')
    exec asisp_createSTTP 'NVPT_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_intermediate')
    exec asisp_createSTTP 'NVPT_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_low satisfactory')
    exec asisp_createSTTP 'NVPT_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_low unsatisfactory')
    exec asisp_createSTTP 'NVPT_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_medium satisfactory')
    exec asisp_createSTTP 'NVPT_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_medium unsatisfactory')
    exec asisp_createSTTP 'NVPT_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (152)')
    exec asisp_createSTTP 'NVPT_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (153)')
    exec asisp_createSTTP 'NVPT_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (154)')
    exec asisp_createSTTP 'NVPT_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (155)')
    exec asisp_createSTTP 'NVPT_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (156)')
    exec asisp_createSTTP 'NVPT_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (157)')
    exec asisp_createSTTP 'NVPT_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (158)')
    exec asisp_createSTTP 'NVPT_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_negative user-defined (159)')
    exec asisp_createSTTP 'NVPT_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (136)')
    exec asisp_createSTTP 'NVPT_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (137)')
    exec asisp_createSTTP 'NVPT_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (138)')
    exec asisp_createSTTP 'NVPT_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (139)')
    exec asisp_createSTTP 'NVPT_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (140)')
    exec asisp_createSTTP 'NVPT_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (141)')
    exec asisp_createSTTP 'NVPT_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (142)')
    exec asisp_createSTTP 'NVPT_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_positive user-defined (143)')
    exec asisp_createSTTP 'NVPT_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='NVPT_satisfactory')
    exec asisp_createSTTP 'NVPT_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_severely degraded')
    exec asisp_createSTTP 'NVPT_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_unknown')
    exec asisp_createSTTP 'NVPT_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='NVPT_unsatisfactory')
    exec asisp_createSTTP 'NVPT_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=NVPT)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=NVPT, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for NVPT-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'NVPT',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=NVPT)
END
-- END RODM_EVENT_DEFINITIONS(NVPT)

-- BEGIN RODM_EVENT_DEFINITIONS(SNAN)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=SNAN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_SNAN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_SNAN'
    exec("
    create table STCR_EXCT_SNAN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_SNAN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_SNAN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_SNAN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_SNAN to public
    grant delete on STCR_EXCT_SNAN to public
    grant select on STCR_EXCT_SNAN to public
    grant update on STCR_EXCT_SNAN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_SNAN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'SNAN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_SNAN on STCR_EXCT_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_SNAN on STCR_EXCT_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=SNAN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_SNAN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_SNAN'
    exec("
    create table STCR_STTP_SNAN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_SNAN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_SNAN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_SNAN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_SNAN to public
    grant delete on STCR_STTP_SNAN to public
    grant select on STCR_STTP_SNAN to public
    grant update on STCR_STTP_SNAN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_SNAN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'SNAN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_SNAN on STCR_STTP_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_SNAN on STCR_STTP_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=SNAN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_SNAN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_SNAN'
    exec("
    create table STCR_MSGD_SNAN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_SNAN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_SNAN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_SNAN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_SNAN to public
    grant delete on STCR_MSGD_SNAN to public
    grant select on STCR_MSGD_SNAN to public
    grant update on STCR_MSGD_SNAN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_SNAN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'SNAN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_SNAN on STCR_MSGD_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_SNAN on STCR_MSGD_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=SNAN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'SNAN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'SNAN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'SNAN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=SNAN)

if not exists (select * from isa where cid = 'SNAN')
begin
  raiserror('No isa relationship has been established for cid SNAN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=SNAN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_SNAN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_SNAN'
    exec("
    create table STCR_STTP_SNAN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_SNAN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_SNAN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_SNAN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_SNAN to public
    grant delete on STCR_STTP_SNAN to public
    grant select on STCR_STTP_SNAN to public
    grant update on STCR_STTP_SNAN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_SNAN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'SNAN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_SNAN on STCR_STTP_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_SNAN on STCR_STTP_SNAN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'SNAN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_degraded')
    exec asisp_createSTTP 'SNAN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_intermediate')
    exec asisp_createSTTP 'SNAN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_low satisfactory')
    exec asisp_createSTTP 'SNAN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_low unsatisfactory')
    exec asisp_createSTTP 'SNAN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_medium satisfactory')
    exec asisp_createSTTP 'SNAN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_medium unsatisfactory')
    exec asisp_createSTTP 'SNAN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (152)')
    exec asisp_createSTTP 'SNAN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (153)')
    exec asisp_createSTTP 'SNAN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (154)')
    exec asisp_createSTTP 'SNAN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (155)')
    exec asisp_createSTTP 'SNAN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (156)')
    exec asisp_createSTTP 'SNAN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (157)')
    exec asisp_createSTTP 'SNAN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (158)')
    exec asisp_createSTTP 'SNAN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_negative user-defined (159)')
    exec asisp_createSTTP 'SNAN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (136)')
    exec asisp_createSTTP 'SNAN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (137)')
    exec asisp_createSTTP 'SNAN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (138)')
    exec asisp_createSTTP 'SNAN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (139)')
    exec asisp_createSTTP 'SNAN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (140)')
    exec asisp_createSTTP 'SNAN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (141)')
    exec asisp_createSTTP 'SNAN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (142)')
    exec asisp_createSTTP 'SNAN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_positive user-defined (143)')
    exec asisp_createSTTP 'SNAN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='SNAN_satisfactory')
    exec asisp_createSTTP 'SNAN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_severely degraded')
    exec asisp_createSTTP 'SNAN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_unknown')
    exec asisp_createSTTP 'SNAN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='SNAN_unsatisfactory')
    exec asisp_createSTTP 'SNAN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=SNAN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=SNAN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for SNAN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'SNAN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=SNAN)
END
-- END RODM_EVENT_DEFINITIONS(SNAN)

-- BEGIN RODM_EVENT_DEFINITIONS(T21N)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=T21N)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_T21N' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_T21N'
    exec("
    create table STCR_EXCT_T21N
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_T21N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_T21N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_T21N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_T21N to public
    grant delete on STCR_EXCT_T21N to public
    grant select on STCR_EXCT_T21N to public
    grant update on STCR_EXCT_T21N to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_T21N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'T21N')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T21N on STCR_EXCT_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T21N on STCR_EXCT_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T21N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T21N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T21N'
    exec("
    create table STCR_STTP_T21N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T21N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T21N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T21N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T21N to public
    grant delete on STCR_STTP_T21N to public
    grant select on STCR_STTP_T21N to public
    grant update on STCR_STTP_T21N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T21N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T21N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T21N on STCR_STTP_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T21N on STCR_STTP_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=T21N)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_T21N' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_T21N'
    exec("
    create table STCR_MSGD_T21N
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_T21N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_T21N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_T21N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_T21N to public
    grant delete on STCR_MSGD_T21N to public
    grant select on STCR_MSGD_T21N to public
    grant update on STCR_MSGD_T21N to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_T21N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'T21N')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T21N on STCR_MSGD_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T21N on STCR_MSGD_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T21N, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T21N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'T21N'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T21N', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=T21N)

if not exists (select * from isa where cid = 'T21N')
begin
  raiserror('No isa relationship has been established for cid T21N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T21N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T21N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T21N'
    exec("
    create table STCR_STTP_T21N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T21N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T21N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T21N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T21N to public
    grant delete on STCR_STTP_T21N to public
    grant select on STCR_STTP_T21N to public
    grant update on STCR_STTP_T21N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T21N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T21N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T21N on STCR_STTP_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T21N on STCR_STTP_T21N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T21N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_degraded')
    exec asisp_createSTTP 'T21N_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_intermediate')
    exec asisp_createSTTP 'T21N_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_low satisfactory')
    exec asisp_createSTTP 'T21N_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_low unsatisfactory')
    exec asisp_createSTTP 'T21N_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_medium satisfactory')
    exec asisp_createSTTP 'T21N_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_medium unsatisfactory')
    exec asisp_createSTTP 'T21N_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (152)')
    exec asisp_createSTTP 'T21N_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (153)')
    exec asisp_createSTTP 'T21N_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (154)')
    exec asisp_createSTTP 'T21N_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (155)')
    exec asisp_createSTTP 'T21N_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (156)')
    exec asisp_createSTTP 'T21N_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (157)')
    exec asisp_createSTTP 'T21N_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (158)')
    exec asisp_createSTTP 'T21N_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_negative user-defined (159)')
    exec asisp_createSTTP 'T21N_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (136)')
    exec asisp_createSTTP 'T21N_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (137)')
    exec asisp_createSTTP 'T21N_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (138)')
    exec asisp_createSTTP 'T21N_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (139)')
    exec asisp_createSTTP 'T21N_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (140)')
    exec asisp_createSTTP 'T21N_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (141)')
    exec asisp_createSTTP 'T21N_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (142)')
    exec asisp_createSTTP 'T21N_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_positive user-defined (143)')
    exec asisp_createSTTP 'T21N_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T21N_satisfactory')
    exec asisp_createSTTP 'T21N_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_severely degraded')
    exec asisp_createSTTP 'T21N_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_unknown')
    exec asisp_createSTTP 'T21N_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T21N_unsatisfactory')
    exec asisp_createSTTP 'T21N_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=T21N)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=T21N, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for T21N-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T21N',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=T21N)
END
-- END RODM_EVENT_DEFINITIONS(T21N)

-- BEGIN RODM_EVENT_DEFINITIONS(T4N)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=T4N)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_T4N' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_T4N'
    exec("
    create table STCR_EXCT_T4N
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_T4N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_T4N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_T4N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_T4N to public
    grant delete on STCR_EXCT_T4N to public
    grant select on STCR_EXCT_T4N to public
    grant update on STCR_EXCT_T4N to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_T4N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'T4N')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T4N on STCR_EXCT_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T4N on STCR_EXCT_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T4N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T4N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T4N'
    exec("
    create table STCR_STTP_T4N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T4N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T4N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T4N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T4N to public
    grant delete on STCR_STTP_T4N to public
    grant select on STCR_STTP_T4N to public
    grant update on STCR_STTP_T4N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T4N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T4N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4N on STCR_STTP_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4N on STCR_STTP_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=T4N)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_T4N' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_T4N'
    exec("
    create table STCR_MSGD_T4N
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_T4N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_T4N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_T4N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_T4N to public
    grant delete on STCR_MSGD_T4N to public
    grant select on STCR_MSGD_T4N to public
    grant update on STCR_MSGD_T4N to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_T4N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'T4N')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T4N on STCR_MSGD_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T4N on STCR_MSGD_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4N, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'T4N'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4N', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=T4N)

if not exists (select * from isa where cid = 'T4N')
begin
  raiserror('No isa relationship has been established for cid T4N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T4N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T4N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T4N'
    exec("
    create table STCR_STTP_T4N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T4N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T4N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T4N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T4N to public
    grant delete on STCR_STTP_T4N to public
    grant select on STCR_STTP_T4N to public
    grant update on STCR_STTP_T4N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T4N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T4N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4N on STCR_STTP_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4N on STCR_STTP_T4N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_degraded')
    exec asisp_createSTTP 'T4N_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_intermediate')
    exec asisp_createSTTP 'T4N_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_low satisfactory')
    exec asisp_createSTTP 'T4N_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_low unsatisfactory')
    exec asisp_createSTTP 'T4N_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_medium satisfactory')
    exec asisp_createSTTP 'T4N_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_medium unsatisfactory')
    exec asisp_createSTTP 'T4N_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (152)')
    exec asisp_createSTTP 'T4N_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (153)')
    exec asisp_createSTTP 'T4N_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (154)')
    exec asisp_createSTTP 'T4N_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (155)')
    exec asisp_createSTTP 'T4N_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (156)')
    exec asisp_createSTTP 'T4N_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (157)')
    exec asisp_createSTTP 'T4N_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (158)')
    exec asisp_createSTTP 'T4N_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_negative user-defined (159)')
    exec asisp_createSTTP 'T4N_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (136)')
    exec asisp_createSTTP 'T4N_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (137)')
    exec asisp_createSTTP 'T4N_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (138)')
    exec asisp_createSTTP 'T4N_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (139)')
    exec asisp_createSTTP 'T4N_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (140)')
    exec asisp_createSTTP 'T4N_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (141)')
    exec asisp_createSTTP 'T4N_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (142)')
    exec asisp_createSTTP 'T4N_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_positive user-defined (143)')
    exec asisp_createSTTP 'T4N_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4N_satisfactory')
    exec asisp_createSTTP 'T4N_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_severely degraded')
    exec asisp_createSTTP 'T4N_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_unknown')
    exec asisp_createSTTP 'T4N_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4N_unsatisfactory')
    exec asisp_createSTTP 'T4N_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=T4N)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=T4N, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for T4N-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4N',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=T4N)
END
-- END RODM_EVENT_DEFINITIONS(T4N)

-- BEGIN RODM_EVENT_DEFINITIONS(T4NG)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=T4NG)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_T4NG' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_T4NG'
    exec("
    create table STCR_EXCT_T4NG
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_T4NG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_T4NG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_T4NG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_T4NG to public
    grant delete on STCR_EXCT_T4NG to public
    grant select on STCR_EXCT_T4NG to public
    grant update on STCR_EXCT_T4NG to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_T4NG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'T4NG')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T4NG on STCR_EXCT_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T4NG on STCR_EXCT_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T4NG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T4NG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T4NG'
    exec("
    create table STCR_STTP_T4NG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T4NG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T4NG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T4NG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T4NG to public
    grant delete on STCR_STTP_T4NG to public
    grant select on STCR_STTP_T4NG to public
    grant update on STCR_STTP_T4NG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T4NG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T4NG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4NG on STCR_STTP_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4NG on STCR_STTP_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=T4NG)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_T4NG' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_T4NG'
    exec("
    create table STCR_MSGD_T4NG
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_T4NG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_T4NG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_T4NG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_T4NG to public
    grant delete on STCR_MSGD_T4NG to public
    grant select on STCR_MSGD_T4NG to public
    grant update on STCR_MSGD_T4NG to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_T4NG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'T4NG')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T4NG on STCR_MSGD_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T4NG on STCR_MSGD_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T4NG, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T4NG' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'T4NG'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T4NG', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=T4NG)

if not exists (select * from isa where cid = 'T4NG')
begin
  raiserror('No isa relationship has been established for cid T4NG -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T4NG)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T4NG' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T4NG'
    exec("
    create table STCR_STTP_T4NG
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T4NG_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T4NG_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T4NG_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T4NG to public
    grant delete on STCR_STTP_T4NG to public
    grant select on STCR_STTP_T4NG to public
    grant update on STCR_STTP_T4NG to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T4NG'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T4NG')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4NG on STCR_STTP_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T4NG on STCR_STTP_T4NG FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T4NG', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_degraded')
    exec asisp_createSTTP 'T4NG_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_intermediate')
    exec asisp_createSTTP 'T4NG_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_low satisfactory')
    exec asisp_createSTTP 'T4NG_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_low unsatisfactory')
    exec asisp_createSTTP 'T4NG_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_medium satisfactory')
    exec asisp_createSTTP 'T4NG_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_medium unsatisfactory')
    exec asisp_createSTTP 'T4NG_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (152)')
    exec asisp_createSTTP 'T4NG_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (153)')
    exec asisp_createSTTP 'T4NG_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (154)')
    exec asisp_createSTTP 'T4NG_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (155)')
    exec asisp_createSTTP 'T4NG_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (156)')
    exec asisp_createSTTP 'T4NG_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (157)')
    exec asisp_createSTTP 'T4NG_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (158)')
    exec asisp_createSTTP 'T4NG_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_negative user-defined (159)')
    exec asisp_createSTTP 'T4NG_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (136)')
    exec asisp_createSTTP 'T4NG_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (137)')
    exec asisp_createSTTP 'T4NG_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (138)')
    exec asisp_createSTTP 'T4NG_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (139)')
    exec asisp_createSTTP 'T4NG_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (140)')
    exec asisp_createSTTP 'T4NG_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (141)')
    exec asisp_createSTTP 'T4NG_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (142)')
    exec asisp_createSTTP 'T4NG_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_positive user-defined (143)')
    exec asisp_createSTTP 'T4NG_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T4NG_satisfactory')
    exec asisp_createSTTP 'T4NG_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_severely degraded')
    exec asisp_createSTTP 'T4NG_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_unknown')
    exec asisp_createSTTP 'T4NG_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T4NG_unsatisfactory')
    exec asisp_createSTTP 'T4NG_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=T4NG)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=T4NG, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for T4NG-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T4NG',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=T4NG)
END
-- END RODM_EVENT_DEFINITIONS(T4NG)

-- BEGIN RODM_EVENT_DEFINITIONS(T5N)
-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=EXCT, 'PHYC'=T5N)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_T5N' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_T5N'
    exec("
    create table STCR_EXCT_T5N
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_T5N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_T5N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_T5N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_T5N to public
    grant delete on STCR_EXCT_T5N to public
    grant select on STCR_EXCT_T5N to public
    grant update on STCR_EXCT_T5N to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_T5N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'T5N')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T5N on STCR_EXCT_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_T5N on STCR_EXCT_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T5N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T5N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T5N'
    exec("
    create table STCR_STTP_T5N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T5N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T5N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T5N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T5N to public
    grant delete on STCR_STTP_T5N to public
    grant select on STCR_STTP_T5N to public
    grant update on STCR_STTP_T5N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T5N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T5N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T5N on STCR_STTP_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T5N on STCR_STTP_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=MSGD, 'PHYC'=T5N)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_T5N' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_T5N'
    exec("
    create table STCR_MSGD_T5N
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_T5N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_T5N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_T5N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_T5N to public
    grant delete on STCR_MSGD_T5N to public
    grant select on STCR_MSGD_T5N to public
    grant update on STCR_MSGD_T5N to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_T5N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'T5N')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T5N on STCR_MSGD_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_T5N on STCR_MSGD_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=T5N, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'T5N' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'T5N'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'T5N', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=T5N)

if not exists (select * from isa where cid = 'T5N')
begin
  raiserror('No isa relationship has been established for cid T5N -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('SNNT'=STCR, 'SHLO'=STTP, 'PHYC'=T5N)
  if not exists (select * from sysobjects where name = 'STCR_STTP_T5N' and type = 'U')
  begin
    print 'Creating table STCR_STTP_T5N'
    exec("
    create table STCR_STTP_T5N
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_T5N_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_T5N_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_T5N_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_T5N to public
    grant delete on STCR_STTP_T5N to public
    grant select on STCR_STTP_T5N to public
    grant update on STCR_STTP_T5N to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_T5N'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'T5N')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T5N on STCR_STTP_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_T5N on STCR_STTP_T5N FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'T5N', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_degraded')
    exec asisp_createSTTP 'T5N_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_intermediate')
    exec asisp_createSTTP 'T5N_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_low satisfactory')
    exec asisp_createSTTP 'T5N_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_low unsatisfactory')
    exec asisp_createSTTP 'T5N_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_medium satisfactory')
    exec asisp_createSTTP 'T5N_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_medium unsatisfactory')
    exec asisp_createSTTP 'T5N_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (152)')
    exec asisp_createSTTP 'T5N_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (153)')
    exec asisp_createSTTP 'T5N_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (154)')
    exec asisp_createSTTP 'T5N_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (155)')
    exec asisp_createSTTP 'T5N_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (156)')
    exec asisp_createSTTP 'T5N_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (157)')
    exec asisp_createSTTP 'T5N_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (158)')
    exec asisp_createSTTP 'T5N_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_negative user-defined (159)')
    exec asisp_createSTTP 'T5N_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (136)')
    exec asisp_createSTTP 'T5N_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (137)')
    exec asisp_createSTTP 'T5N_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (138)')
    exec asisp_createSTTP 'T5N_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (139)')
    exec asisp_createSTTP 'T5N_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (140)')
    exec asisp_createSTTP 'T5N_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (141)')
    exec asisp_createSTTP 'T5N_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (142)')
    exec asisp_createSTTP 'T5N_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_positive user-defined (143)')
    exec asisp_createSTTP 'T5N_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='T5N_satisfactory')
    exec asisp_createSTTP 'T5N_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_severely degraded')
    exec asisp_createSTTP 'T5N_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_unknown')
    exec asisp_createSTTP 'T5N_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='T5N_unsatisfactory')
    exec asisp_createSTTP 'T5N_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=T5N)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=T5N, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for T5N-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'T5N',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=T5N)
END
-- END RODM_EVENT_DEFINITIONS(T5N)

-- BEGIN RODM_EVENT_DEFINITIONS(VRN)
-- CREATE_LINK_TABLE('T5N'=STCR, 'XDRM'=EXCT, 'PHYC'=VRN)
  if not exists (select * from sysobjects where name = 'STCR_EXCT_VRN' and type = 'U')
  begin
    print 'Creating table STCR_EXCT_VRN'
    exec("
    create table STCR_EXCT_VRN
    (
      src_id       ObjID    CONSTRAINT STCR_EXCT_VRN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_EXCT_VRN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_EXCT_VRN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_EXCT_VRN to public
    grant delete on STCR_EXCT_VRN to public
    grant select on STCR_EXCT_VRN to public
    grant update on STCR_EXCT_VRN to public
    ")
  end
  print 'Creating trigger tI_STCR_EXCT_VRN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'EXCT' AND dol.link_type = 'VRN')
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_VRN on STCR_EXCT_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'EXCT', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_EXCT_VRN on STCR_EXCT_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'EXCT', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('T5N'=STCR, 'XDRM'=STTP, 'PHYC'=VRN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_VRN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_VRN'
    exec("
    create table STCR_STTP_VRN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_VRN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_VRN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_VRN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_VRN to public
    grant delete on STCR_STTP_VRN to public
    grant select on STCR_STTP_VRN to public
    grant update on STCR_STTP_VRN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_VRN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'VRN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_VRN on STCR_STTP_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_VRN on STCR_STTP_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

-- CREATE_LINK_TABLE('T5N'=STCR, 'XDRM'=MSGD, 'PHYC'=VRN)
  if not exists (select * from sysobjects where name = 'STCR_MSGD_VRN' and type = 'U')
  begin
    print 'Creating table STCR_MSGD_VRN'
    exec("
    create table STCR_MSGD_VRN
    (
      src_id       ObjID    CONSTRAINT STCR_MSGD_VRN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_MSGD_VRN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_MSGD_VRN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_MSGD_VRN to public
    grant delete on STCR_MSGD_VRN to public
    grant select on STCR_MSGD_VRN to public
    grant update on STCR_MSGD_VRN to public
    ")
  end
  print 'Creating trigger tI_STCR_MSGD_VRN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'MSGD' AND dol.link_type = 'VRN')
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_VRN on STCR_MSGD_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'MSGD', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_MSGD_VRN on STCR_MSGD_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'MSGD', dst_id FROM inserted
  ")


-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='RODM Register Action Responses', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'RODM Register Action Responses'
  )
  begin
    exec asisp_createEXCT 'RODM Register Action Responses', STCR, 1, @Desc='RODM Register Action Responses', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER FAILED, DESC='RODM Register Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'RODM Register Action Responses', 'RODMREGISTER FAILED', 'RODM Register Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMREGISTER SUCCEEDED, DESC='RODM Register Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'RODM Register Action Responses', 'RODMREGISTER SUCCEEDED', 'RODM Register Succeeded', 'Green', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER FAILED, DESC='RODM Unregister Failed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'RODM Register Action Responses', 'RODMUNREGISTER FAILED', 'RODM Unregister Failed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=RODMUNREGISTER SUCCEEDED, DESC='RODM Unregister Succeeded', ALERT=Green, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'RODM Register Action Responses', 'RODMUNREGISTER SUCCEEDED', 'RODM Unregister Succeeded', 'Green', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Administrative State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Administrative State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Administrative State Exceptions', STCR, 1, @Desc='Administrative State Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Administrative State is not currently set, DESC='Administrative State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Administrative State Exceptions', 'Administrative State is not currently set', 'Administrative State is not currently set', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State locked, DESC='Administrative State locked', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Administrative State Exceptions', 'Administrative State locked', 'Administrative State locked', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State shutting down, DESC='Administrative State shutting down', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Administrative State Exceptions', 'Administrative State shutting down', 'Administrative State shutting down', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Administrative State unlocked, DESC='Administrative State unlocked', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Administrative State Exceptions', 'Administrative State unlocked', 'Administrative State unlocked', 'Green', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Availability Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Availability Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Availability Status Exceptions', STCR, 1, @Desc='Availability Status Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Availability Status degraded, DESC='Availability Status degraded', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status degraded', 'Availability Status degraded', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status dependency, DESC='Availability Status dependency', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status dependency', 'Availability Status dependency', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status failed, DESC='Availability Status failed', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status failed', 'Availability Status failed', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status in test, DESC='Availability Status in test', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status in test', 'Availability Status in test', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status not installed, DESC='Availability Status not installed', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status not installed', 'Availability Status not installed', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status off duty, DESC='Availability Status off duty', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status off duty', 'Availability Status off duty', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status offline, DESC='Availability Status offline', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status offline', 'Availability Status offline', 'Red', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Availability Status power off, DESC='Availability Status power off', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Availability Status Exceptions', 'Availability Status power off', 'Availability Status power off', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Native Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Native Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Native Status Exceptions', STCR, 1, @Desc='Native Status Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Native Status active, DESC='Native Status active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status active', 'Native Status active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status active with session, DESC='Native Status active with session', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status active with session', 'Native Status active with session', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status congested, DESC='Native Status congested', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status congested', 'Native Status congested', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status connectable, DESC='Native Status connectable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status connectable', 'Native Status connectable', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inactive, DESC='Native Status inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status inactive', 'Native Status inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status inoperative, DESC='Native Status inoperative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status inoperative', 'Native Status inoperative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status is not currently set, DESC='Native Status is not currently set', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status is not currently set', 'Native Status is not currently set', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status never active, DESC='Native Status never active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status never active', 'Native Status never active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status operative, DESC='Native Status operative', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status operative', 'Native Status operative', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active, DESC='Native Status pending active', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status pending active', 'Native Status pending active', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending active or inactive, DESC='Native Status pending active or inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status pending active or inactive', 'Native Status pending active or inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status pending inactive, DESC='Native Status pending inactive', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status pending inactive', 'Native Status pending inactive', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released, DESC='Native Status released', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status released', 'Native Status released', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status released or reset, DESC='Native Status released or reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status released or reset', 'Native Status released or reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status reset, DESC='Native Status reset', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status reset', 'Native Status reset', 'Yellow', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Native Status routable, DESC='Native Status routable', ALERT=Yellow, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Native Status Exceptions', 'Native Status routable', 'Native Status routable', 'Yellow', 'Ignore', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Operational State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Operational State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Operational State Exceptions', STCR, 1, @Desc='Operational State Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Operational State disabled, DESC='Operational State disabled', ALERT=Red, PRIORITY=Critical, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Operational State Exceptions', 'Operational State disabled', 'Operational State disabled', 'Red', 'Critical', 0
  /* EXCEPTION_TYPE(EXCP=Operational State is not currently set, DESC='Operational State is not currently set', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Operational State Exceptions', 'Operational State is not currently set', 'Operational State is not currently set', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Procedural Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Procedural Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Procedural Status Exceptions', STCR, 1, @Desc='Procedural Status Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Procedural Status initialization required, DESC='Procedural Status initialization required', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Procedural Status Exceptions', 'Procedural Status initialization required', 'Procedural Status initialization required', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status initializing, DESC='Procedural Status initializing', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Procedural Status Exceptions', 'Procedural Status initializing', 'Procedural Status initializing', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status not initialized, DESC='Procedural Status not initialized', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Procedural Status Exceptions', 'Procedural Status not initialized', 'Procedural Status not initialized', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status reporting, DESC='Procedural Status reporting', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Procedural Status Exceptions', 'Procedural Status reporting', 'Procedural Status reporting', 'Yellow', 'High', 0
  /* EXCEPTION_TYPE(EXCP=Procedural Status terminating, DESC='Procedural Status terminating', ALERT=Yellow, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Procedural Status Exceptions', 'Procedural Status terminating', 'Procedural Status terminating', 'Yellow', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Unknown Status Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Unknown Status Exceptions'
  )
  begin
    exec asisp_createEXCT 'Unknown Status Exceptions', STCR, 1, @Desc='Unknown Status Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Unknown Status, DESC='Unknown Status', ALERT=Red, PRIORITY=High, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Unknown Status Exceptions', 'Unknown Status', 'Unknown Status', 'Red', 'High', 0
end

-- BEGIN_EXCEPTION_CATEGORY(CID=VRN, NAME='Usage State Exceptions', ORDER=)
begin
  if not exists 
  (
    select * from ExceptionCategory_C as exct join link as l on id = dst_id 
    where l.link_type = 'VRN' and l.src_cid = 'STCR' and l.dst_cid = 'EXCT' and l.deleted = 0 
      and exct.name = 'Usage State Exceptions'
  )
  begin
    exec asisp_createEXCT 'Usage State Exceptions', STCR, 1, @Desc='Usage State Exceptions', @Order=0, @link_type = 'VRN'
  end
  /* EXCEPTION_TYPE(EXCP=Usage State active, DESC='Usage State active', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Usage State Exceptions', 'Usage State active', 'Usage State active', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State busy, DESC='Usage State busy', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Usage State Exceptions', 'Usage State busy', 'Usage State busy', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State idle, DESC='Usage State idle', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Usage State Exceptions', 'Usage State idle', 'Usage State idle', 'Green', 'Ignore', 0
  /* EXCEPTION_TYPE(EXCP=Usage State is not currently set, DESC='Usage State is not currently set', ALERT=Green, PRIORITY=Ignore, SALIENCE=) */
  EXEC asisp_defineExceptionType 'VRN', 'Usage State Exceptions', 'Usage State is not currently set', 'Usage State is not currently set', 'Green', 'Ignore', 0
end

-- BEGIN_STATE_TYPES(CID=VRN)

if not exists (select * from isa where cid = 'VRN')
begin
  raiserror('No isa relationship has been established for cid VRN -- cannot define state types!', 5, 1)
end
else
begin  -- CREATE_LINK_TABLE('T5N'=STCR, 'XDRM'=STTP, 'PHYC'=VRN)
  if not exists (select * from sysobjects where name = 'STCR_STTP_VRN' and type = 'U')
  begin
    print 'Creating table STCR_STTP_VRN'
    exec("
    create table STCR_STTP_VRN
    (
      src_id       ObjID    CONSTRAINT STCR_STTP_VRN_PK PRIMARY KEY CLUSTERED(src_id, dst_id),
      dst_id       ObjID,
      ctime        datetime CONSTRAINT STCR_STTP_VRN_ctime_DF DEFAULT getdate(),
      deleted      tinyint  CONSTRAINT STCR_STTP_VRN_deleted_DF DEFAULT 0
    )
    ")
    exec("
    grant insert on STCR_STTP_VRN to public
    grant delete on STCR_STTP_VRN to public
    grant select on STCR_STTP_VRN to public
    grant update on STCR_STTP_VRN to public
    ")
  end
  print 'Creating trigger tI_STCR_STTP_VRN'
  IF EXISTS (SELECT * FROM derived_obj_link AS dol JOIN link_type AS lt ON lt.link_type = dol.link_type WHERE lt.flag_containment = 1 AND dol.src_cid = 'STCR' AND dol.dst_cid = 'STTP' AND dol.link_type = 'VRN')
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_VRN on STCR_STTP_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT containment(dst_cid, dst_id, src_cid, src_id)  SELECT 'STTP', dst_id, 'STCR', src_id FROM inserted
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")
  ELSE
  EXEC("
  CREATE TRIGGER tI_STCR_STTP_VRN on STCR_STTP_VRN FOR INSERT AS
    DECLARE @rc int, @src_id ObjID, @dst_id ObjID
    SELECT @rc=@@rowcount
    INSERT link(link_type, src_cid, src_id, dst_cid, dst_id)
      SELECT 'VRN', 'STCR', src_id, 'STTP', dst_id FROM inserted
  ")

  -- STATE_TYPE(NAME=degraded, STATE='degraded', DESCRIPTION='degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_degraded')
    exec asisp_createSTTP 'VRN_degraded', STCR, 1, 'degraded', 'degraded', 0, 2
  -- STATE_TYPE(NAME=intermediate, STATE='intermediate', DESCRIPTION='intermediate', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_intermediate')
    exec asisp_createSTTP 'VRN_intermediate', STCR, 1, 'intermediate', 'intermediate', 0, 2
  -- STATE_TYPE(NAME=low satisfactory, STATE='low satisfactory', DESCRIPTION='low satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_low satisfactory')
    exec asisp_createSTTP 'VRN_low satisfactory', STCR, 1, 'low satisfactory', 'low satisfactory', 0, 3
  -- STATE_TYPE(NAME=low unsatisfactory, STATE='low unsatisfactory', DESCRIPTION='low unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_low unsatisfactory')
    exec asisp_createSTTP 'VRN_low unsatisfactory', STCR, 1, 'low unsatisfactory', 'low unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=medium satisfactory, STATE='medium satisfactory', DESCRIPTION='medium satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_medium satisfactory')
    exec asisp_createSTTP 'VRN_medium satisfactory', STCR, 1, 'medium satisfactory', 'medium satisfactory', 0, 3
  -- STATE_TYPE(NAME=medium unsatisfactory, STATE='medium unsatisfactory', DESCRIPTION='medium unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_medium unsatisfactory')
    exec asisp_createSTTP 'VRN_medium unsatisfactory', STCR, 1, 'medium unsatisfactory', 'medium unsatisfactory', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (152), STATE='negative user-defined (152)', DESCRIPTION='negative user-defined (152)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (152)')
    exec asisp_createSTTP 'VRN_negative user-defined (152)', STCR, 1, 'negative user-defined (152)', 'negative user-defined (152)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (153), STATE='negative user-defined (153)', DESCRIPTION='negative user-defined (153)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (153)')
    exec asisp_createSTTP 'VRN_negative user-defined (153)', STCR, 1, 'negative user-defined (153)', 'negative user-defined (153)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (154), STATE='negative user-defined (154)', DESCRIPTION='negative user-defined (154)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (154)')
    exec asisp_createSTTP 'VRN_negative user-defined (154)', STCR, 1, 'negative user-defined (154)', 'negative user-defined (154)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (155), STATE='negative user-defined (155)', DESCRIPTION='negative user-defined (155)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (155)')
    exec asisp_createSTTP 'VRN_negative user-defined (155)', STCR, 1, 'negative user-defined (155)', 'negative user-defined (155)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (156), STATE='negative user-defined (156)', DESCRIPTION='negative user-defined (156)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (156)')
    exec asisp_createSTTP 'VRN_negative user-defined (156)', STCR, 1, 'negative user-defined (156)', 'negative user-defined (156)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (157), STATE='negative user-defined (157)', DESCRIPTION='negative user-defined (157)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (157)')
    exec asisp_createSTTP 'VRN_negative user-defined (157)', STCR, 1, 'negative user-defined (157)', 'negative user-defined (157)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (158), STATE='negative user-defined (158)', DESCRIPTION='negative user-defined (158)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (158)')
    exec asisp_createSTTP 'VRN_negative user-defined (158)', STCR, 1, 'negative user-defined (158)', 'negative user-defined (158)', 0, 2
  -- STATE_TYPE(NAME=negative user-defined (159), STATE='negative user-defined (159)', DESCRIPTION='negative user-defined (159)', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_negative user-defined (159)')
    exec asisp_createSTTP 'VRN_negative user-defined (159)', STCR, 1, 'negative user-defined (159)', 'negative user-defined (159)', 0, 2
  -- STATE_TYPE(NAME=positive user-defined (136), STATE='positive user-defined (136)', DESCRIPTION='positive user-defined (136)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (136)')
    exec asisp_createSTTP 'VRN_positive user-defined (136)', STCR, 1, 'positive user-defined (136)', 'positive user-defined (136)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (137), STATE='positive user-defined (137)', DESCRIPTION='positive user-defined (137)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (137)')
    exec asisp_createSTTP 'VRN_positive user-defined (137)', STCR, 1, 'positive user-defined (137)', 'positive user-defined (137)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (138), STATE='positive user-defined (138)', DESCRIPTION='positive user-defined (138)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (138)')
    exec asisp_createSTTP 'VRN_positive user-defined (138)', STCR, 1, 'positive user-defined (138)', 'positive user-defined (138)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (139), STATE='positive user-defined (139)', DESCRIPTION='positive user-defined (139)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (139)')
    exec asisp_createSTTP 'VRN_positive user-defined (139)', STCR, 1, 'positive user-defined (139)', 'positive user-defined (139)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (140), STATE='positive user-defined (140)', DESCRIPTION='positive user-defined (140)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (140)')
    exec asisp_createSTTP 'VRN_positive user-defined (140)', STCR, 1, 'positive user-defined (140)', 'positive user-defined (140)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (141), STATE='positive user-defined (141)', DESCRIPTION='positive user-defined (141)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (141)')
    exec asisp_createSTTP 'VRN_positive user-defined (141)', STCR, 1, 'positive user-defined (141)', 'positive user-defined (141)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (142), STATE='positive user-defined (142)', DESCRIPTION='positive user-defined (142)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (142)')
    exec asisp_createSTTP 'VRN_positive user-defined (142)', STCR, 1, 'positive user-defined (142)', 'positive user-defined (142)', 0, 3
  -- STATE_TYPE(NAME=positive user-defined (143), STATE='positive user-defined (143)', DESCRIPTION='positive user-defined (143)', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_positive user-defined (143)')
    exec asisp_createSTTP 'VRN_positive user-defined (143)', STCR, 1, 'positive user-defined (143)', 'positive user-defined (143)', 0, 3
  -- STATE_TYPE(NAME=satisfactory, STATE='satisfactory', DESCRIPTION='satisfactory', FLAGS=2|1)
  if not exists (select * from StateType_C where name='VRN_satisfactory')
    exec asisp_createSTTP 'VRN_satisfactory', STCR, 1, 'satisfactory', 'satisfactory', 0, 3
  -- STATE_TYPE(NAME=severely degraded, STATE='severely degraded', DESCRIPTION='severely degraded', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_severely degraded')
    exec asisp_createSTTP 'VRN_severely degraded', STCR, 1, 'severely degraded', 'severely degraded', 0, 2
  -- STATE_TYPE(NAME=unknown, STATE='unknown', DESCRIPTION='unknown', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_unknown')
    exec asisp_createSTTP 'VRN_unknown', STCR, 1, 'unknown', 'unknown', 0, 2
  -- STATE_TYPE(NAME=unsatisfactory, STATE='unsatisfactory', DESCRIPTION='unsatisfactory', FLAGS=2)
  if not exists (select * from StateType_C where name='VRN_unsatisfactory')
    exec asisp_createSTTP 'VRN_unsatisfactory', STCR, 1, 'unsatisfactory', 'unsatisfactory', 0, 2
-- END_STATE_TYPES(CID=VRN)

end
go

-- BEGIN_MESSAGE_DESCRIPTIONS(CID=VRN, ID=)
BEGIN
  PRINT 'Defining Message Descriptions for VRN-'
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status degraded, DESCRIPTION='Display Status degraded', STATE=degraded, ALERTSTATE=Red, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status degraded',
  @Description        = 'Display Status degraded',
  @State              = 'degraded',
  @AlertState         = 'Red',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status intermediate, DESCRIPTION='Display Status intermediate', STATE=intermediate, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status intermediate',
  @Description        = 'Display Status intermediate',
  @State              = 'intermediate',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low satisfactory, DESCRIPTION='Display Status low satisfactory', STATE=low satisfactory, ALERTSTATE=Green, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status low satisfactory',
  @Description        = 'Display Status low satisfactory',
  @State              = 'low satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status low unsatisfactory, DESCRIPTION='Display Status low unsatisfactory', STATE=low unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Low, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status low unsatisfactory',
  @Description        = 'Display Status low unsatisfactory',
  @State              = 'low unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Low',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium satisfactory, DESCRIPTION='Display Status medium satisfactory', STATE=medium satisfactory, ALERTSTATE=Green, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status medium satisfactory',
  @Description        = 'Display Status medium satisfactory',
  @State              = 'medium satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status medium unsatisfactory, DESCRIPTION='Display Status medium unsatisfactory', STATE=medium unsatisfactory, ALERTSTATE=Yellow, PRIORITY=Medium, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status medium unsatisfactory',
  @Description        = 'Display Status medium unsatisfactory',
  @State              = 'medium unsatisfactory',
  @AlertState         = 'Yellow',
  @Priority           = 'Medium',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status satisfactory, DESCRIPTION='Display Status satisfactory', STATE=satisfactory, ALERTSTATE=Green, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status satisfactory',
  @Description        = 'Display Status satisfactory',
  @State              = 'satisfactory',
  @AlertState         = 'Green',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status severely degraded, DESCRIPTION='Display Status severely degraded', STATE=severely degraded, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status severely degraded',
  @Description        = 'Display Status severely degraded',
  @State              = 'severely degraded',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unknown, DESCRIPTION='Display Status unknown', STATE=unknown, ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status unknown',
  @Description        = 'Display Status unknown',
  @State              = 'unknown',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status unsatisfactory, DESCRIPTION='Display Status unsatisfactory', STATE=unsatisfactory, ALERTSTATE=Red, PRIORITY=High, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status unsatisfactory',
  @Description        = 'Display Status unsatisfactory',
  @State              = 'unsatisfactory',
  @AlertState         = 'Red',
  @Priority           = 'High',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (152), DESCRIPTION='Display Status negative user-defined (152)', STATE=negative user-defined (152), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (152)',
  @Description        = 'Display Status negative user-defined (152)',
  @State              = 'negative user-defined (152)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (153), DESCRIPTION='Display Status negative user-defined (153)', STATE=negative user-defined (153), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (153)',
  @Description        = 'Display Status negative user-defined (153)',
  @State              = 'negative user-defined (153)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (154), DESCRIPTION='Display Status negative user-defined (154)', STATE=negative user-defined (154), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (154)',
  @Description        = 'Display Status negative user-defined (154)',
  @State              = 'negative user-defined (154)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (155), DESCRIPTION='Display Status negative user-defined (155)', STATE=negative user-defined (155), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (155)',
  @Description        = 'Display Status negative user-defined (155)',
  @State              = 'negative user-defined (155)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (156), DESCRIPTION='Display Status negative user-defined (156)', STATE=negative user-defined (156), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (156)',
  @Description        = 'Display Status negative user-defined (156)',
  @State              = 'negative user-defined (156)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (157), DESCRIPTION='Display Status negative user-defined (157)', STATE=negative user-defined (157), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (157)',
  @Description        = 'Display Status negative user-defined (157)',
  @State              = 'negative user-defined (157)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (158), DESCRIPTION='Display Status negative user-defined (158)', STATE=negative user-defined (158), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (158)',
  @Description        = 'Display Status negative user-defined (158)',
  @State              = 'negative user-defined (158)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status negative user-defined (159), DESCRIPTION='Display Status negative user-defined (159)', STATE=negative user-defined (159), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status negative user-defined (159)',
  @Description        = 'Display Status negative user-defined (159)',
  @State              = 'negative user-defined (159)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (136), DESCRIPTION='Display Status positive user-defined (136)', STATE=positive user-defined (136), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (136)',
  @Description        = 'Display Status positive user-defined (136)',
  @State              = 'positive user-defined (136)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (137), DESCRIPTION='Display Status positive user-defined (137)', STATE=positive user-defined (137), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (137)',
  @Description        = 'Display Status positive user-defined (137)',
  @State              = 'positive user-defined (137)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (138), DESCRIPTION='Display Status positive user-defined (138)', STATE=positive user-defined (138), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (138)',
  @Description        = 'Display Status positive user-defined (138)',
  @State              = 'positive user-defined (138)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (139), DESCRIPTION='Display Status positive user-defined (139)', STATE=positive user-defined (139), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (139)',
  @Description        = 'Display Status positive user-defined (139)',
  @State              = 'positive user-defined (139)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (140), DESCRIPTION='Display Status positive user-defined (140)', STATE=positive user-defined (140), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (140)',
  @Description        = 'Display Status positive user-defined (140)',
  @State              = 'positive user-defined (140)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (141), DESCRIPTION='Display Status positive user-defined (141)', STATE=positive user-defined (141), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (141)',
  @Description        = 'Display Status positive user-defined (141)',
  @State              = 'positive user-defined (141)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (142), DESCRIPTION='Display Status positive user-defined (142)', STATE=positive user-defined (142), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (142)',
  @Description        = 'Display Status positive user-defined (142)',
  @State              = 'positive user-defined (142)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
  -- MESSAGE_DESCRIPTION(MESSAGE=Display Status positive user-defined (143), DESCRIPTION='Display Status positive user-defined (143)', STATE=positive user-defined (143), ALERTSTATE=Yellow, PRIORITY=Ignore, FLAGS=, ID=)
EXEC asisp_defineMessageDescription
  @cid                = 'VRN',
  @MsgID              = 'Display Status positive user-defined (143)',
  @Description        = 'Display Status positive user-defined (143)',
  @State              = 'positive user-defined (143)',
  @AlertState         = 'Yellow',
  @Priority           = 'Ignore',
  @Flags              = 0,
  @id                 = 0
 -- END_MESSAGE_DESCRIPTIONS(CID=VRN)
END
-- END RODM_EVENT_DEFINITIONS(VRN)
